/* game.c generated by valac 0.46.2, the Vala compiler
 * generated from game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

typedef enum  {
	MAIN_LINE_TOP,
	MAIN_LINE_LEFT,
	MAIN_LINE_RIGHT,
	MAIN_LINE_BOTTOM,
	MAIN_LINE_TOPLEFT,
	MAIN_LINE_TOPRIGHT
} MainLine;

#define TYPE_MAIN_LINE (main_line_get_type ())

#define TYPE_GAME_STATE_STRUCT (game_state_struct_get_type ())
typedef struct _GameStateStruct GameStateStruct;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_POSSIBLE_MOVE (possible_move_get_type ())
typedef struct _PossibleMove PossibleMove;

#define TYPE_GAME_STATE_OBJECT (game_state_object_get_type ())
#define GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_STATE_OBJECT, GameStateObject))
#define GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))
#define IS_GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_STATE_OBJECT))
#define IS_GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_STATE_OBJECT))
#define GAME_STATE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))

typedef struct _GameStateObject GameStateObject;
typedef struct _GameStateObjectClass GameStateObjectClass;
typedef struct _GameStateObjectPrivate GameStateObjectPrivate;
enum  {
	GAME_STATE_OBJECT_0_PROPERTY,
	GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY,
	GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY,
	GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY,
	GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY,
	GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY,
	GAME_STATE_OBJECT_NUM_PROPERTIES
};
static GParamSpec* game_state_object_properties[GAME_STATE_OBJECT_NUM_PROPERTIES];

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
enum  {
	GAME_0_PROPERTY,
	GAME_NUMBER_OF_MOVES_PROPERTY,
	GAME_SIZE_PROPERTY,
	GAME_CURRENT_STATE_PROPERTY,
	GAME_ALTERNATIVE_START_PROPERTY,
	GAME_INITIAL_NUMBER_OF_TILES_PROPERTY,
	GAME_IS_COMPLETE_PROPERTY,
	GAME_N_LIGHT_TILES_PROPERTY,
	GAME_N_DARK_TILES_PROPERTY,
	GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_CURRENT_COLOR_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GAME_TURN_ENDED_SIGNAL,
	GAME_COMPLETENESS_UPDATED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GameStateStruct {
	Player current_color;
	Player opponent_color;
	guint8 size;
	guint8 n_current_tiles;
	guint8 n_opponent_tiles;
	guint8 n_tiles;
	gboolean current_player_can_move;
	gboolean is_complete;
	Player* tiles;
	gint tiles_length1;
	gint tiles_length2;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
	guint8 x_saved;
	guint8 y_saved;
	guint8* empty_neighbors;
	gint empty_neighbors_length1;
	gint empty_neighbors_length2;
};

struct _PossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
	guint8 n_tiles_n;
	guint8 n_tiles_ne;
	guint8 n_tiles_e;
	guint8 n_tiles_se;
	guint8 n_tiles_s;
	guint8 n_tiles_so;
	guint8 n_tiles_o;
	guint8 n_tiles_no;
};

struct _GameStateObject {
	GObject parent_instance;
	GameStateObjectPrivate * priv;
};

struct _GameStateObjectClass {
	GObjectClass parent_class;
};

struct _GameStateObjectPrivate {
	GameStateStruct _game_state_struct;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	GListStore* undo_stack;
	guint8 _size;
	GameStateObject* _current_state;
	gboolean _alternative_start;
	guint8 _initial_number_of_tiles;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
	GSList* possible_moves;
};

static gint GameStateObject_private_offset;
static gpointer game_state_object_parent_class = NULL;
static gint Game_private_offset;
static gpointer game_parent_class = NULL;

GType main_line_get_type (void) G_GNUC_CONST;
GType game_state_struct_get_type (void) G_GNUC_CONST;
GType player_get_type (void) G_GNUC_CONST;
GameStateStruct* game_state_struct_dup (const GameStateStruct* self);
void game_state_struct_free (GameStateStruct* self);
void game_state_struct_copy (const GameStateStruct* self,
                             GameStateStruct* dest);
void game_state_struct_destroy (GameStateStruct* self);
gchar* game_state_struct_to_string (GameStateStruct *self);
gchar* player_to_string (Player self);
void game_state_struct_init_copy_and_pass (GameStateStruct *self,
                                           GameStateStruct* game);
Player player_flip_color (Player p);
static Player* _vala_array_dup5 (Player* self,
                          int length);
static guint8* _vala_array_dup6 (guint8* self,
                          int length);
GType possible_move_get_type (void) G_GNUC_CONST;
PossibleMove* possible_move_dup (const PossibleMove* self);
void possible_move_free (PossibleMove* self);
void game_state_struct_init_copy_and_move (GameStateStruct *self,
                                           GameStateStruct* game,
                                           PossibleMove* move);
static Player* _vala_array_dup7 (Player* self,
                          int length);
static inline void game_state_struct_flip_tiles (Player** tiles,
                                   gint* tiles_length1,
                                   gint* tiles_length2,
                                   guint8 x,
                                   guint8 y,
                                   Player color,
                                   gint8 x_step,
                                   gint8 y_step,
                                   guint8 count);
static guint8* _vala_array_dup8 (guint8* self,
                          int length);
static inline void game_state_struct_update_empty_neighbors (GameStateStruct *self,
                                               guint8 x,
                                               guint8 y);
static void game_state_struct_update_who_can_move (GameStateStruct *self);
void game_state_struct_init_from_grid (GameStateStruct *self,
                                       guint8 _size,
                                       Player* _tiles,
                                       gint _tiles_length1,
                                       gint _tiles_length2,
                                       Player color,
                                       guint8* _neighbor_tiles,
                                       gint _neighbor_tiles_length1,
                                       gint _neighbor_tiles_length2);
static Player* _vala_array_dup9 (Player* self,
                          int length);
static inline void game_state_struct_add_tile_of_color (GameStateStruct *self,
                                          Player color);
static inline void game_state_struct_init_empty_neighbors (GameStateStruct *self);
gboolean game_state_struct_is_current_color (GameStateStruct *self,
                                             guint8 x,
                                             guint8 y);
gboolean game_state_struct_is_empty_tile (GameStateStruct *self,
                                          guint8 x,
                                          guint8 y);
static inline gboolean game_state_struct_is_valid_location_signed (GameStateStruct *self,
                                                     gint8 x,
                                                     gint8 y);
static inline gboolean game_state_struct_is_unplayable_basic (GameStateStruct *self,
                                                guint8 x,
                                                guint8 y);
static inline gboolean game_state_struct_can_place (GameStateStruct *self,
                                      guint8 x,
                                      guint8 y,
                                      Player color);
void game_state_struct_get_possible_moves (GameStateStruct *self,
                                           GSList* * moves);
static void _possible_move_free0_ (gpointer var);
static inline void _g_slist_free__possible_move_free0_ (GSList* self);
static inline gboolean game_state_struct_place_tile (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y,
                                       Player color,
                                       PossibleMove* move);
gboolean game_state_struct_test_placing_tile (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y,
                                              PossibleMove* move);
void possible_move_init (PossibleMove *self,
                         guint8 x,
                         guint8 y);
static inline guint8 game_state_struct_can_flip_tiles (GameStateStruct *self,
                                         guint8 x,
                                         guint8 y,
                                         Player color,
                                         gint8 x_step,
                                         gint8 y_step);
guint8 game_state_struct_get_empty_neighbors (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y);
static inline guint8 game_state_struct_is_empty (GameStateStruct *self,
                                   gint8 x,
                                   gint8 y);
Player* game_state_struct_get_mainline (GameStateStruct *self,
                                        MainLine mainline_id,
                                        gint* result_length1);
static Player* _vala_array_dup10 (Player* self,
                           int length);
static guint8* _vala_array_dup11 (guint8* self,
                           int length);
GType game_state_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameStateObject, g_object_unref)
gchar* game_state_object_to_string (GameStateObject* self);
void game_state_object_get_game_state_struct (GameStateObject* self,
                                              GameStateStruct * result);
GameStateObject* game_state_object_new_copy_and_pass (GameStateObject* game);
GameStateObject* game_state_object_construct_copy_and_pass (GType object_type,
                                                            GameStateObject* game);
GameStateObject* game_state_object_new_copy_and_move (GameStateObject* game,
                                                      PossibleMove* move);
GameStateObject* game_state_object_construct_copy_and_move (GType object_type,
                                                            GameStateObject* game,
                                                            PossibleMove* move);
GameStateObject* game_state_object_new_from_grid (guint8 size,
                                                  Player* tiles,
                                                  gint tiles_length1,
                                                  gint tiles_length2,
                                                  Player color,
                                                  guint8* neighbor_tiles,
                                                  gint neighbor_tiles_length1,
                                                  gint neighbor_tiles_length2);
GameStateObject* game_state_object_construct_from_grid (GType object_type,
                                                        guint8 size,
                                                        Player* tiles,
                                                        gint tiles_length1,
                                                        gint tiles_length2,
                                                        Player color,
                                                        guint8* neighbor_tiles,
                                                        gint neighbor_tiles_length1,
                                                        gint neighbor_tiles_length2);
Player game_state_object_get_owner (GameStateObject* self,
                                    guint8 x,
                                    guint8 y);
void game_state_object_get_possible_moves (GameStateObject* self,
                                           GSList* * moves);
gboolean game_state_object_test_placing_tile (GameStateObject* self,
                                              guint8 x,
                                              guint8 y,
                                              PossibleMove* move);
GameStateObject* game_state_object_new (void);
GameStateObject* game_state_object_construct (GType object_type);
Player game_state_object_get_current_color (GameStateObject* self);
guint8 game_state_object_get_n_light_tiles (GameStateObject* self);
guint8 game_state_object_get_n_dark_tiles (GameStateObject* self);
gboolean game_state_object_get_current_player_can_move (GameStateObject* self);
gboolean game_state_object_get_is_complete (GameStateObject* self);
static void game_state_object_finalize (GObject * obj);
static void _vala_game_state_object_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
Game* game_new (gboolean _alternative_start,
                guint8 _size);
Game* game_construct (GType object_type,
                      gboolean _alternative_start,
                      guint8 _size);
static void game_init_neighbor_tiles (guint8 size,
                               guint8** neighbor_tiles,
                               gint* neighbor_tiles_length1,
                               gint* neighbor_tiles_length2);
Game* game_new_from_strings (gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size);
Game* game_construct_from_strings (GType object_type,
                                   gchar** setup,
                                   gint setup_length1,
                                   Player to_move,
                                   guint8 _size);
Player player_from_char (gchar c);
gchar* game_to_string (Game* self);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
GameStateObject* game_get_current_state (Game* self);
gboolean game_place_tile (Game* self,
                          guint8 x,
                          guint8 y);
void game_set_current_state (Game* self,
                             GameStateObject* value);
static void game_end_of_turn (Game* self,
                       gboolean undoing,
                       gboolean no_draw);
gboolean game_pass (Game* self);
gboolean game_get_current_player_can_move (Game* self);
static inline void game_update_possible_moves (Game* self);
void game_undo (Game* self,
                guint8 count);
guint8 game_get_number_of_moves (Game* self);
guint8* game_copy_neighbor_tiles (Game* self,
                                  gint* result_length1,
                                  gint* result_length2);
static guint8* _vala_array_dup12 (guint8* self,
                           int length);
gboolean game_test_placing_tile (Game* self,
                                 guint8 x,
                                 guint8 y,
                                 PossibleMove* move);
void game_get_possible_moves (Game* self,
                              GSList* * moves);
static PossibleMove* __lambda15_ (Game* self,
                           PossibleMove* a);
static gpointer ___lambda15__gcopy_func (gconstpointer src,
                                  gpointer self);
guint8 game_get_size (Game* self);
static void game_set_size (Game* self,
                    guint8 value);
gboolean game_get_alternative_start (Game* self);
static void game_set_alternative_start (Game* self,
                                 gboolean value);
guint8 game_get_initial_number_of_tiles (Game* self);
static void game_set_initial_number_of_tiles (Game* self,
                                       guint8 value);
gboolean game_get_is_complete (Game* self);
guint8 game_get_n_light_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
Player game_get_current_color (Game* self);
static void g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static GObject * game_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);

GType
main_line_get_type (void)
{
	static volatile gsize main_line_type_id__volatile = 0;
	if (g_once_init_enter (&main_line_type_id__volatile)) {
		static const GEnumValue values[] = {{MAIN_LINE_TOP, "MAIN_LINE_TOP", "top"}, {MAIN_LINE_LEFT, "MAIN_LINE_LEFT", "left"}, {MAIN_LINE_RIGHT, "MAIN_LINE_RIGHT", "right"}, {MAIN_LINE_BOTTOM, "MAIN_LINE_BOTTOM", "bottom"}, {MAIN_LINE_TOPLEFT, "MAIN_LINE_TOPLEFT", "topleft"}, {MAIN_LINE_TOPRIGHT, "MAIN_LINE_TOPRIGHT", "topright"}, {0, NULL, NULL}};
		GType main_line_type_id;
		main_line_type_id = g_enum_register_static ("MainLine", values);
		g_once_init_leave (&main_line_type_id__volatile, main_line_type_id);
	}
	return main_line_type_id__volatile;
}

gchar*
game_state_struct_to_string (GameStateStruct *self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_strdup ("\n");
	s = _tmp0_;
	{
		guint8 y = 0U;
		y = (guint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				const gchar* _tmp13_;
				gchar* _tmp14_;
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = y;
					y = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(y < (*self).size)) {
					break;
				}
				{
					guint8 x = 0U;
					x = (guint8) 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							const gchar* _tmp5_;
							Player* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							Player _tmp7_;
							gchar* _tmp8_;
							gchar* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
							if (!_tmp3_) {
								guint8 _tmp4_;
								_tmp4_ = x;
								x = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							if (!(x < (*self).size)) {
								break;
							}
							_tmp5_ = s;
							_tmp6_ = (*self).tiles;
							_tmp6__length1 = (*self).tiles_length1;
							_tmp6__length2 = (*self).tiles_length2;
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
							_tmp8_ = player_to_string (_tmp7_);
							_tmp9_ = _tmp8_;
							_tmp10_ = g_strconcat (" ", _tmp9_, NULL);
							_tmp11_ = _tmp10_;
							_tmp12_ = g_strconcat (_tmp5_, _tmp11_, NULL);
							_g_free0 (s);
							s = _tmp12_;
							_g_free0 (_tmp11_);
							_g_free0 (_tmp9_);
						}
					}
				}
				_tmp13_ = s;
				_tmp14_ = g_strconcat (_tmp13_, "\n", NULL);
				_g_free0 (s);
				s = _tmp14_;
			}
		}
	}
	result = s;
	return result;
}

static Player*
_vala_array_dup5 (Player* self,
                  int length)
{
	return g_memdup (self, length * sizeof (Player));
}

static guint8*
_vala_array_dup6 (guint8* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guint8));
}

void
game_state_struct_init_copy_and_pass (GameStateStruct *self,
                                      GameStateStruct* game)
{
	GameStateStruct _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp3_;
	GameStateStruct _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	GameStateStruct _tmp6_;
	Player* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	GameStateStruct _tmp9_;
	GameStateStruct _tmp10_;
	GameStateStruct _tmp11_;
	guint8* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	g_return_if_fail (game != NULL);
	memset (self, 0, sizeof (GameStateStruct));
	_tmp0_ = *game;
	_tmp1_ = _tmp0_.current_color;
	(*self).opponent_color = _tmp1_;
	_tmp2_ = (*self).opponent_color;
	(*self).current_color = player_flip_color (_tmp2_);
	_tmp3_ = *game;
	(*self).size = _tmp3_.size;
	_tmp4_ = *game;
	_tmp5_ = _tmp4_.neighbor_tiles;
	_tmp5__length1 = _tmp4_.neighbor_tiles_length1;
	_tmp5__length2 = _tmp4_.neighbor_tiles_length2;
	(*self).neighbor_tiles = _tmp5_;
	(*self).neighbor_tiles_length1 = _tmp5__length1;
	(*self).neighbor_tiles_length2 = _tmp5__length2;
	_tmp6_ = *game;
	_tmp7_ = _tmp6_.tiles;
	_tmp7__length1 = _tmp6_.tiles_length1;
	_tmp7__length2 = _tmp6_.tiles_length2;
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup5 (_tmp7_, _tmp7__length1 * _tmp7__length2) : ((gpointer) _tmp7_);
	_tmp8__length1 = _tmp7__length1;
	_tmp8__length2 = _tmp7__length2;
	(*self).tiles = (g_free ((*self).tiles), NULL);
	(*self).tiles = _tmp8_;
	(*self).tiles_length1 = _tmp8__length1;
	(*self).tiles_length2 = _tmp8__length2;
	_tmp9_ = *game;
	(*self).n_current_tiles = _tmp9_.n_opponent_tiles;
	_tmp10_ = *game;
	(*self).n_opponent_tiles = _tmp10_.n_current_tiles;
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
	_tmp11_ = *game;
	_tmp12_ = _tmp11_.empty_neighbors;
	_tmp12__length1 = _tmp11_.empty_neighbors_length1;
	_tmp12__length2 = _tmp11_.empty_neighbors_length2;
	_tmp13_ = (_tmp12_ != NULL) ? _vala_array_dup6 (_tmp12_, _tmp12__length1 * _tmp12__length2) : ((gpointer) _tmp12_);
	_tmp13__length1 = _tmp12__length1;
	_tmp13__length2 = _tmp12__length2;
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
	(*self).empty_neighbors = _tmp13_;
	(*self).empty_neighbors_length1 = _tmp13__length1;
	(*self).empty_neighbors_length2 = _tmp13__length2;
	(*self).current_player_can_move = TRUE;
	(*self).is_complete = FALSE;
	(*self).x_saved = (guint8) 0;
	(*self).y_saved = (guint8) 0;
}

static Player*
_vala_array_dup7 (Player* self,
                  int length)
{
	return g_memdup (self, length * sizeof (Player));
}

static guint8*
_vala_array_dup8 (guint8* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guint8));
}

void
game_state_struct_init_copy_and_move (GameStateStruct *self,
                                      GameStateStruct* game,
                                      PossibleMove* move)
{
	GameStateStruct _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp3_;
	GameStateStruct _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	GameStateStruct _tmp6_;
	Player* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	PossibleMove _tmp9_;
	PossibleMove _tmp10_;
	Player _tmp11_;
	PossibleMove _tmp12_;
	PossibleMove _tmp13_;
	PossibleMove _tmp14_;
	Player _tmp15_;
	PossibleMove _tmp16_;
	PossibleMove _tmp17_;
	PossibleMove _tmp18_;
	Player _tmp19_;
	PossibleMove _tmp20_;
	PossibleMove _tmp21_;
	PossibleMove _tmp22_;
	Player _tmp23_;
	PossibleMove _tmp24_;
	PossibleMove _tmp25_;
	PossibleMove _tmp26_;
	Player _tmp27_;
	PossibleMove _tmp28_;
	PossibleMove _tmp29_;
	PossibleMove _tmp30_;
	Player _tmp31_;
	PossibleMove _tmp32_;
	PossibleMove _tmp33_;
	PossibleMove _tmp34_;
	Player _tmp35_;
	PossibleMove _tmp36_;
	PossibleMove _tmp37_;
	PossibleMove _tmp38_;
	Player _tmp39_;
	PossibleMove _tmp40_;
	PossibleMove _tmp41_;
	PossibleMove _tmp42_;
	Player _tmp43_;
	GameStateStruct _tmp44_;
	PossibleMove _tmp45_;
	GameStateStruct _tmp46_;
	PossibleMove _tmp47_;
	GameStateStruct _tmp48_;
	guint8* _tmp49_;
	gint _tmp49__length1;
	gint _tmp49__length2;
	guint8* _tmp50_;
	gint _tmp50__length1;
	gint _tmp50__length2;
	PossibleMove _tmp51_;
	PossibleMove _tmp52_;
	g_return_if_fail (game != NULL);
	g_return_if_fail (move != NULL);
	memset (self, 0, sizeof (GameStateStruct));
	_tmp0_ = *game;
	_tmp1_ = _tmp0_.current_color;
	(*self).opponent_color = _tmp1_;
	_tmp2_ = (*self).opponent_color;
	(*self).current_color = player_flip_color (_tmp2_);
	_tmp3_ = *game;
	(*self).size = _tmp3_.size;
	_tmp4_ = *game;
	_tmp5_ = _tmp4_.neighbor_tiles;
	_tmp5__length1 = _tmp4_.neighbor_tiles_length1;
	_tmp5__length2 = _tmp4_.neighbor_tiles_length2;
	(*self).neighbor_tiles = _tmp5_;
	(*self).neighbor_tiles_length1 = _tmp5__length1;
	(*self).neighbor_tiles_length2 = _tmp5__length2;
	_tmp6_ = *game;
	_tmp7_ = _tmp6_.tiles;
	_tmp7__length1 = _tmp6_.tiles_length1;
	_tmp7__length2 = _tmp6_.tiles_length2;
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup7 (_tmp7_, _tmp7__length1 * _tmp7__length2) : ((gpointer) _tmp7_);
	_tmp8__length1 = _tmp7__length1;
	_tmp8__length2 = _tmp7__length2;
	(*self).tiles = (g_free ((*self).tiles), NULL);
	(*self).tiles = _tmp8_;
	(*self).tiles_length1 = _tmp8__length1;
	(*self).tiles_length2 = _tmp8__length2;
	_tmp9_ = *move;
	_tmp10_ = *move;
	_tmp11_ = (*self).opponent_color;
	_tmp12_ = *move;
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp9_.x, _tmp10_.y, _tmp11_, (gint8) 0, (gint8) -1, _tmp12_.n_tiles_n);
	_tmp13_ = *move;
	_tmp14_ = *move;
	_tmp15_ = (*self).opponent_color;
	_tmp16_ = *move;
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp13_.x, _tmp14_.y, _tmp15_, (gint8) 1, (gint8) -1, _tmp16_.n_tiles_ne);
	_tmp17_ = *move;
	_tmp18_ = *move;
	_tmp19_ = (*self).opponent_color;
	_tmp20_ = *move;
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp17_.x, _tmp18_.y, _tmp19_, (gint8) 1, (gint8) 0, _tmp20_.n_tiles_e);
	_tmp21_ = *move;
	_tmp22_ = *move;
	_tmp23_ = (*self).opponent_color;
	_tmp24_ = *move;
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp21_.x, _tmp22_.y, _tmp23_, (gint8) 1, (gint8) 1, _tmp24_.n_tiles_se);
	_tmp25_ = *move;
	_tmp26_ = *move;
	_tmp27_ = (*self).opponent_color;
	_tmp28_ = *move;
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp25_.x, _tmp26_.y, _tmp27_, (gint8) 0, (gint8) 1, _tmp28_.n_tiles_s);
	_tmp29_ = *move;
	_tmp30_ = *move;
	_tmp31_ = (*self).opponent_color;
	_tmp32_ = *move;
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp29_.x, _tmp30_.y, _tmp31_, (gint8) -1, (gint8) 1, _tmp32_.n_tiles_so);
	_tmp33_ = *move;
	_tmp34_ = *move;
	_tmp35_ = (*self).opponent_color;
	_tmp36_ = *move;
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp33_.x, _tmp34_.y, _tmp35_, (gint8) -1, (gint8) 0, _tmp36_.n_tiles_o);
	_tmp37_ = *move;
	_tmp38_ = *move;
	_tmp39_ = (*self).opponent_color;
	_tmp40_ = *move;
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp37_.x, _tmp38_.y, _tmp39_, (gint8) -1, (gint8) -1, _tmp40_.n_tiles_no);
	_tmp41_ = *move;
	_tmp42_ = *move;
	_tmp43_ = (*self).opponent_color;
	(*self).tiles[(_tmp41_.x * (*self).tiles_length2) + _tmp42_.y] = _tmp43_;
	_tmp44_ = *game;
	_tmp45_ = *move;
	(*self).n_current_tiles = _tmp44_.n_opponent_tiles - _tmp45_.n_tiles;
	_tmp46_ = *game;
	_tmp47_ = *move;
	(*self).n_opponent_tiles = (guint8) ((_tmp46_.n_current_tiles + _tmp47_.n_tiles) + 1);
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
	_tmp48_ = *game;
	_tmp49_ = _tmp48_.empty_neighbors;
	_tmp49__length1 = _tmp48_.empty_neighbors_length1;
	_tmp49__length2 = _tmp48_.empty_neighbors_length2;
	_tmp50_ = (_tmp49_ != NULL) ? _vala_array_dup8 (_tmp49_, _tmp49__length1 * _tmp49__length2) : ((gpointer) _tmp49_);
	_tmp50__length1 = _tmp49__length1;
	_tmp50__length2 = _tmp49__length2;
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
	(*self).empty_neighbors = _tmp50_;
	(*self).empty_neighbors_length1 = _tmp50__length1;
	(*self).empty_neighbors_length2 = _tmp50__length2;
	_tmp51_ = *move;
	_tmp52_ = *move;
	game_state_struct_update_empty_neighbors (&(*self), _tmp51_.x, _tmp52_.y);
	game_state_struct_update_who_can_move (&(*self));
}

static inline void
game_state_struct_flip_tiles (Player** tiles,
                              gint* tiles_length1,
                              gint* tiles_length2,
                              guint8 x,
                              guint8 y,
                              Player color,
                              gint8 x_step,
                              gint8 y_step,
                              guint8 count)
{
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			if (!_tmp0_) {
				guint8 _tmp1_;
				_tmp1_ = count;
				count = _tmp1_ - 1;
			}
			_tmp0_ = FALSE;
			if (!(((gint) count) > 0)) {
				break;
			}
			(*tiles)[((((gint8) x) + (((gint8) count) * x_step)) * (*tiles_length2)) + (((gint8) y) + (((gint8) count) * y_step))] = color;
		}
	}
}

static Player*
_vala_array_dup9 (Player* self,
                  int length)
{
	return g_memdup (self, length * sizeof (Player));
}

void
game_state_struct_init_from_grid (GameStateStruct *self,
                                  guint8 _size,
                                  Player* _tiles,
                                  gint _tiles_length1,
                                  gint _tiles_length2,
                                  Player color,
                                  guint8* _neighbor_tiles,
                                  gint _neighbor_tiles_length1,
                                  gint _neighbor_tiles_length2)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	memset (self, 0, sizeof (GameStateStruct));
	(*self).current_color = color;
	(*self).opponent_color = player_flip_color (color);
	(*self).size = _size;
	(*self).neighbor_tiles = _neighbor_tiles;
	(*self).neighbor_tiles_length1 = _neighbor_tiles_length1;
	(*self).neighbor_tiles_length2 = _neighbor_tiles_length2;
	_tmp0_ = (_tiles != NULL) ? _vala_array_dup9 (_tiles, _tiles_length1 * _tiles_length2) : ((gpointer) _tiles);
	_tmp0__length1 = _tiles_length1;
	_tmp0__length2 = _tiles_length2;
	(*self).tiles = (g_free ((*self).tiles), NULL);
	(*self).tiles = _tmp0_;
	(*self).tiles_length1 = _tmp0__length1;
	(*self).tiles_length2 = _tmp0__length2;
	(*self).n_current_tiles = (guint8) 0;
	(*self).n_opponent_tiles = (guint8) 0;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(x < _size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							Player _tmp5_;
							if (!_tmp3_) {
								guint8 _tmp4_;
								_tmp4_ = y;
								y = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							if (!(y < _size)) {
								break;
							}
							_tmp5_ = _tiles[(x * _tiles_length2) + y];
							game_state_struct_add_tile_of_color (&(*self), _tmp5_);
						}
					}
				}
			}
		}
	}
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
	game_state_struct_init_empty_neighbors (&(*self));
	game_state_struct_update_who_can_move (&(*self));
}

static inline void
game_state_struct_add_tile_of_color (GameStateStruct *self,
                                     Player color)
{
	Player _tmp0_;
	_tmp0_ = (*self).current_color;
	if (color == _tmp0_) {
		guint8 _tmp1_;
		_tmp1_ = (*self).n_current_tiles;
		(*self).n_current_tiles = _tmp1_ + 1;
	} else {
		if (color != PLAYER_NONE) {
			guint8 _tmp2_;
			_tmp2_ = (*self).n_opponent_tiles;
			(*self).n_opponent_tiles = _tmp2_ + 1;
		}
	}
}

inline gboolean
game_state_struct_is_current_color (GameStateStruct *self,
                                    guint8 x,
                                    guint8 y)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	Player _tmp2_;
	gboolean result = FALSE;
	_tmp0_ = (*self).tiles;
	_tmp0__length1 = (*self).tiles_length1;
	_tmp0__length2 = (*self).tiles_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = (*self).current_color;
	result = _tmp1_ == _tmp2_;
	return result;
}

inline gboolean
game_state_struct_is_empty_tile (GameStateStruct *self,
                                 guint8 x,
                                 guint8 y)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	gboolean result = FALSE;
	_tmp0_ = (*self).tiles;
	_tmp0__length1 = (*self).tiles_length1;
	_tmp0__length2 = (*self).tiles_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	result = _tmp1_ == PLAYER_NONE;
	return result;
}

static inline gboolean
game_state_struct_is_valid_location_signed (GameStateStruct *self,
                                            gint8 x,
                                            gint8 y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
	if (((gint) x) >= 0) {
		_tmp2_ = ((guint8) x) < (*self).size;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = ((gint) y) >= 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = ((guint8) y) < (*self).size;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static void
game_state_struct_update_who_can_move (GameStateStruct *self)
{
	Player enemy = 0;
	Player _tmp0_;
	gboolean opponent_can_move = FALSE;
	_tmp0_ = (*self).current_color;
	enemy = player_flip_color (_tmp0_);
	opponent_can_move = FALSE;
	{
		gboolean _tmp1_ = FALSE;
		(*self).x_saved = (guint8) 0;
		_tmp1_ = TRUE;
		while (TRUE) {
			if (!_tmp1_) {
				guint8 _tmp2_;
				_tmp2_ = (*self).x_saved;
				(*self).x_saved = _tmp2_ + 1;
			}
			_tmp1_ = FALSE;
			if (!((*self).x_saved < (*self).size)) {
				break;
			}
			{
				gboolean _tmp3_ = FALSE;
				(*self).y_saved = (guint8) 0;
				_tmp3_ = TRUE;
				while (TRUE) {
					Player _tmp5_;
					Player _tmp6_;
					if (!_tmp3_) {
						guint8 _tmp4_;
						_tmp4_ = (*self).y_saved;
						(*self).y_saved = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					if (!((*self).y_saved < (*self).size)) {
						break;
					}
					if (game_state_struct_is_unplayable_basic (&(*self), (*self).x_saved, (*self).y_saved)) {
						continue;
					}
					_tmp5_ = (*self).current_color;
					if (game_state_struct_can_place (&(*self), (*self).x_saved, (*self).y_saved, _tmp5_)) {
						(*self).current_player_can_move = TRUE;
						(*self).is_complete = FALSE;
						return;
					}
					if (opponent_can_move) {
						continue;
					}
					_tmp6_ = enemy;
					if (game_state_struct_can_place (&(*self), (*self).x_saved, (*self).y_saved, _tmp6_)) {
						opponent_can_move = TRUE;
						(*self).is_complete = FALSE;
					}
				}
			}
		}
	}
	(*self).current_player_can_move = FALSE;
	if (!opponent_can_move) {
		(*self).is_complete = TRUE;
	}
}

static void
_possible_move_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (possible_move_free (var), NULL));
}

static inline void
_g_slist_free__possible_move_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _possible_move_free0_);
}

static gpointer
_possible_move_dup0 (gpointer self)
{
	return self ? possible_move_dup (self) : NULL;
}

void
game_state_struct_get_possible_moves (GameStateStruct *self,
                                      GSList* * moves)
{
	GSList* _vala_moves = NULL;
	guint8 x = 0U;
	guint8 y = 0U;
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
	_vala_moves = NULL;
	x = (*self).x_saved;
	y = (*self).y_saved;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			if (!_tmp0_) {
				guint8 _tmp1_;
				_tmp1_ = x;
				x = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			if (!(x < (*self).size)) {
				break;
			}
			{
				gboolean _tmp2_ = FALSE;
				_tmp2_ = TRUE;
				while (TRUE) {
					PossibleMove move = {0};
					Player _tmp4_;
					PossibleMove _tmp5_ = {0};
					gboolean _tmp6_;
					if (!_tmp2_) {
						guint8 _tmp3_;
						_tmp3_ = y;
						y = _tmp3_ + 1;
					}
					_tmp2_ = FALSE;
					if (!(y < (*self).size)) {
						break;
					}
					_tmp4_ = (*self).current_color;
					_tmp6_ = game_state_struct_place_tile (&(*self), x, y, _tmp4_, &_tmp5_);
					move = _tmp5_;
					if (_tmp6_) {
						PossibleMove _tmp7_;
						PossibleMove* _tmp8_;
						_tmp7_ = move;
						_tmp8_ = _possible_move_dup0 (&_tmp7_);
						_vala_moves = g_slist_prepend (_vala_moves, _tmp8_);
					}
				}
			}
			y = (guint8) 0;
		}
	}
	if (moves) {
		*moves = _vala_moves;
	} else {
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
	}
}

inline gboolean
game_state_struct_test_placing_tile (GameStateStruct *self,
                                     guint8 x,
                                     guint8 y,
                                     PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	Player _tmp0_;
	PossibleMove _tmp1_ = {0};
	gboolean _tmp2_;
	gboolean result = FALSE;
	_tmp0_ = (*self).current_color;
	_tmp2_ = game_state_struct_place_tile (&(*self), x, y, _tmp0_, &_tmp1_);
	_vala_move = _tmp1_;
	result = _tmp2_;
	if (move) {
		*move = _vala_move;
	}
	return result;
}

static inline gboolean
game_state_struct_is_unplayable_basic (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8 _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	guint8 _tmp3_;
	Player* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	Player _tmp5_;
	gboolean result = FALSE;
	_tmp0_ = (*self).empty_neighbors;
	_tmp0__length1 = (*self).empty_neighbors_length1;
	_tmp0__length2 = (*self).empty_neighbors_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = (*self).neighbor_tiles;
	_tmp2__length1 = (*self).neighbor_tiles_length1;
	_tmp2__length2 = (*self).neighbor_tiles_length2;
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
	if (_tmp1_ == _tmp3_) {
		result = TRUE;
		return result;
	}
	_tmp4_ = (*self).tiles;
	_tmp4__length1 = (*self).tiles_length1;
	_tmp4__length2 = (*self).tiles_length2;
	_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
	if (_tmp5_ != PLAYER_NONE) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static inline gboolean
game_state_struct_place_tile (GameStateStruct *self,
                              guint8 x,
                              guint8 y,
                              Player color,
                              PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	PossibleMove _tmp0_;
	PossibleMove _tmp1_;
	PossibleMove _tmp2_;
	PossibleMove _tmp3_;
	PossibleMove _tmp4_;
	PossibleMove _tmp5_;
	PossibleMove _tmp6_;
	PossibleMove _tmp7_;
	PossibleMove _tmp8_;
	gboolean result = FALSE;
	possible_move_init (&_vala_move, x, y);
	if (game_state_struct_is_unplayable_basic (&(*self), x, y)) {
		result = FALSE;
		if (move) {
			*move = _vala_move;
		}
		return result;
	}
	_vala_move.n_tiles_n = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) -1);
	_vala_move.n_tiles_ne = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) -1);
	_vala_move.n_tiles_e = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 0);
	_vala_move.n_tiles_se = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 1);
	_vala_move.n_tiles_s = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) 1);
	_vala_move.n_tiles_so = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 1);
	_vala_move.n_tiles_o = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 0);
	_vala_move.n_tiles_no = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) -1);
	_tmp0_ = _vala_move;
	_tmp1_ = _vala_move;
	_tmp2_ = _vala_move;
	_tmp3_ = _vala_move;
	_tmp4_ = _vala_move;
	_tmp5_ = _vala_move;
	_tmp6_ = _vala_move;
	_tmp7_ = _vala_move;
	_vala_move.n_tiles = ((((((_tmp0_.n_tiles_n + _tmp1_.n_tiles_ne) + _tmp2_.n_tiles_e) + _tmp3_.n_tiles_se) + _tmp4_.n_tiles_s) + _tmp5_.n_tiles_so) + _tmp6_.n_tiles_o) + _tmp7_.n_tiles_no;
	_tmp8_ = _vala_move;
	result = ((gint) _tmp8_.n_tiles) != 0;
	if (move) {
		*move = _vala_move;
	}
	return result;
}

/**
     * can_place:
     * @x: the x coordinate of the tile to test
     * @y: the y coordinate of the tile to test
     * @color: the player color to test
     *
     * You should test is_unplayable_basic() before launching this.
     *
     * This method is faster than place_tile(), as it returns early
     * when some turnable tiles are found in one of the directions.
     *
     * Returns: %true if the given @color can be play there
     */
static inline gboolean
game_state_struct_can_place (GameStateStruct *self,
                             guint8 x,
                             guint8 y,
                             Player color)
{
	gboolean result = FALSE;
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) -1)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 1)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 1)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) -1)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 0)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 0)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) 1)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) -1)) > 0) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

/**
     * can_flip_tiles:
     * @x: the x coordinate to start with
     * @y: the y coordinate to start with
     * @color: the player color to test
     * @x_step: the step on the x direction, %1, %0 or %-1
     * @y_step: the step on the y direction, %1, %0 or %-1
     *
     * Returns: the number of turnable tiles in the given direction
     */
static inline guint8
game_state_struct_can_flip_tiles (GameStateStruct *self,
                                  guint8 x,
                                  guint8 y,
                                  Player color,
                                  gint8 x_step,
                                  gint8 y_step)
{
	Player enemy = 0;
	gint8 enemy_count = 0;
	gboolean is_valid_location = FALSE;
	gint8 xt = 0;
	gint8 yt = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	guint8 result = 0U;
	enemy = player_flip_color (color);
	enemy_count = (gint8) -1;
	is_valid_location = FALSE;
	xt = (gint8) x;
	yt = (gint8) y;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gint8 _tmp5_;
			if (!_tmp0_) {
				gboolean _tmp1_ = FALSE;
				if (is_valid_location) {
					Player* _tmp2_;
					gint _tmp2__length1;
					gint _tmp2__length2;
					Player _tmp3_;
					Player _tmp4_;
					_tmp2_ = (*self).tiles;
					_tmp2__length1 = (*self).tiles_length1;
					_tmp2__length2 = (*self).tiles_length2;
					_tmp3_ = _tmp2_[(xt * _tmp2__length2) + yt];
					_tmp4_ = enemy;
					_tmp1_ = _tmp3_ == _tmp4_;
				} else {
					_tmp1_ = FALSE;
				}
				if (!_tmp1_) {
					break;
				}
			}
			_tmp0_ = FALSE;
			_tmp5_ = enemy_count;
			enemy_count = _tmp5_ + 1;
			xt += x_step;
			yt += y_step;
			is_valid_location = game_state_struct_is_valid_location_signed (&(*self), xt, yt);
		}
	}
	if (((gint) enemy_count) <= 0) {
		_tmp7_ = TRUE;
	} else {
		_tmp7_ = !is_valid_location;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player _tmp9_;
		_tmp8_ = (*self).tiles;
		_tmp8__length1 = (*self).tiles_length1;
		_tmp8__length2 = (*self).tiles_length2;
		_tmp9_ = _tmp8_[(xt * _tmp8__length2) + yt];
		_tmp6_ = _tmp9_ != color;
	}
	if (_tmp6_) {
		result = (guint8) 0;
		return result;
	}
	result = (guint8) enemy_count;
	return result;
}

guint8
game_state_struct_get_empty_neighbors (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8 _tmp1_;
	guint8 result = 0U;
	_tmp0_ = (*self).empty_neighbors;
	_tmp0__length1 = (*self).empty_neighbors_length1;
	_tmp0__length2 = (*self).empty_neighbors_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	result = _tmp1_;
	return result;
}

static inline void
game_state_struct_init_empty_neighbors (GameStateStruct *self)
{
	guint8* _tmp0_;
	gint8 _size = 0;
	gint8 xmm = 0;
	gint8 ymm = 0;
	gint8 xpp = 0;
	gint8 ypp = 0;
	gboolean xmm_is_valid = FALSE;
	gboolean xpp_is_valid = FALSE;
	_tmp0_ = g_new0 (guint8, (*self).size * (*self).size);
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
	(*self).empty_neighbors = _tmp0_;
	(*self).empty_neighbors_length1 = (*self).size;
	(*self).empty_neighbors_length2 = (*self).size;
	_size = (gint8) (*self).size;
	{
		gint8 x = 0;
		x = (gint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					gint8 _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(x < _size)) {
					break;
				}
				xmm = (gint8) (x - 1);
				xpp = (gint8) (x + 1);
				xmm_is_valid = ((gint) xmm) >= 0;
				xpp_is_valid = ((guint8) xpp) < (*self).size;
				{
					gint8 y = 0;
					y = (gint8) 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							guint8 empty_neighbors_x_y = 0U;
							if (!_tmp3_) {
								gint8 _tmp4_;
								_tmp4_ = y;
								y = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							if (!(y < _size)) {
								break;
							}
							ymm = (gint8) (y - 1);
							ypp = (gint8) (y + 1);
							empty_neighbors_x_y = game_state_struct_is_empty (&(*self), x, ymm) + game_state_struct_is_empty (&(*self), x, ypp);
							if (xmm_is_valid) {
								empty_neighbors_x_y += (game_state_struct_is_empty (&(*self), xmm, y) + game_state_struct_is_empty (&(*self), xmm, ymm)) + game_state_struct_is_empty (&(*self), xmm, ypp);
							}
							if (xpp_is_valid) {
								empty_neighbors_x_y += (game_state_struct_is_empty (&(*self), xpp, y) + game_state_struct_is_empty (&(*self), xpp, ymm)) + game_state_struct_is_empty (&(*self), xpp, ypp);
							}
							(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + y] = empty_neighbors_x_y;
						}
					}
				}
			}
		}
	}
}

static inline guint8
game_state_struct_is_empty (GameStateStruct *self,
                            gint8 x,
                            gint8 y)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	guint8 result = 0U;
	if (!game_state_struct_is_valid_location_signed (&(*self), x, y)) {
		result = (guint8) 0;
		return result;
	}
	_tmp0_ = (*self).tiles;
	_tmp0__length1 = (*self).tiles_length1;
	_tmp0__length2 = (*self).tiles_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	if (_tmp1_ != PLAYER_NONE) {
		result = (guint8) 0;
		return result;
	}
	result = (guint8) 1;
	return result;
}

static inline void
game_state_struct_update_empty_neighbors (GameStateStruct *self,
                                          guint8 x,
                                          guint8 y)
{
	gint8 xmm = 0;
	gint8 ymm = 0;
	gint8 xpp = 0;
	gint8 ypp = 0;
	gboolean ymm_is_valid = FALSE;
	gboolean ypp_is_valid = FALSE;
	xmm = (gint8) (((gint8) x) - 1);
	ymm = (gint8) (((gint8) y) - 1);
	xpp = (gint8) (xmm + 2);
	ypp = (gint8) (ymm + 2);
	ymm_is_valid = ((gint) ymm) >= 0;
	ypp_is_valid = ((guint8) ypp) < (*self).size;
	if (((gint) xmm) >= 0) {
		(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + y] -= (guint8) 1;
		if (ymm_is_valid) {
			(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
		}
		if (ypp_is_valid) {
			(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
		}
	}
	if (ymm_is_valid) {
		(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
	}
	if (ypp_is_valid) {
		(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
	}
	if (((guint8) xpp) < (*self).size) {
		(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + y] -= (guint8) 1;
		if (ymm_is_valid) {
			(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
		}
		if (ypp_is_valid) {
			(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
		}
	}
}

Player*
game_state_struct_get_mainline (GameStateStruct *self,
                                MainLine mainline_id,
                                gint* result_length1)
{
	Player* mainline = NULL;
	Player* _tmp0_;
	gint mainline_length1;
	gint _mainline_size_;
	Player* _tmp31_;
	gint _tmp31__length1;
	Player* result = NULL;
	_tmp0_ = g_new0 (Player, (*self).size);
	mainline = _tmp0_;
	mainline_length1 = (*self).size;
	_mainline_size_ = mainline_length1;
	switch (mainline_id) {
		case MAIN_LINE_TOP:
		{
			{
				guint8 i = 0U;
				i = (guint8) 0;
				{
					gboolean _tmp1_ = FALSE;
					_tmp1_ = TRUE;
					while (TRUE) {
						Player* _tmp3_;
						gint _tmp3__length1;
						Player* _tmp4_;
						gint _tmp4__length1;
						gint _tmp4__length2;
						Player _tmp5_;
						if (!_tmp1_) {
							guint8 _tmp2_;
							_tmp2_ = i;
							i = _tmp2_ + 1;
						}
						_tmp1_ = FALSE;
						if (!(i < (*self).size)) {
							break;
						}
						_tmp3_ = mainline;
						_tmp3__length1 = mainline_length1;
						_tmp4_ = (*self).tiles;
						_tmp4__length1 = (*self).tiles_length1;
						_tmp4__length2 = (*self).tiles_length2;
						_tmp5_ = _tmp4_[(i * _tmp4__length2) + 0];
						_tmp3_[i] = _tmp5_;
					}
				}
			}
			break;
		}
		case MAIN_LINE_LEFT:
		{
			{
				guint8 i = 0U;
				i = (guint8) 0;
				{
					gboolean _tmp6_ = FALSE;
					_tmp6_ = TRUE;
					while (TRUE) {
						Player* _tmp8_;
						gint _tmp8__length1;
						Player* _tmp9_;
						gint _tmp9__length1;
						gint _tmp9__length2;
						Player _tmp10_;
						if (!_tmp6_) {
							guint8 _tmp7_;
							_tmp7_ = i;
							i = _tmp7_ + 1;
						}
						_tmp6_ = FALSE;
						if (!(i < (*self).size)) {
							break;
						}
						_tmp8_ = mainline;
						_tmp8__length1 = mainline_length1;
						_tmp9_ = (*self).tiles;
						_tmp9__length1 = (*self).tiles_length1;
						_tmp9__length2 = (*self).tiles_length2;
						_tmp10_ = _tmp9_[(0 * _tmp9__length2) + i];
						_tmp8_[i] = _tmp10_;
					}
				}
			}
			break;
		}
		case MAIN_LINE_RIGHT:
		{
			{
				guint8 i = 0U;
				i = (guint8) 0;
				{
					gboolean _tmp11_ = FALSE;
					_tmp11_ = TRUE;
					while (TRUE) {
						Player* _tmp13_;
						gint _tmp13__length1;
						Player* _tmp14_;
						gint _tmp14__length1;
						gint _tmp14__length2;
						Player _tmp15_;
						if (!_tmp11_) {
							guint8 _tmp12_;
							_tmp12_ = i;
							i = _tmp12_ + 1;
						}
						_tmp11_ = FALSE;
						if (!(i < (*self).size)) {
							break;
						}
						_tmp13_ = mainline;
						_tmp13__length1 = mainline_length1;
						_tmp14_ = (*self).tiles;
						_tmp14__length1 = (*self).tiles_length1;
						_tmp14__length2 = (*self).tiles_length2;
						_tmp15_ = _tmp14_[(((*self).size - 1) * _tmp14__length2) + i];
						_tmp13_[i] = _tmp15_;
					}
				}
			}
			break;
		}
		case MAIN_LINE_BOTTOM:
		{
			{
				guint8 i = 0U;
				i = (guint8) 0;
				{
					gboolean _tmp16_ = FALSE;
					_tmp16_ = TRUE;
					while (TRUE) {
						Player* _tmp18_;
						gint _tmp18__length1;
						Player* _tmp19_;
						gint _tmp19__length1;
						gint _tmp19__length2;
						Player _tmp20_;
						if (!_tmp16_) {
							guint8 _tmp17_;
							_tmp17_ = i;
							i = _tmp17_ + 1;
						}
						_tmp16_ = FALSE;
						if (!(i < (*self).size)) {
							break;
						}
						_tmp18_ = mainline;
						_tmp18__length1 = mainline_length1;
						_tmp19_ = (*self).tiles;
						_tmp19__length1 = (*self).tiles_length1;
						_tmp19__length2 = (*self).tiles_length2;
						_tmp20_ = _tmp19_[(i * _tmp19__length2) + ((*self).size - 1)];
						_tmp18_[i] = _tmp20_;
					}
				}
			}
			break;
		}
		case MAIN_LINE_TOPLEFT:
		{
			{
				guint8 i = 0U;
				i = (guint8) 0;
				{
					gboolean _tmp21_ = FALSE;
					_tmp21_ = TRUE;
					while (TRUE) {
						Player* _tmp23_;
						gint _tmp23__length1;
						Player* _tmp24_;
						gint _tmp24__length1;
						gint _tmp24__length2;
						Player _tmp25_;
						if (!_tmp21_) {
							guint8 _tmp22_;
							_tmp22_ = i;
							i = _tmp22_ + 1;
						}
						_tmp21_ = FALSE;
						if (!(i < (*self).size)) {
							break;
						}
						_tmp23_ = mainline;
						_tmp23__length1 = mainline_length1;
						_tmp24_ = (*self).tiles;
						_tmp24__length1 = (*self).tiles_length1;
						_tmp24__length2 = (*self).tiles_length2;
						_tmp25_ = _tmp24_[(i * _tmp24__length2) + i];
						_tmp23_[i] = _tmp25_;
					}
				}
			}
			break;
		}
		case MAIN_LINE_TOPRIGHT:
		{
			{
				guint8 i = 0U;
				i = (guint8) 0;
				{
					gboolean _tmp26_ = FALSE;
					_tmp26_ = TRUE;
					while (TRUE) {
						Player* _tmp28_;
						gint _tmp28__length1;
						Player* _tmp29_;
						gint _tmp29__length1;
						gint _tmp29__length2;
						Player _tmp30_;
						if (!_tmp26_) {
							guint8 _tmp27_;
							_tmp27_ = i;
							i = _tmp27_ + 1;
						}
						_tmp26_ = FALSE;
						if (!(i < (*self).size)) {
							break;
						}
						_tmp28_ = mainline;
						_tmp28__length1 = mainline_length1;
						_tmp29_ = (*self).tiles;
						_tmp29__length1 = (*self).tiles_length1;
						_tmp29__length2 = (*self).tiles_length2;
						_tmp30_ = _tmp29_[((((*self).size - 1) - i) * _tmp29__length2) + i];
						_tmp28_[i] = _tmp30_;
					}
				}
			}
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp31_ = mainline;
	_tmp31__length1 = mainline_length1;
	if (result_length1) {
		*result_length1 = _tmp31__length1;
	}
	result = _tmp31_;
	return result;
}

static Player*
_vala_array_dup10 (Player* self,
                   int length)
{
	return g_memdup (self, length * sizeof (Player));
}

static guint8*
_vala_array_dup11 (guint8* self,
                   int length)
{
	return g_memdup (self, length * sizeof (guint8));
}

void
game_state_struct_copy (const GameStateStruct* self,
                        GameStateStruct* dest)
{
	Player _tmp0_;
	Player _tmp1_;
	Player* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Player* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	_tmp0_ = (*self).current_color;
	(*dest).current_color = _tmp0_;
	_tmp1_ = (*self).opponent_color;
	(*dest).opponent_color = _tmp1_;
	(*dest).size = (*self).size;
	(*dest).n_current_tiles = (*self).n_current_tiles;
	(*dest).n_opponent_tiles = (*self).n_opponent_tiles;
	(*dest).n_tiles = (*self).n_tiles;
	(*dest).current_player_can_move = (*self).current_player_can_move;
	(*dest).is_complete = (*self).is_complete;
	_tmp2_ = (*self).tiles;
	_tmp2__length1 = (*self).tiles_length1;
	_tmp2__length2 = (*self).tiles_length2;
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup10 (_tmp2_, _tmp2__length1 * _tmp2__length2) : ((gpointer) _tmp2_);
	_tmp3__length1 = _tmp2__length1;
	_tmp3__length2 = _tmp2__length2;
	(*dest).tiles = (g_free ((*dest).tiles), NULL);
	(*dest).tiles = _tmp3_;
	(*dest).tiles_length1 = _tmp3__length1;
	(*dest).tiles_length2 = _tmp3__length2;
	_tmp4_ = (*self).neighbor_tiles;
	_tmp4__length1 = (*self).neighbor_tiles_length1;
	_tmp4__length2 = (*self).neighbor_tiles_length2;
	(*dest).neighbor_tiles = _tmp4_;
	(*dest).neighbor_tiles_length1 = _tmp4__length1;
	(*dest).neighbor_tiles_length2 = _tmp4__length2;
	(*dest).x_saved = (*self).x_saved;
	(*dest).y_saved = (*self).y_saved;
	_tmp5_ = (*self).empty_neighbors;
	_tmp5__length1 = (*self).empty_neighbors_length1;
	_tmp5__length2 = (*self).empty_neighbors_length2;
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup11 (_tmp5_, _tmp5__length1 * _tmp5__length2) : ((gpointer) _tmp5_);
	_tmp6__length1 = _tmp5__length1;
	_tmp6__length2 = _tmp5__length2;
	(*dest).empty_neighbors = (g_free ((*dest).empty_neighbors), NULL);
	(*dest).empty_neighbors = _tmp6_;
	(*dest).empty_neighbors_length1 = _tmp6__length1;
	(*dest).empty_neighbors_length2 = _tmp6__length2;
}

void
game_state_struct_destroy (GameStateStruct* self)
{
	(*self).tiles = (g_free ((*self).tiles), NULL);
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
}

GameStateStruct*
game_state_struct_dup (const GameStateStruct* self)
{
	GameStateStruct* dup;
	dup = g_new0 (GameStateStruct, 1);
	game_state_struct_copy (self, dup);
	return dup;
}

void
game_state_struct_free (GameStateStruct* self)
{
	game_state_struct_destroy (self);
	g_free (self);
}

GType
game_state_struct_get_type (void)
{
	static volatile gsize game_state_struct_type_id__volatile = 0;
	if (g_once_init_enter (&game_state_struct_type_id__volatile)) {
		GType game_state_struct_type_id;
		game_state_struct_type_id = g_boxed_type_register_static ("GameStateStruct", (GBoxedCopyFunc) game_state_struct_dup, (GBoxedFreeFunc) game_state_struct_free);
		g_once_init_leave (&game_state_struct_type_id__volatile, game_state_struct_type_id);
	}
	return game_state_struct_type_id__volatile;
}

static inline gpointer
game_state_object_get_instance_private (GameStateObject* self)
{
	return G_STRUCT_MEMBER_P (self, GameStateObject_private_offset);
}

gchar*
game_state_object_to_string (GameStateObject* self)
{
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	game_state_object_get_game_state_struct (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_state_struct_to_string (&_tmp1_);
	result = _tmp2_;
	return result;
}

GameStateObject*
game_state_object_construct_copy_and_pass (GType object_type,
                                           GameStateObject* game)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	g_return_val_if_fail (game != NULL, NULL);
	self = (GameStateObject*) g_object_new (object_type, NULL);
	game_state_object_get_game_state_struct (game, &_tmp0_);
	_tmp1_ = _tmp0_;
	game_state_struct_destroy (&self->priv->_game_state_struct);
	game_state_struct_init_copy_and_pass (&self->priv->_game_state_struct, &_tmp1_);
	return self;
}

GameStateObject*
game_state_object_new_copy_and_pass (GameStateObject* game)
{
	return game_state_object_construct_copy_and_pass (TYPE_GAME_STATE_OBJECT, game);
}

GameStateObject*
game_state_object_construct_copy_and_move (GType object_type,
                                           GameStateObject* game,
                                           PossibleMove* move)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	PossibleMove _tmp2_;
	g_return_val_if_fail (game != NULL, NULL);
	g_return_val_if_fail (move != NULL, NULL);
	self = (GameStateObject*) g_object_new (object_type, NULL);
	game_state_object_get_game_state_struct (game, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = *move;
	game_state_struct_destroy (&self->priv->_game_state_struct);
	game_state_struct_init_copy_and_move (&self->priv->_game_state_struct, &_tmp1_, &_tmp2_);
	return self;
}

GameStateObject*
game_state_object_new_copy_and_move (GameStateObject* game,
                                     PossibleMove* move)
{
	return game_state_object_construct_copy_and_move (TYPE_GAME_STATE_OBJECT, game, move);
}

GameStateObject*
game_state_object_construct_from_grid (GType object_type,
                                       guint8 size,
                                       Player* tiles,
                                       gint tiles_length1,
                                       gint tiles_length2,
                                       Player color,
                                       guint8* neighbor_tiles,
                                       gint neighbor_tiles_length1,
                                       gint neighbor_tiles_length2)
{
	GameStateObject * self = NULL;
	self = (GameStateObject*) g_object_new (object_type, NULL);
	game_state_struct_destroy (&self->priv->_game_state_struct);
	game_state_struct_init_from_grid (&self->priv->_game_state_struct, size, tiles, tiles_length1, tiles_length2, color, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2);
	return self;
}

GameStateObject*
game_state_object_new_from_grid (guint8 size,
                                 Player* tiles,
                                 gint tiles_length1,
                                 gint tiles_length2,
                                 Player color,
                                 guint8* neighbor_tiles,
                                 gint neighbor_tiles_length1,
                                 gint neighbor_tiles_length2)
{
	return game_state_object_construct_from_grid (TYPE_GAME_STATE_OBJECT, size, tiles, tiles_length1, tiles_length2, color, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2);
}

Player
game_state_object_get_owner (GameStateObject* self,
                             guint8 x,
                             guint8 y)
{
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Player _tmp3_;
	Player result = 0;
	g_return_val_if_fail (self != NULL, 0);
	game_state_object_get_game_state_struct (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_.tiles;
	_tmp2__length1 = _tmp1_.tiles_length1;
	_tmp2__length2 = _tmp1_.tiles_length2;
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
	result = _tmp3_;
	return result;
}

void
game_state_object_get_possible_moves (GameStateObject* self,
                                      GSList* * moves)
{
	GSList* _vala_moves = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	GSList* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	game_state_object_get_game_state_struct (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	game_state_struct_get_possible_moves (&_tmp1_, &_tmp2_);
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
	_vala_moves = _tmp2_;
	if (moves) {
		*moves = _vala_moves;
	} else {
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
	}
}

gboolean
game_state_object_test_placing_tile (GameStateObject* self,
                                     guint8 x,
                                     guint8 y,
                                     PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	PossibleMove _tmp2_ = {0};
	gboolean _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	game_state_object_get_game_state_struct (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp3_ = game_state_struct_test_placing_tile (&_tmp1_, x, y, &_tmp2_);
	_vala_move = _tmp2_;
	result = _tmp3_;
	if (move) {
		*move = _vala_move;
	}
	return result;
}

GameStateObject*
game_state_object_construct (GType object_type)
{
	GameStateObject * self = NULL;
	self = (GameStateObject*) g_object_new (object_type, NULL);
	return self;
}

GameStateObject*
game_state_object_new (void)
{
	return game_state_object_construct (TYPE_GAME_STATE_OBJECT);
}

void
game_state_object_get_game_state_struct (GameStateObject* self,
                                         GameStateStruct * result)
{
	GameStateStruct _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_game_state_struct;
	*result = _tmp0_;
	return;
}

Player
game_state_object_get_current_color (GameStateObject* self)
{
	Player result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	game_state_object_get_game_state_struct (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_.current_color;
	result = _tmp2_;
	return result;
}

guint8
game_state_object_get_n_light_tiles (GameStateObject* self)
{
	guint8 result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp5_ = {0};
	GameStateStruct _tmp6_;
	g_return_val_if_fail (self != NULL, 0U);
	game_state_object_get_game_state_struct (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_.current_color;
	if (_tmp2_ == PLAYER_LIGHT) {
		GameStateStruct _tmp3_ = {0};
		GameStateStruct _tmp4_;
		game_state_object_get_game_state_struct (self, &_tmp3_);
		_tmp4_ = _tmp3_;
		result = _tmp4_.n_current_tiles;
		return result;
	}
	game_state_object_get_game_state_struct (self, &_tmp5_);
	_tmp6_ = _tmp5_;
	result = _tmp6_.n_opponent_tiles;
	return result;
}

guint8
game_state_object_get_n_dark_tiles (GameStateObject* self)
{
	guint8 result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp5_ = {0};
	GameStateStruct _tmp6_;
	g_return_val_if_fail (self != NULL, 0U);
	game_state_object_get_game_state_struct (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_.current_color;
	if (_tmp2_ == PLAYER_DARK) {
		GameStateStruct _tmp3_ = {0};
		GameStateStruct _tmp4_;
		game_state_object_get_game_state_struct (self, &_tmp3_);
		_tmp4_ = _tmp3_;
		result = _tmp4_.n_current_tiles;
		return result;
	}
	game_state_object_get_game_state_struct (self, &_tmp5_);
	_tmp6_ = _tmp5_;
	result = _tmp6_.n_opponent_tiles;
	return result;
}

gboolean
game_state_object_get_current_player_can_move (GameStateObject* self)
{
	gboolean result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	game_state_object_get_game_state_struct (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = _tmp1_.current_player_can_move;
	return result;
}

gboolean
game_state_object_get_is_complete (GameStateObject* self)
{
	gboolean result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	game_state_object_get_game_state_struct (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = _tmp1_.is_complete;
	return result;
}

static void
game_state_object_class_init (GameStateObjectClass * klass,
                              gpointer klass_data)
{
	game_state_object_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GameStateObject_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_game_state_object_get_property;
	G_OBJECT_CLASS (klass)->finalize = game_state_object_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY] = g_param_spec_boxed ("game-state-struct", "game-state-struct", "game-state-struct", TYPE_GAME_STATE_STRUCT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
}

static void
game_state_object_instance_init (GameStateObject * self,
                                 gpointer klass)
{
	self->priv = game_state_object_get_instance_private (self);
}

static void
game_state_object_finalize (GObject * obj)
{
	GameStateObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_STATE_OBJECT, GameStateObject);
	game_state_struct_destroy (&self->priv->_game_state_struct);
	G_OBJECT_CLASS (game_state_object_parent_class)->finalize (obj);
}

GType
game_state_object_get_type (void)
{
	static volatile gsize game_state_object_type_id__volatile = 0;
	if (g_once_init_enter (&game_state_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameStateObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_state_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameStateObject), 0, (GInstanceInitFunc) game_state_object_instance_init, NULL };
		GType game_state_object_type_id;
		game_state_object_type_id = g_type_register_static (G_TYPE_OBJECT, "GameStateObject", &g_define_type_info, 0);
		GameStateObject_private_offset = g_type_add_instance_private (game_state_object_type_id, sizeof (GameStateObjectPrivate));
		g_once_init_leave (&game_state_object_type_id__volatile, game_state_object_type_id);
	}
	return game_state_object_type_id__volatile;
}

static void
_vala_game_state_object_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GameStateObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_STATE_OBJECT, GameStateObject);
	switch (property_id) {
		case GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY:
		{
			GameStateStruct boxed;
			game_state_object_get_game_state_struct (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY:
		g_value_set_enum (value, game_state_object_get_current_color (self));
		break;
		case GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY:
		g_value_set_uchar (value, game_state_object_get_n_light_tiles (self));
		break;
		case GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY:
		g_value_set_uchar (value, game_state_object_get_n_dark_tiles (self));
		break;
		case GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
		g_value_set_boolean (value, game_state_object_get_current_player_can_move (self));
		break;
		case GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY:
		g_value_set_boolean (value, game_state_object_get_is_complete (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gboolean _alternative_start,
                guint8 _size)
{
	Game * self = NULL;
	gboolean even_board = FALSE;
	Player* tiles = NULL;
	Player* _tmp0_;
	gint tiles_length1;
	gint tiles_length2;
	guint8 _initial_number_of_tiles = 0U;
	guint8* _neighbor_tiles = NULL;
	gint _neighbor_tiles_length1 = 0;
	gint _neighbor_tiles_length2 = 0;
	guint8* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	GameStateObject* _current_state = NULL;
	Player* _tmp26_;
	gint _tmp26__length1;
	gint _tmp26__length2;
	guint8* _tmp27_;
	gint _tmp27__length1;
	gint _tmp27__length2;
	GameStateObject* _tmp28_;
	guint8* _tmp29_;
	gint _tmp29__length1;
	gint _tmp29__length2;
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
	even_board = (_size % 2) == 0;
	_tmp0_ = g_new0 (Player, _size * _size);
	tiles = _tmp0_;
	tiles_length1 = _size;
	tiles_length2 = _size;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(x < _size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							Player* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							if (!_tmp3_) {
								guint8 _tmp4_;
								_tmp4_ = y;
								y = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							if (!(y < _size)) {
								break;
							}
							_tmp5_ = tiles;
							_tmp5__length1 = tiles_length1;
							_tmp5__length2 = tiles_length2;
							_tmp5_[(x * _tmp5__length2) + y] = PLAYER_NONE;
						}
					}
				}
			}
		}
	}
	if (even_board) {
		guint8 half_size = 0U;
		Player _tmp6_ = 0;
		Player* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player _tmp9_ = 0;
		Player* _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		Player* _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		half_size = (guint8) (_size / 2);
		_initial_number_of_tiles = (guint8) 4;
		if (_alternative_start) {
			_tmp6_ = PLAYER_DARK;
		} else {
			_tmp6_ = PLAYER_LIGHT;
		}
		_tmp7_ = tiles;
		_tmp7__length1 = tiles_length1;
		_tmp7__length2 = tiles_length2;
		_tmp7_[((half_size - 1) * _tmp7__length2) + (half_size - 1)] = _tmp6_;
		_tmp8_ = tiles;
		_tmp8__length1 = tiles_length1;
		_tmp8__length2 = tiles_length2;
		_tmp8_[((half_size - 1) * _tmp8__length2) + half_size] = PLAYER_DARK;
		if (_alternative_start) {
			_tmp9_ = PLAYER_LIGHT;
		} else {
			_tmp9_ = PLAYER_DARK;
		}
		_tmp10_ = tiles;
		_tmp10__length1 = tiles_length1;
		_tmp10__length2 = tiles_length2;
		_tmp10_[(half_size * _tmp10__length2) + (half_size - 1)] = _tmp9_;
		_tmp11_ = tiles;
		_tmp11__length1 = tiles_length1;
		_tmp11__length2 = tiles_length2;
		_tmp11_[(half_size * _tmp11__length2) + half_size] = PLAYER_LIGHT;
	} else {
		guint8 mid_board = 0U;
		Player* _tmp12_;
		gint _tmp12__length1;
		gint _tmp12__length2;
		Player _tmp13_ = 0;
		Player* _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		Player _tmp15_ = 0;
		Player* _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		Player* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		Player _tmp18_ = 0;
		Player* _tmp19_;
		gint _tmp19__length1;
		gint _tmp19__length2;
		Player _tmp20_ = 0;
		Player* _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
		Player* _tmp22_;
		gint _tmp22__length1;
		gint _tmp22__length2;
		mid_board = (guint8) ((_size - 1) / 2);
		_initial_number_of_tiles = (guint8) 7;
		_tmp12_ = tiles;
		_tmp12__length1 = tiles_length1;
		_tmp12__length2 = tiles_length2;
		_tmp12_[(mid_board * _tmp12__length2) + mid_board] = PLAYER_DARK;
		if (_alternative_start) {
			_tmp13_ = PLAYER_LIGHT;
		} else {
			_tmp13_ = PLAYER_DARK;
		}
		_tmp14_ = tiles;
		_tmp14__length1 = tiles_length1;
		_tmp14__length2 = tiles_length2;
		_tmp14_[((mid_board + 1) * _tmp14__length2) + (mid_board - 1)] = _tmp13_;
		if (_alternative_start) {
			_tmp15_ = PLAYER_LIGHT;
		} else {
			_tmp15_ = PLAYER_DARK;
		}
		_tmp16_ = tiles;
		_tmp16__length1 = tiles_length1;
		_tmp16__length2 = tiles_length2;
		_tmp16_[((mid_board - 1) * _tmp16__length2) + (mid_board + 1)] = _tmp15_;
		_tmp17_ = tiles;
		_tmp17__length1 = tiles_length1;
		_tmp17__length2 = tiles_length2;
		_tmp17_[(mid_board * _tmp17__length2) + (mid_board - 1)] = PLAYER_LIGHT;
		if (_alternative_start) {
			_tmp18_ = PLAYER_DARK;
		} else {
			_tmp18_ = PLAYER_LIGHT;
		}
		_tmp19_ = tiles;
		_tmp19__length1 = tiles_length1;
		_tmp19__length2 = tiles_length2;
		_tmp19_[((mid_board - 1) * _tmp19__length2) + mid_board] = _tmp18_;
		if (_alternative_start) {
			_tmp20_ = PLAYER_DARK;
		} else {
			_tmp20_ = PLAYER_LIGHT;
		}
		_tmp21_ = tiles;
		_tmp21__length1 = tiles_length1;
		_tmp21__length2 = tiles_length2;
		_tmp21_[((mid_board + 1) * _tmp21__length2) + mid_board] = _tmp20_;
		_tmp22_ = tiles;
		_tmp22__length1 = tiles_length1;
		_tmp22__length2 = tiles_length2;
		_tmp22_[(mid_board * _tmp22__length2) + (mid_board + 1)] = PLAYER_LIGHT;
	}
	game_init_neighbor_tiles (_size, &_tmp23_, &_tmp24_, &_tmp25_);
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
	_neighbor_tiles = _tmp23_;
	_neighbor_tiles_length1 = _tmp24_;
	_neighbor_tiles_length2 = _tmp25_;
	_tmp26_ = tiles;
	_tmp26__length1 = tiles_length1;
	_tmp26__length2 = tiles_length2;
	_tmp27_ = _neighbor_tiles;
	_tmp27__length1 = _neighbor_tiles_length1;
	_tmp27__length2 = _neighbor_tiles_length2;
	_tmp28_ = game_state_object_new_from_grid (_size, _tmp26_, _tmp26__length1, _tmp26__length2, PLAYER_DARK, _tmp27_, _tmp27__length1, _tmp27__length2);
	_current_state = _tmp28_;
	self = (Game*) g_object_new (object_type, "size", _size, "current-state", _current_state, "alternative-start", _alternative_start, "initial-number-of-tiles", _initial_number_of_tiles, NULL);
	_tmp29_ = _neighbor_tiles;
	_tmp29__length1 = _neighbor_tiles_length1;
	_tmp29__length2 = _neighbor_tiles_length2;
	_neighbor_tiles = NULL;
	_neighbor_tiles_length1 = 0;
	_neighbor_tiles_length2 = 0;
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
	self->priv->neighbor_tiles = _tmp29_;
	self->priv->neighbor_tiles_length1 = _tmp29__length1;
	self->priv->neighbor_tiles_length2 = _tmp29__length2;
	_g_object_unref0 (_current_state);
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
	tiles = (g_free (tiles), NULL);
	return self;
}

Game*
game_new (gboolean _alternative_start,
          guint8 _size)
{
	return game_construct (TYPE_GAME, _alternative_start, _size);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp19_ = res;
		_tmp20_ = str_array[0];
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
		ptr = _tmp21_;
		{
			gboolean _tmp22_ = FALSE;
			i = 1;
			_tmp22_ = TRUE;
			while (TRUE) {
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp24_ = ptr;
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
				ptr = _tmp25_;
				_tmp27_ = str_array[i];
				if (_tmp27_ != NULL) {
					const gchar* _tmp28_;
					_tmp28_ = str_array[i];
					_tmp26_ = (const gchar*) _tmp28_;
				} else {
					_tmp26_ = "";
				}
				_tmp29_ = ptr;
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
				ptr = _tmp30_;
			}
		}
		_tmp31_ = res;
		res = NULL;
		result = (gchar*) _tmp31_;
		return result;
	} else {
		gchar* _tmp32_;
		_tmp32_ = g_strdup ("");
		result = _tmp32_;
		return result;
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

Game*
game_construct_from_strings (GType object_type,
                             gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size)
{
	Game * self = NULL;
	Player* tiles = NULL;
	Player* _tmp0_;
	gint tiles_length1;
	gint tiles_length2;
	guint8* _neighbor_tiles = NULL;
	gint _neighbor_tiles_length1 = 0;
	gint _neighbor_tiles_length2 = 0;
	guint8* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GameStateObject* _current_state = NULL;
	Player* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	guint8* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	GameStateObject* _tmp15_;
	gint _tmp16_ = 0;
	GameStateObject* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	gint _tmp18__length2;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
	_vala_return_val_if_fail (to_move != PLAYER_NONE, "to_move != Player.NONE", NULL);
	_vala_return_val_if_fail (setup_length1 == ((gint) _size), "setup.length == _size", NULL);
	_tmp0_ = g_new0 (Player, _size * _size);
	tiles = _tmp0_;
	tiles_length1 = _size;
	tiles_length2 = _size;
	{
		guint8 y = 0U;
		y = (guint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				const gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = y;
					y = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(y < _size)) {
					break;
				}
				_tmp3_ = setup[y];
				_tmp4_ = strlen (_tmp3_);
				_tmp5_ = _tmp4_;
				if (_tmp5_ != (_size * 2)) {
					g_warn_if_reached ();
				}
				{
					guint8 x = 0U;
					x = (guint8) 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							Player* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							const gchar* _tmp9_;
							if (!_tmp6_) {
								guint8 _tmp7_;
								_tmp7_ = x;
								x = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							if (!(x < _size)) {
								break;
							}
							_tmp8_ = tiles;
							_tmp8__length1 = tiles_length1;
							_tmp8__length2 = tiles_length2;
							_tmp9_ = setup[y];
							_tmp8_[(x * _tmp8__length2) + y] = player_from_char (string_get (_tmp9_, (glong) ((x * 2) + 1)));
						}
					}
				}
			}
		}
	}
	game_init_neighbor_tiles (_size, &_tmp10_, &_tmp11_, &_tmp12_);
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
	_neighbor_tiles = _tmp10_;
	_neighbor_tiles_length1 = _tmp11_;
	_neighbor_tiles_length2 = _tmp12_;
	_tmp13_ = tiles;
	_tmp13__length1 = tiles_length1;
	_tmp13__length2 = tiles_length2;
	_tmp14_ = _neighbor_tiles;
	_tmp14__length1 = _neighbor_tiles_length1;
	_tmp14__length2 = _neighbor_tiles_length2;
	_tmp15_ = game_state_object_new_from_grid (_size, _tmp13_, _tmp13__length1, _tmp13__length2, to_move, _tmp14_, _tmp14__length1, _tmp14__length2);
	_current_state = _tmp15_;
	if ((_size % 2) == 0) {
		_tmp16_ = 4;
	} else {
		_tmp16_ = 7;
	}
	_tmp17_ = _current_state;
	self = (Game*) g_object_new (object_type, "size", _size, "current-state", _tmp17_, "alternative-start", FALSE, "initial-number-of-tiles", _tmp16_, NULL);
	_tmp18_ = _neighbor_tiles;
	_tmp18__length1 = _neighbor_tiles_length1;
	_tmp18__length2 = _neighbor_tiles_length2;
	_neighbor_tiles = NULL;
	_neighbor_tiles_length1 = 0;
	_neighbor_tiles_length2 = 0;
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
	self->priv->neighbor_tiles = _tmp18_;
	self->priv->neighbor_tiles_length1 = _tmp18__length1;
	self->priv->neighbor_tiles_length2 = _tmp18__length2;
	_tmp19_ = _vala_g_strjoinv ("\n", (gchar**) setup, (gint) ((setup_length1 * sizeof (gchar*)) / sizeof (gchar*)));
	_tmp20_ = _tmp19_;
	_tmp21_ = string_strip (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = game_to_string (self);
	_tmp24_ = _tmp23_;
	_tmp25_ = string_strip (_tmp24_);
	_tmp26_ = _tmp25_;
	g_warn_if_fail (g_strcmp0 (_tmp22_, _tmp26_) == 0);
	_g_free0 (_tmp26_);
	_g_free0 (_tmp24_);
	_g_free0 (_tmp22_);
	_g_free0 (_tmp20_);
	_g_object_unref0 (_current_state);
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
	tiles = (g_free (tiles), NULL);
	return self;
}

Game*
game_new_from_strings (gchar** setup,
                       gint setup_length1,
                       Player to_move,
                       guint8 _size)
{
	return game_construct_from_strings (TYPE_GAME, setup, setup_length1, to_move, _size);
}

Player
game_get_owner (Game* self,
                guint8 x,
                guint8 y)
{
	GameStateObject* _tmp0_;
	Player result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_current_state;
	result = game_state_object_get_owner (_tmp0_, x, y);
	return result;
}

gchar*
game_to_string (Game* self)
{
	GameStateObject* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_state;
	_tmp1_ = game_state_object_to_string (_tmp0_);
	result = _tmp1_;
	return result;
}

gboolean
game_place_tile (Game* self,
                 guint8 x,
                 guint8 y)
{
	PossibleMove move = {0};
	GameStateObject* _tmp0_;
	PossibleMove _tmp1_ = {0};
	gboolean _tmp2_;
	GameStateObject* _tmp3_;
	PossibleMove _tmp4_;
	GameStateObject* _tmp5_;
	GameStateObject* _tmp6_;
	GListStore* _tmp7_;
	GameStateObject* _tmp8_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_current_state;
	_tmp2_ = game_state_object_test_placing_tile (_tmp0_, x, y, &_tmp1_);
	move = _tmp1_;
	if (!_tmp2_) {
		result = FALSE;
		return result;
	}
	_tmp3_ = self->priv->_current_state;
	_tmp4_ = move;
	_tmp5_ = game_state_object_new_copy_and_move (_tmp3_, &_tmp4_);
	_tmp6_ = _tmp5_;
	game_set_current_state (self, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = self->priv->undo_stack;
	_tmp8_ = self->priv->_current_state;
	g_list_store_append (_tmp7_, (GObject*) _tmp8_);
	game_end_of_turn (self, FALSE, FALSE);
	result = TRUE;
	return result;
}

gboolean
game_pass (Game* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GameStateObject* _tmp2_;
	GameStateObject* _tmp3_;
	GameStateObject* _tmp4_;
	GListStore* _tmp5_;
	GameStateObject* _tmp6_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = game_get_current_player_can_move (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = self->priv->_current_state;
	_tmp3_ = game_state_object_new_copy_and_pass (_tmp2_);
	_tmp4_ = _tmp3_;
	game_set_current_state (self, _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->undo_stack;
	_tmp6_ = self->priv->_current_state;
	g_list_store_append (_tmp5_, (GObject*) _tmp6_);
	game_end_of_turn (self, FALSE, TRUE);
	result = TRUE;
	return result;
}

static void
game_end_of_turn (Game* self,
                  gboolean undoing,
                  gboolean no_draw)
{
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	game_update_possible_moves (self);
	_tmp0_ = self->priv->_current_state;
	_tmp1_ = game_state_object_get_is_complete (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit (self, game_signals[GAME_COMPLETENESS_UPDATED_SIGNAL], 0, _tmp2_);
	g_signal_emit (self, game_signals[GAME_TURN_ENDED_SIGNAL], 0, undoing, no_draw);
}

void
game_undo (Game* self,
           guint8 count)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint undo_stack_n_items = 0U;
	GListStore* _tmp2_;
	GObject* tmp_current_state = NULL;
	GListStore* _tmp3_;
	GObject* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GObject* _tmp6_;
	GObject* _tmp8_;
	GListStore* _tmp9_;
	gboolean _tmp10_ = FALSE;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail ((((gint) count) == 1) || (((gint) count) == 2), "count == 1 || count == 2");
	_tmp0_ = game_get_number_of_moves (self);
	_tmp1_ = _tmp0_;
	_vala_return_if_fail (_tmp1_ >= count, "number_of_moves >= count");
	_tmp2_ = self->priv->undo_stack;
	undo_stack_n_items = g_list_model_get_n_items ((GListModel*) _tmp2_);
	_tmp3_ = self->priv->undo_stack;
	_tmp4_ = g_list_model_get_object ((GListModel*) _tmp3_, undo_stack_n_items - 2);
	tmp_current_state = _tmp4_;
	_tmp6_ = tmp_current_state;
	if (_tmp6_ == NULL) {
		_tmp5_ = TRUE;
	} else {
		GObject* _tmp7_;
		_tmp7_ = tmp_current_state;
		_tmp5_ = !IS_GAME_STATE_OBJECT (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, G_TYPE_OBJECT, GObject));
	}
	if (_tmp5_) {
		g_assert_not_reached ();
	}
	_tmp8_ = tmp_current_state;
	game_set_current_state (self, G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, G_TYPE_OBJECT, GObject), TYPE_GAME_STATE_OBJECT, GameStateObject));
	_tmp9_ = self->priv->undo_stack;
	g_list_store_remove (_tmp9_, undo_stack_n_items - 1);
	if (((gint) count) == 1) {
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp11_ = game_get_current_player_can_move (self);
		_tmp12_ = _tmp11_;
		_tmp10_ = _tmp12_;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		game_end_of_turn (self, TRUE, FALSE);
	} else {
		if (((gint) count) == 2) {
			game_end_of_turn (self, TRUE, TRUE);
			game_undo (self, (guint8) (count - 1));
		}
	}
	_g_object_unref0 (tmp_current_state);
}

static guint8*
_vala_array_dup12 (guint8* self,
                   int length)
{
	return g_memdup (self, length * sizeof (guint8));
}

guint8*
game_copy_neighbor_tiles (Game* self,
                          gint* result_length1,
                          gint* result_length2)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	guint8* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->neighbor_tiles;
	_tmp0__length1 = self->priv->neighbor_tiles_length1;
	_tmp0__length2 = self->priv->neighbor_tiles_length2;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup12 (_tmp0_, _tmp0__length1 * _tmp0__length2) : ((gpointer) _tmp0_);
	_tmp1__length1 = _tmp0__length1;
	_tmp1__length2 = _tmp0__length2;
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	_tmp2__length2 = _tmp1__length2;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	if (result_length2) {
		*result_length2 = _tmp2__length2;
	}
	result = _tmp2_;
	return result;
}

static void
game_init_neighbor_tiles (guint8 size,
                          guint8** neighbor_tiles,
                          gint* neighbor_tiles_length1,
                          gint* neighbor_tiles_length2)
{
	guint8* _vala_neighbor_tiles = NULL;
	gint _vala_neighbor_tiles_length1 = 0;
	gint _vala_neighbor_tiles_length2 = 0;
	guint8* _tmp0_;
	guint8 max = 0U;
	guint8* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	guint8* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	_tmp0_ = g_new0 (guint8, size * size);
	_vala_neighbor_tiles = (g_free (_vala_neighbor_tiles), NULL);
	_vala_neighbor_tiles = _tmp0_;
	_vala_neighbor_tiles_length1 = size;
	_vala_neighbor_tiles_length2 = size;
	max = (guint8) (size - 1);
	{
		guint8 i = 0U;
		i = (guint8) 1;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				guint8* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				guint8* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				guint8* _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				guint8* _tmp6_;
				gint _tmp6__length1;
				gint _tmp6__length2;
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < max)) {
					break;
				}
				_tmp3_ = _vala_neighbor_tiles;
				_tmp3__length1 = _vala_neighbor_tiles_length1;
				_tmp3__length2 = _vala_neighbor_tiles_length2;
				_tmp3_[(i * _tmp3__length2) + 0] = (guint8) 5;
				_tmp4_ = _vala_neighbor_tiles;
				_tmp4__length1 = _vala_neighbor_tiles_length1;
				_tmp4__length2 = _vala_neighbor_tiles_length2;
				_tmp4_[(i * _tmp4__length2) + max] = (guint8) 5;
				_tmp5_ = _vala_neighbor_tiles;
				_tmp5__length1 = _vala_neighbor_tiles_length1;
				_tmp5__length2 = _vala_neighbor_tiles_length2;
				_tmp5_[(0 * _tmp5__length2) + i] = (guint8) 5;
				_tmp6_ = _vala_neighbor_tiles;
				_tmp6__length1 = _vala_neighbor_tiles_length1;
				_tmp6__length2 = _vala_neighbor_tiles_length2;
				_tmp6_[(max * _tmp6__length2) + i] = (guint8) 5;
				{
					guint8 j = 0U;
					j = (guint8) 1;
					{
						gboolean _tmp7_ = FALSE;
						_tmp7_ = TRUE;
						while (TRUE) {
							guint8* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							if (!_tmp7_) {
								guint8 _tmp8_;
								_tmp8_ = j;
								j = _tmp8_ + 1;
							}
							_tmp7_ = FALSE;
							if (!(j < max)) {
								break;
							}
							_tmp9_ = _vala_neighbor_tiles;
							_tmp9__length1 = _vala_neighbor_tiles_length1;
							_tmp9__length2 = _vala_neighbor_tiles_length2;
							_tmp9_[(i * _tmp9__length2) + j] = (guint8) 8;
						}
					}
				}
			}
		}
	}
	_tmp10_ = _vala_neighbor_tiles;
	_tmp10__length1 = _vala_neighbor_tiles_length1;
	_tmp10__length2 = _vala_neighbor_tiles_length2;
	_tmp10_[(0 * _tmp10__length2) + 0] = (guint8) 3;
	_tmp11_ = _vala_neighbor_tiles;
	_tmp11__length1 = _vala_neighbor_tiles_length1;
	_tmp11__length2 = _vala_neighbor_tiles_length2;
	_tmp11_[(0 * _tmp11__length2) + max] = (guint8) 3;
	_tmp12_ = _vala_neighbor_tiles;
	_tmp12__length1 = _vala_neighbor_tiles_length1;
	_tmp12__length2 = _vala_neighbor_tiles_length2;
	_tmp12_[(max * _tmp12__length2) + max] = (guint8) 3;
	_tmp13_ = _vala_neighbor_tiles;
	_tmp13__length1 = _vala_neighbor_tiles_length1;
	_tmp13__length2 = _vala_neighbor_tiles_length2;
	_tmp13_[(max * _tmp13__length2) + 0] = (guint8) 3;
	if (neighbor_tiles) {
		*neighbor_tiles = _vala_neighbor_tiles;
	} else {
		_vala_neighbor_tiles = (g_free (_vala_neighbor_tiles), NULL);
	}
	if (neighbor_tiles_length1) {
		*neighbor_tiles_length1 = _vala_neighbor_tiles_length1;
	}
	if (neighbor_tiles_length2) {
		*neighbor_tiles_length2 = _vala_neighbor_tiles_length2;
	}
}

gboolean
game_test_placing_tile (Game* self,
                        guint8 x,
                        guint8 y,
                        PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	GSList* test_move = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->possible_moves;
	_tmp1_ = g_slist_nth (_tmp0_, (guint) 0);
	test_move = _tmp1_;
	while (TRUE) {
		GSList* _tmp2_;
		GSList* _tmp3_;
		gconstpointer _tmp4_;
		gboolean _tmp5_ = FALSE;
		PossibleMove _tmp6_;
		GSList* _tmp8_;
		GSList* _tmp9_;
		_tmp2_ = test_move;
		if (!(_tmp2_ != NULL)) {
			break;
		}
		_tmp3_ = test_move;
		_tmp4_ = ((GSList*) _tmp3_)->data;
		_vala_move = (PossibleMove) (*((PossibleMove*) _tmp4_));
		_tmp6_ = _vala_move;
		if (_tmp6_.x == x) {
			PossibleMove _tmp7_;
			_tmp7_ = _vala_move;
			_tmp5_ = _tmp7_.y == y;
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			result = TRUE;
			if (move) {
				*move = _vala_move;
			}
			return result;
		}
		_tmp8_ = test_move;
		_tmp9_ = ((GSList*) _tmp8_)->next;
		test_move = _tmp9_;
	}
	result = FALSE;
	if (move) {
		*move = _vala_move;
	}
	return result;
}

static PossibleMove*
__lambda15_ (Game* self,
             PossibleMove* a)
{
	PossibleMove* _tmp0_;
	PossibleMove* result = NULL;
	_tmp0_ = _possible_move_dup0 (a);
	result = _tmp0_;
	return result;
}

static gpointer
___lambda15__gcopy_func (gconstpointer src,
                         gpointer self)
{
	gpointer result;
	result = __lambda15_ ((Game*) self, (PossibleMove*) src);
	return result;
}

void
game_get_possible_moves (Game* self,
                         GSList* * moves)
{
	GSList* _vala_moves = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->possible_moves;
	_tmp1_ = g_slist_copy_deep (_tmp0_, ___lambda15__gcopy_func, self);
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
	_vala_moves = _tmp1_;
	if (moves) {
		*moves = _vala_moves;
	} else {
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
	}
}

static inline void
game_update_possible_moves (Game* self)
{
	GameStateObject* _tmp0_;
	GSList* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_state;
	game_state_object_get_possible_moves (_tmp0_, &_tmp1_);
	(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
	self->priv->possible_moves = _tmp1_;
}

guint8
game_get_number_of_moves (Game* self)
{
	guint8 result;
	guint n_items = 0U;
	GListStore* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->undo_stack;
	n_items = g_list_model_get_n_items ((GListModel*) _tmp0_);
	if (n_items == ((guint) 0)) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = n_items >= ((guint) 256);
	}
	if (_tmp1_) {
		g_assert_not_reached ();
	}
	result = (guint8) (n_items - 1);
	return result;
}

guint8
game_get_size (Game* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_size;
	return result;
}

static void
game_set_size (Game* self,
               guint8 value)
{
	g_return_if_fail (self != NULL);
	self->priv->_size = value;
}

GameStateObject*
game_get_current_state (Game* self)
{
	GameStateObject* result;
	GameStateObject* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_state;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
game_set_current_state (Game* self,
                        GameStateObject* value)
{
	GameStateObject* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_current_state);
	self->priv->_current_state = _tmp0_;
}

gboolean
game_get_alternative_start (Game* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_alternative_start;
	return result;
}

static void
game_set_alternative_start (Game* self,
                            gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_alternative_start = value;
}

guint8
game_get_initial_number_of_tiles (Game* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_initial_number_of_tiles;
	return result;
}

static void
game_set_initial_number_of_tiles (Game* self,
                                  guint8 value)
{
	g_return_if_fail (self != NULL);
	self->priv->_initial_number_of_tiles = value;
}

gboolean
game_get_is_complete (Game* self)
{
	gboolean result;
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_current_state;
	_tmp1_ = game_state_object_get_is_complete (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

guint8
game_get_n_light_tiles (Game* self)
{
	guint8 result;
	GameStateObject* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_current_state;
	_tmp1_ = game_state_object_get_n_light_tiles (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

guint8
game_get_n_dark_tiles (Game* self)
{
	guint8 result;
	GameStateObject* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_current_state;
	_tmp1_ = game_state_object_get_n_dark_tiles (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

gboolean
game_get_current_player_can_move (Game* self)
{
	gboolean result;
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_current_state;
	_tmp1_ = game_state_object_get_current_player_can_move (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

Player
game_get_current_color (Game* self)
{
	Player result;
	GameStateObject* _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_current_state;
	_tmp1_ = game_state_object_get_current_color (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static void
g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (gpointer data1, gboolean arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}

static GObject *
game_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Game * self;
	GListStore* _tmp0_;
	GameStateObject* _tmp1_;
	parent_class = G_OBJECT_CLASS (game_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
	_tmp0_ = self->priv->undo_stack;
	_tmp1_ = self->priv->_current_state;
	g_list_store_append (_tmp0_, (GObject*) _tmp1_);
	game_update_possible_moves (self);
	return obj;
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
	game_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
	G_OBJECT_CLASS (klass)->constructor = game_constructor;
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_NUMBER_OF_MOVES_PROPERTY, game_properties[GAME_NUMBER_OF_MOVES_PROPERTY] = g_param_spec_uchar ("number-of-moves", "number-of-moves", "number-of-moves", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SIZE_PROPERTY, game_properties[GAME_SIZE_PROPERTY] = g_param_spec_uchar ("size", "size", "size", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_STATE_PROPERTY, game_properties[GAME_CURRENT_STATE_PROPERTY] = g_param_spec_object ("current-state", "current-state", "current-state", TYPE_GAME_STATE_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ALTERNATIVE_START_PROPERTY, game_properties[GAME_ALTERNATIVE_START_PROPERTY] = g_param_spec_boolean ("alternative-start", "alternative-start", "alternative-start", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_INITIAL_NUMBER_OF_TILES_PROPERTY, game_properties[GAME_INITIAL_NUMBER_OF_TILES_PROPERTY] = g_param_spec_uchar ("initial-number-of-tiles", "initial-number-of-tiles", "initial-number-of-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_IS_COMPLETE_PROPERTY, game_properties[GAME_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_LIGHT_TILES_PROPERTY, game_properties[GAME_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_DARK_TILES_PROPERTY, game_properties[GAME_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_properties[GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_COLOR_PROPERTY, game_properties[GAME_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	game_signals[GAME_TURN_ENDED_SIGNAL] = g_signal_new ("turn-ended", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);
	game_signals[GAME_COMPLETENESS_UPDATED_SIGNAL] = g_signal_new ("completeness-updated", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
	GListStore* _tmp0_;
	self->priv = game_get_instance_private (self);
	_tmp0_ = g_list_store_new (TYPE_GAME_STATE_OBJECT);
	self->priv->undo_stack = _tmp0_;
}

static void
game_finalize (GObject * obj)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
	_g_object_unref0 (self->priv->undo_stack);
	_g_object_unref0 (self->priv->_current_state);
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
	(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_NUMBER_OF_MOVES_PROPERTY:
		g_value_set_uchar (value, game_get_number_of_moves (self));
		break;
		case GAME_SIZE_PROPERTY:
		g_value_set_uchar (value, game_get_size (self));
		break;
		case GAME_CURRENT_STATE_PROPERTY:
		g_value_set_object (value, game_get_current_state (self));
		break;
		case GAME_ALTERNATIVE_START_PROPERTY:
		g_value_set_boolean (value, game_get_alternative_start (self));
		break;
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
		g_value_set_uchar (value, game_get_initial_number_of_tiles (self));
		break;
		case GAME_IS_COMPLETE_PROPERTY:
		g_value_set_boolean (value, game_get_is_complete (self));
		break;
		case GAME_N_LIGHT_TILES_PROPERTY:
		g_value_set_uchar (value, game_get_n_light_tiles (self));
		break;
		case GAME_N_DARK_TILES_PROPERTY:
		g_value_set_uchar (value, game_get_n_dark_tiles (self));
		break;
		case GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
		g_value_set_boolean (value, game_get_current_player_can_move (self));
		break;
		case GAME_CURRENT_COLOR_PROPERTY:
		g_value_set_enum (value, game_get_current_color (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_SIZE_PROPERTY:
		game_set_size (self, g_value_get_uchar (value));
		break;
		case GAME_CURRENT_STATE_PROPERTY:
		game_set_current_state (self, g_value_get_object (value));
		break;
		case GAME_ALTERNATIVE_START_PROPERTY:
		game_set_alternative_start (self, g_value_get_boolean (value));
		break;
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
		game_set_initial_number_of_tiles (self, g_value_get_uchar (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

