/* reversi-view.c generated by valac 0.46.2, the Vala compiler
 * generated from reversi-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <librsvg/rsvg.h>

#define TYPE_REVERSI_VIEW (reversi_view_get_type ())
#define REVERSI_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REVERSI_VIEW, ReversiView))
#define REVERSI_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REVERSI_VIEW, ReversiViewClass))
#define IS_REVERSI_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REVERSI_VIEW))
#define IS_REVERSI_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REVERSI_VIEW))
#define REVERSI_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REVERSI_VIEW, ReversiViewClass))

typedef struct _ReversiView ReversiView;
typedef struct _ReversiViewClass ReversiViewClass;
typedef struct _ReversiViewPrivate ReversiViewPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;

#define TYPE_IAGNO (iagno_get_type ())
#define IAGNO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IAGNO, Iagno))
#define IAGNO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IAGNO, IagnoClass))
#define IS_IAGNO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IAGNO))
#define IS_IAGNO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IAGNO))
#define IAGNO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IAGNO, IagnoClass))

typedef struct _Iagno Iagno;
typedef struct _IagnoClass IagnoClass;

#define TYPE_GAME_STATE_OBJECT (game_state_object_get_type ())
#define GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_STATE_OBJECT, GameStateObject))
#define GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))
#define IS_GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_STATE_OBJECT))
#define IS_GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_STATE_OBJECT))
#define GAME_STATE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))

typedef struct _GameStateObject GameStateObject;
typedef struct _GameStateObjectClass GameStateObjectClass;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	REVERSI_VIEW_0_PROPERTY,
	REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY,
	REVERSI_VIEW_SOUND_FLIP_PROPERTY,
	REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY,
	REVERSI_VIEW_GAME_PROPERTY,
	REVERSI_VIEW_THEME_PROPERTY,
	REVERSI_VIEW_NUM_PROPERTIES
};
static GParamSpec* reversi_view_properties[REVERSI_VIEW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

#define TYPE_COMPUTER_PLAYER (computer_player_get_type ())
#define COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayer))
#define COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))
#define IS_COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_PLAYER))
#define IS_COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_PLAYER))
#define COMPUTER_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))

typedef struct _ComputerPlayer ComputerPlayer;
typedef struct _ComputerPlayerClass ComputerPlayerClass;

#define TYPE_POSSIBLE_MOVE (possible_move_get_type ())
typedef struct _PossibleMove PossibleMove;
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
enum  {
	REVERSI_VIEW_MOVE_SIGNAL,
	REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL,
	REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL,
	REVERSI_VIEW_NUM_SIGNALS
};
static guint reversi_view_signals[REVERSI_VIEW_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ReversiView {
	GtkDrawingArea parent_instance;
	ReversiViewPrivate * priv;
};

struct _ReversiViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _ReversiViewPrivate {
	gboolean _show_turnable_tiles;
	gchar* pieces_file;
	gdouble background_red;
	gdouble background_green;
	gdouble background_blue;
	gint background_radius;
	gdouble texture_alpha;
	gboolean apply_texture;
	gdouble mark_red;
	gdouble mark_green;
	gdouble mark_blue;
	gint mark_width;
	gdouble border_red;
	gdouble border_green;
	gdouble border_blue;
	gint border_width;
	gdouble half_border_width;
	gdouble spacing_red;
	gdouble spacing_green;
	gdouble spacing_blue;
	gint spacing_width;
	gdouble highlight_hard_red;
	gdouble highlight_hard_green;
	gdouble highlight_hard_blue;
	gdouble highlight_hard_alpha;
	gdouble highlight_soft_red;
	gdouble highlight_soft_green;
	gdouble highlight_soft_blue;
	gdouble highlight_soft_alpha;
	gchar* _sound_flip;
	gchar* _sound_gameover;
	gint board_x;
	gint board_y;
	gboolean show_highlight;
	gboolean highlight_set;
	guint8 highlight_x;
	guint8 highlight_y;
	guint8 old_highlight_x;
	guint8 old_highlight_y;
	guint8 highlight_state;
	gboolean show_mouse_highlight;
	gboolean mouse_position_set;
	guint8 mouse_highlight_x;
	guint8 mouse_highlight_y;
	guint8 mouse_position_x;
	guint8 mouse_position_y;
	guint render_size;
	cairo_pattern_t* tiles_pattern;
	cairo_pattern_t* board_pattern;
	gboolean noise_pixbuf_loaded;
	gint* pixmaps;
	gint pixmaps_length1;
	gint pixmaps_length2;
	guint animate_timeout;
	gboolean game_is_set;
	guint8 game_size;
	Game* _game;
	Iagno* iagno_instance;
	gchar* _theme;
	gint paving_size;
	gint tile_size;
	gint board_size;
	gint* tile_xs;
	gint tile_xs_length1;
	gint tile_xs_length2;
	gint* tile_ys;
	gint tile_ys_length1;
	gint tile_ys_length2;
	gboolean last_state_set;
	GameStateObject* last_state;
	gboolean flip_final_result_now;
	Player winning_color;
	gint n_winning_tiles;
	Player losing_color;
	gint n_losing_tiles;
	GtkEventControllerMotion* motion_controller;
	gboolean mouse_is_in;
	guint timeout_id;
	guint8 playable_tiles_highlight_state;
	gboolean* possible_moves;
	gint possible_moves_length1;
	gint possible_moves_length2;
};

struct _PossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
	guint8 n_tiles_n;
	guint8 n_tiles_ne;
	guint8 n_tiles_e;
	guint8 n_tiles_se;
	guint8 n_tiles_s;
	guint8 n_tiles_so;
	guint8 n_tiles_o;
	guint8 n_tiles_no;
};

struct _Block7Data {
	int _ref_count_;
	ReversiView* self;
	gboolean is_final_animation;
};

struct _Block8Data {
	int _ref_count_;
	ReversiView* self;
	guint8 x;
	guint8 y;
};

static gint ReversiView_private_offset;
static gpointer reversi_view_parent_class = NULL;

GType reversi_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ReversiView, g_object_unref)
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
GType iagno_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Iagno, g_object_unref)
GType game_state_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameStateObject, g_object_unref)
GType player_get_type (void) G_GNUC_CONST;
#define REVERSI_VIEW_HIGHLIGHT_MAX ((guint8) 5)
#define REVERSI_VIEW_PIXMAP_FLIP_DELAY 20
#define REVERSI_VIEW_HALF_PI G_PI_2
ReversiView* reversi_view_new (Iagno* iagno_instance);
ReversiView* reversi_view_construct (GType object_type,
                                     Iagno* iagno_instance);
void reversi_view_theme_changed (ReversiView* self);
const gchar* reversi_view_get_theme (ReversiView* self);
void reversi_view_set_theme (ReversiView* self,
                             const gchar* value);
static void reversi_view_set_default_theme (ReversiView* self,
                                     GKeyFile* * key);
static void reversi_view_load_theme (ReversiView* self,
                              GKeyFile* key);
static void reversi_view_set_sound_flip (ReversiView* self,
                                  const gchar* value);
static void reversi_view_set_sound_gameover (ReversiView* self,
                                      const gchar* value);
static inline void reversi_view_calculate (ReversiView* self);
static gboolean reversi_view_real_draw (GtkWidget* base,
                                 cairo_t* cr);
static inline void reversi_view_init_patterns (ReversiView* self,
                                 cairo_t* cr);
static inline void reversi_view_draw_highlight (ReversiView* self,
                                  cairo_t* cr);
static inline void reversi_view_add_highlights (ReversiView* self,
                                  cairo_t* cr);
static inline void reversi_view_draw_playables (ReversiView* self,
                                  cairo_t* cr);
static void reversi_view_load_image (ReversiView* self,
                              cairo_t* c,
                              gint width,
                              gint height);
static inline void reversi_view_draw_board_background (ReversiView* self,
                                         cairo_t* cr);
static inline void reversi_view_draw_tiles_background (ReversiView* self,
                                         cairo_t* cr,
                                         cairo_pattern_t* * noise_pattern);
static inline void reversi_view_draw_tile_background (ReversiView* self,
                                        cairo_t* cr,
                                        cairo_pattern_t* * noise_pattern,
                                        gint tile_x,
                                        gint tile_y);
static void reversi_view_rounded_square (ReversiView* self,
                                  cairo_t* cr,
                                  gdouble x,
                                  gdouble y,
                                  gint size,
                                  gdouble width,
                                  gdouble radius_percent);
Game* reversi_view_get_game (ReversiView* self);
gboolean game_get_is_complete (Game* self);
Player iagno_get_player_one (Iagno* self);
Player game_get_current_color (Game* self);
GType computer_player_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerPlayer, g_object_unref)
ComputerPlayer* iagno_get_computer (Iagno* self);
static inline void reversi_view_draw_tile_highlight (ReversiView* self,
                                       cairo_t* cr,
                                       guint8 x,
                                       guint8 y);
GType possible_move_get_type (void) G_GNUC_CONST;
PossibleMove* possible_move_dup (const PossibleMove* self);
void possible_move_free (PossibleMove* self);
gboolean game_test_placing_tile (Game* self,
                                 guint8 x,
                                 guint8 y,
                                 PossibleMove* move);
static void reversi_view_queue_draw_tile (ReversiView* self,
                                   guint8 x,
                                   guint8 y);
static void reversi_view_highlight_tile (ReversiView* self,
                                  cairo_t* cr,
                                  guint8 x,
                                  guint8 y,
                                  guint8 intensity,
                                  gboolean soft_highlight);
static gboolean reversi_view_get_show_turnable_tiles (ReversiView* self);
static inline void reversi_view_highlight_turnable_tiles (ReversiView* self,
                                            cairo_t* cr,
                                            guint8 x,
                                            guint8 y,
                                            gint8 x_step,
                                            gint8 y_step,
                                            guint8 count);
static void reversi_view_init_possible_moves (ReversiView* self);
static inline void reversi_view_add_highlight (ReversiView* self,
                                 cairo_t* cr,
                                 guint8 x,
                                 guint8 y,
                                 guint8 intensity);
static inline void reversi_view_draw_playable (ReversiView* self,
                                 cairo_t* cr,
                                 gint pixmap,
                                 gint tile_x,
                                 gint tile_y);
static inline void reversi_view_update_highlight_after_undo (ReversiView* self);
static void reversi_view_get_missing_tile (ReversiView* self,
                                    guint8* x,
                                    guint8* y);
static void reversi_view_set_square (ReversiView* self,
                              guint8 x,
                              guint8 y,
                              gint pixmap,
                              gboolean is_final_animation,
                              gboolean force_redraw);
static gint reversi_view_get_pixmap (Player color);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
Player game_state_object_get_owner (GameStateObject* self,
                                    guint8 x,
                                    guint8 y);
static void reversi_view_turn_ended_cb (ReversiView* self,
                                 gboolean undoing,
                                 gboolean no_draw);
static inline void reversi_view_update_squares (ReversiView* self);
GameStateObject* game_get_current_state (Game* self);
static inline void reversi_view_update_square (ReversiView* self,
                                 guint8 x,
                                 guint8 y);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean ____lambda17_ (Block7Data* _data7_);
static void reversi_view_flip_final_result_tile (ReversiView* self,
                                          guint8 x,
                                          guint8 y);
static void _reversi_view_on_motion (ReversiView* self,
                              guint8 x,
                              guint8 y,
                              gboolean force_redraw);
static gboolean _____lambda17__gsource_func (gpointer self);
static void reversi_view_game_is_complete_cb (ReversiView* self);
guint8 game_get_n_light_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
static gboolean ___lambda16_ (ReversiView* self);
static void reversi_view_set_winner_and_loser_variables (ReversiView* self);
static gboolean ____lambda16__gsource_func (gpointer self);
gboolean reversi_view_undo_final_animation (ReversiView* self);
static void reversi_view_init_mouse (ReversiView* self);
static void reversi_view_on_motion (ReversiView* self,
                             GtkEventControllerMotion* _motion_controller,
                             gdouble event_x,
                             gdouble event_y);
static void _reversi_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean reversi_view_real_enter_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static gboolean reversi_view_pointer_is_in_board (ReversiView* self,
                                           gdouble pos_x,
                                           gdouble pos_y,
                                           guint8* x,
                                           guint8* y);
static void reversi_view_on_cursor_moving_in (ReversiView* self,
                                       guint8 x,
                                       guint8 y);
static gboolean reversi_view_real_leave_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean ______lambda18_ (Block8Data* _data8_);
static gboolean _______lambda18__gsource_func (gpointer self);
static gboolean reversi_view_real_button_press_event (GtkWidget* base,
                                               GdkEventButton* event);
static inline void reversi_view_move_if_possible (ReversiView* self,
                                    guint8 x,
                                    guint8 y);
static gboolean reversi_view_real_key_press_event (GtkWidget* base,
                                            GdkEventKey* event);
static inline void reversi_view_highlight_playable_tiles (ReversiView* self);
void game_get_possible_moves (Game* self,
                              GSList* * moves);
static void _possible_move_free0_ (gpointer var);
static inline void _g_slist_free__possible_move_free0_ (GSList* self);
static void __lambda19_ (ReversiView* self,
                  PossibleMove* move);
static void ___lambda19__gfunc (gconstpointer data,
                         gpointer self);
void reversi_view_set_show_turnable_tiles (ReversiView* self,
                                           gboolean value);
const gchar* reversi_view_get_sound_flip (ReversiView* self);
const gchar* reversi_view_get_sound_gameover (ReversiView* self);
void reversi_view_set_game (ReversiView* self,
                            Game* value);
guint8 game_get_size (Game* self);
static void _reversi_view_game_is_complete_cb_game_completeness_updated (Game* _sender,
                                                                  gboolean completeness,
                                                                  gpointer self);
static void _reversi_view_turn_ended_cb_game_turn_ended (Game* _sender,
                                                  gboolean undoing,
                                                  gboolean no_draw,
                                                  gpointer self);
gboolean game_get_alternative_start (Game* self);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * reversi_view_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void reversi_view_finalize (GObject * obj);
static void _vala_reversi_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_reversi_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
reversi_view_get_instance_private (ReversiView* self)
{
	return G_STRUCT_MEMBER_P (self, ReversiView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

ReversiView*
reversi_view_construct (GType object_type,
                        Iagno* iagno_instance)
{
	ReversiView * self = NULL;
	Iagno* _tmp0_;
	g_return_val_if_fail (iagno_instance != NULL, NULL);
	self = (ReversiView*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (iagno_instance);
	_g_object_unref0 (self->priv->iagno_instance);
	self->priv->iagno_instance = _tmp0_;
	return self;
}

ReversiView*
reversi_view_new (Iagno* iagno_instance)
{
	return reversi_view_construct (TYPE_REVERSI_VIEW, iagno_instance);
}

void
reversi_view_theme_changed (ReversiView* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp1_ = reversi_view_get_theme (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = reversi_view_get_theme (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = g_strcmp0 ((const gchar*) _tmp4_, "default") == 0;
	}
	if (_tmp0_) {
		reversi_view_set_theme (self, "default");
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
reversi_view_set_default_theme (ReversiView* self,
                                GKeyFile* * key)
{
	GtkSettings* defaults = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gchar* filename = NULL;
	gboolean _tmp2_ = FALSE;
	GtkSettings* _tmp3_;
	gchar* filepath = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (*key != NULL);
	_tmp0_ = gtk_settings_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	defaults = _tmp1_;
	_tmp3_ = defaults;
	if (_tmp3_ != NULL) {
		GtkSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp4_ = defaults;
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp5_, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = _tmp6_;
		_tmp2_ = string_contains (_tmp7_, "HighContrast");
		_g_free0 (_tmp7_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gchar* _tmp8_;
		_tmp8_ = g_strdup ("high_contrast.theme");
		_g_free0 (filename);
		filename = _tmp8_;
	} else {
		gboolean _tmp9_ = FALSE;
		GtkSettings* _tmp10_;
		_tmp10_ = defaults;
		if (_tmp10_ != NULL) {
			gboolean _tmp11_ = FALSE;
			GtkSettings* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
			_tmp12_ = defaults;
			g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_settings_get_type (), GtkSettings), "gtk-application-prefer-dark-theme", &_tmp13_, NULL);
			_tmp14_ = _tmp13_;
			if (_tmp14_ == TRUE) {
				_tmp11_ = TRUE;
			} else {
				GtkSettings* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				_tmp15_ = defaults;
				g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp16_, NULL);
				_tmp17_ = _tmp16_;
				_tmp18_ = _tmp17_;
				_tmp11_ = g_strcmp0 (_tmp18_, "Adwaita-dark") == 0;
				_g_free0 (_tmp18_);
			}
			_tmp9_ = _tmp11_;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			gchar* _tmp19_;
			_tmp19_ = g_strdup ("adwaita.theme");
			_g_free0 (filename);
			filename = _tmp19_;
		} else {
			gchar* _tmp20_;
			_tmp20_ = g_strdup ("classic.theme");
			_g_free0 (filename);
			filename = _tmp20_;
		}
	}
	_tmp21_ = filename;
	_tmp22_ = g_build_filename (DATA_DIRECTORY, "themes", "key", _tmp21_, NULL);
	filepath = _tmp22_;
	{
		g_key_file_load_from_file (*key, filepath, G_KEY_FILE_NONE, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch7_g_error;
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		g_clear_error (&_inner_error0_);
		_inner_error0_ = NULL;
		g_assert_not_reached ();
	}
	__finally7:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (filepath);
		_g_free0 (filename);
		_g_object_unref0 (defaults);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (filepath);
	_g_free0 (filename);
	_g_object_unref0 (defaults);
}

static void
reversi_view_load_theme (ReversiView* self,
                         GKeyFile* key)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	{
		gchar* svg_path = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gboolean _tmp9_;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gint _tmp15_ = 0;
		gdouble _tmp16_ = 0.0;
		gboolean _tmp17_ = FALSE;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		gdouble _tmp20_ = 0.0;
		gint _tmp21_ = 0;
		gdouble _tmp22_ = 0.0;
		gdouble _tmp23_ = 0.0;
		gdouble _tmp24_ = 0.0;
		gint _tmp25_ = 0;
		gdouble _tmp26_ = 0.0;
		gdouble _tmp27_ = 0.0;
		gdouble _tmp28_ = 0.0;
		gint _tmp29_ = 0;
		gdouble _tmp30_ = 0.0;
		gdouble _tmp31_ = 0.0;
		gdouble _tmp32_ = 0.0;
		gdouble _tmp33_ = 0.0;
		gdouble _tmp34_ = 0.0;
		gdouble _tmp35_ = 0.0;
		gdouble _tmp36_ = 0.0;
		gdouble _tmp37_ = 0.0;
		gchar* _tmp38_ = NULL;
		gchar* _tmp39_;
		gchar* _tmp40_ = NULL;
		gchar* _tmp41_;
		_tmp0_ = g_build_filename (DATA_DIRECTORY, "themes", "svg", NULL);
		svg_path = _tmp0_;
		_tmp2_ = g_key_file_get_string (key, "Pieces", "File", &_inner_error0_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp3_ = svg_path;
		_tmp4_ = g_build_filename (_tmp3_, _tmp1_, NULL);
		_g_free0 (self->priv->pieces_file);
		self->priv->pieces_file = _tmp4_;
		_tmp5_ = self->priv->pieces_file;
		_tmp6_ = g_path_get_dirname (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = svg_path;
		_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
		_g_free0 (_tmp7_);
		if (_tmp9_) {
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp10_ = svg_path;
			_tmp11_ = g_build_filename (_tmp10_, "black_and_white.svg", NULL);
			_g_free0 (self->priv->pieces_file);
			self->priv->pieces_file = _tmp11_;
		}
		_tmp12_ = g_key_file_get_double (key, "Background", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->background_red = _tmp12_;
		_tmp13_ = g_key_file_get_double (key, "Background", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->background_green = _tmp13_;
		_tmp14_ = g_key_file_get_double (key, "Background", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->background_blue = _tmp14_;
		_tmp15_ = g_key_file_get_integer (key, "Background", "Radius", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->background_radius = _tmp15_;
		_tmp16_ = g_key_file_get_double (key, "Background", "TextureAlpha", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->texture_alpha = _tmp16_;
		if (self->priv->texture_alpha > 0.0) {
			_tmp17_ = self->priv->texture_alpha <= 1.0;
		} else {
			_tmp17_ = FALSE;
		}
		self->priv->apply_texture = _tmp17_;
		_tmp18_ = g_key_file_get_double (key, "Mark", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->mark_red = _tmp18_;
		_tmp19_ = g_key_file_get_double (key, "Mark", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->mark_green = _tmp19_;
		_tmp20_ = g_key_file_get_double (key, "Mark", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->mark_blue = _tmp20_;
		_tmp21_ = g_key_file_get_integer (key, "Mark", "Width", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->mark_width = _tmp21_;
		_tmp22_ = g_key_file_get_double (key, "Border", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->border_red = _tmp22_;
		_tmp23_ = g_key_file_get_double (key, "Border", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->border_green = _tmp23_;
		_tmp24_ = g_key_file_get_double (key, "Border", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->border_blue = _tmp24_;
		_tmp25_ = g_key_file_get_integer (key, "Border", "Width", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->border_width = _tmp25_;
		self->priv->half_border_width = ((gdouble) self->priv->border_width) / 2.0;
		_tmp26_ = g_key_file_get_double (key, "Spacing", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->spacing_red = _tmp26_;
		_tmp27_ = g_key_file_get_double (key, "Spacing", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->spacing_green = _tmp27_;
		_tmp28_ = g_key_file_get_double (key, "Spacing", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->spacing_blue = _tmp28_;
		_tmp29_ = g_key_file_get_integer (key, "Spacing", "Width", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->spacing_width = _tmp29_;
		_tmp30_ = g_key_file_get_double (key, "Highlight hard", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_hard_red = _tmp30_;
		_tmp31_ = g_key_file_get_double (key, "Highlight hard", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_hard_green = _tmp31_;
		_tmp32_ = g_key_file_get_double (key, "Highlight hard", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_hard_blue = _tmp32_;
		_tmp33_ = g_key_file_get_double (key, "Highlight hard", "Alpha", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_hard_alpha = _tmp33_;
		_tmp34_ = g_key_file_get_double (key, "Highlight soft", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_soft_red = _tmp34_;
		_tmp35_ = g_key_file_get_double (key, "Highlight soft", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_soft_green = _tmp35_;
		_tmp36_ = g_key_file_get_double (key, "Highlight soft", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_soft_blue = _tmp36_;
		_tmp37_ = g_key_file_get_double (key, "Highlight soft", "Alpha", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_soft_alpha = _tmp37_;
		_tmp39_ = g_key_file_get_string (key, "Sound", "Flip", &_inner_error0_);
		_tmp38_ = _tmp39_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		reversi_view_set_sound_flip (self, _tmp38_);
		_tmp41_ = g_key_file_get_string (key, "Sound", "GameOver", &_inner_error0_);
		_tmp40_ = _tmp41_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp38_);
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		reversi_view_set_sound_gameover (self, _tmp40_);
		_g_free0 (_tmp40_);
		_g_free0 (_tmp38_);
		_g_free0 (_tmp1_);
		_g_free0 (svg_path);
	}
	goto __finally8;
	__catch8_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp42_ = e;
		_tmp43_ = _tmp42_->message;
		g_warning ("reversi-view.vala:287: Errors when loading theme: %s", _tmp43_);
		_g_error_free0 (e);
	}
	__finally8:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static inline void
reversi_view_calculate (ReversiView* self)
{
	gint allocated_width = 0;
	gint allocated_height = 0;
	gint size = 0;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
	allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	size = MIN (allocated_width, allocated_height);
	self->priv->paving_size = ((size - (2 * self->priv->border_width)) + self->priv->spacing_width) / self->priv->game_size;
	self->priv->tile_size = self->priv->paving_size - self->priv->spacing_width;
	self->priv->board_size = ((self->priv->paving_size * self->priv->game_size) - self->priv->spacing_width) + (2 * self->priv->border_width);
	self->priv->board_x = ((allocated_width - self->priv->board_size) / 2) + self->priv->border_width;
	self->priv->board_y = ((allocated_height - self->priv->board_size) / 2) + self->priv->border_width;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							if (!_tmp2_) {
								guint8 _tmp3_;
								_tmp3_ = y;
								y = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							_tmp4_ = self->priv->tile_xs;
							_tmp4__length1 = self->priv->tile_xs_length1;
							_tmp4__length2 = self->priv->tile_xs_length2;
							_tmp4_[(x * _tmp4__length2) + y] = self->priv->paving_size * ((gint) x);
							_tmp5_ = self->priv->tile_ys;
							_tmp5__length1 = self->priv->tile_ys_length1;
							_tmp5__length2 = self->priv->tile_ys_length2;
							_tmp5_[(x * _tmp5__length2) + y] = self->priv->paving_size * ((gint) y);
						}
					}
				}
			}
		}
	}
}

static gboolean
reversi_view_real_draw (GtkWidget* base,
                        cairo_t* cr)
{
	ReversiView * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp4_;
	gboolean result = FALSE;
	self = (ReversiView*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	if (!self->priv->game_is_set) {
		result = FALSE;
		return result;
	}
	reversi_view_calculate (self);
	_tmp2_ = self->priv->board_pattern;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		cairo_pattern_t* _tmp3_;
		_tmp3_ = self->priv->tiles_pattern;
		_tmp1_ = _tmp3_ == NULL;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->render_size != ((guint) self->priv->tile_size);
	}
	if (_tmp0_) {
		reversi_view_init_patterns (self, cr);
	}
	cairo_translate (cr, (gdouble) (self->priv->board_x - self->priv->border_width), (gdouble) (self->priv->board_y - self->priv->border_width));
	_tmp4_ = self->priv->board_pattern;
	cairo_set_source (cr, (cairo_pattern_t*) _tmp4_);
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) self->priv->board_size, (gdouble) self->priv->board_size);
	cairo_fill (cr);
	cairo_translate (cr, (gdouble) self->priv->border_width, (gdouble) self->priv->border_width);
	reversi_view_draw_highlight (self, cr);
	reversi_view_add_highlights (self, cr);
	reversi_view_draw_playables (self, cr);
	result = FALSE;
	return result;
}

static inline void
reversi_view_init_patterns (ReversiView* self,
                            cairo_t* cr)
{
	cairo_surface_t* surface = NULL;
	cairo_t* context = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_surface_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	GdkPixbuf* noise_pixbuf = NULL;
	cairo_pattern_t* noise_pattern = NULL;
	cairo_surface_t* _tmp22_;
	cairo_surface_t* _tmp23_;
	cairo_surface_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	cairo_surface_t* _tmp28_;
	cairo_pattern_t* _tmp29_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	self->priv->render_size = (guint) self->priv->tile_size;
	_tmp0_ = cairo_get_target (cr);
	_tmp1_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size * 8, self->priv->tile_size * 4);
	_cairo_surface_destroy0 (surface);
	surface = _tmp1_;
	_tmp2_ = surface;
	_tmp3_ = cairo_create (_tmp2_);
	_cairo_destroy0 (context);
	context = _tmp3_;
	_tmp4_ = context;
	reversi_view_load_image (self, _tmp4_, self->priv->tile_size * 8, self->priv->tile_size * 4);
	_tmp5_ = surface;
	_tmp6_ = cairo_pattern_create_for_surface (_tmp5_);
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
	self->priv->tiles_pattern = _tmp6_;
	noise_pixbuf = NULL;
	noise_pattern = NULL;
	if (self->priv->apply_texture) {
		GdkPixbuf* _tmp12_;
		{
			GdkPixbuf* _tmp7_ = NULL;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
			_tmp8_ = gdk_pixbuf_new_from_resource_at_scale ("/org/gnome/Reversi/ui/noise.png", self->priv->tile_size, self->priv->tile_size, FALSE, &_inner_error0_);
			_tmp7_ = _tmp8_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch9_g_error;
			}
			_tmp9_ = _tmp7_;
			_tmp7_ = NULL;
			_g_object_unref0 (noise_pixbuf);
			noise_pixbuf = _tmp9_;
			_g_object_unref0 (_tmp7_);
		}
		goto __finally9;
		__catch9_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp10_ = e;
			_tmp11_ = _tmp10_->message;
			g_warning ("reversi-view.vala:377: %s", _tmp11_);
			_g_error_free0 (e);
		}
		__finally9:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_cairo_pattern_destroy0 (noise_pattern);
			_g_object_unref0 (noise_pixbuf);
			_cairo_destroy0 (context);
			_cairo_surface_destroy0 (surface);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp12_ = noise_pixbuf;
		self->priv->noise_pixbuf_loaded = _tmp12_ != NULL;
		if (self->priv->noise_pixbuf_loaded) {
			cairo_surface_t* _tmp13_;
			cairo_surface_t* _tmp14_;
			cairo_surface_t* _tmp15_;
			cairo_t* _tmp16_;
			cairo_t* _tmp17_;
			GdkPixbuf* _tmp18_;
			cairo_t* _tmp19_;
			cairo_surface_t* _tmp20_;
			cairo_pattern_t* _tmp21_;
			_tmp13_ = cairo_get_target (cr);
			_tmp14_ = cairo_surface_create_similar (_tmp13_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size, self->priv->tile_size);
			_cairo_surface_destroy0 (surface);
			surface = _tmp14_;
			_tmp15_ = surface;
			_tmp16_ = cairo_create (_tmp15_);
			_cairo_destroy0 (context);
			context = _tmp16_;
			_tmp17_ = context;
			_tmp18_ = noise_pixbuf;
			gdk_cairo_set_source_pixbuf (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gdk_pixbuf_get_type (), GdkPixbuf), (gdouble) 0, (gdouble) 0);
			_tmp19_ = context;
			cairo_paint_with_alpha (_tmp19_, self->priv->texture_alpha);
			_tmp20_ = surface;
			_tmp21_ = cairo_pattern_create_for_surface (_tmp20_);
			_cairo_pattern_destroy0 (noise_pattern);
			noise_pattern = _tmp21_;
		}
	}
	_tmp22_ = cairo_get_target (cr);
	_tmp23_ = cairo_surface_create_similar (_tmp22_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->board_size, self->priv->board_size);
	_cairo_surface_destroy0 (surface);
	surface = _tmp23_;
	_tmp24_ = surface;
	_tmp25_ = cairo_create (_tmp24_);
	_cairo_destroy0 (context);
	context = _tmp25_;
	_tmp26_ = context;
	reversi_view_draw_board_background (self, _tmp26_);
	_tmp27_ = context;
	reversi_view_draw_tiles_background (self, _tmp27_, &noise_pattern);
	_tmp28_ = surface;
	_tmp29_ = cairo_pattern_create_for_surface (_tmp28_);
	_cairo_pattern_destroy0 (self->priv->board_pattern);
	self->priv->board_pattern = _tmp29_;
	_cairo_pattern_destroy0 (noise_pattern);
	_g_object_unref0 (noise_pixbuf);
	_cairo_destroy0 (context);
	_cairo_surface_destroy0 (surface);
}

static inline void
reversi_view_draw_board_background (ReversiView* self,
                                    cairo_t* cr)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	cairo_set_source_rgba (cr, self->priv->spacing_red, self->priv->spacing_green, self->priv->spacing_blue, 1.0);
	cairo_rectangle (cr, self->priv->half_border_width, self->priv->half_border_width, (gdouble) (self->priv->board_size - self->priv->border_width), (gdouble) (self->priv->board_size - self->priv->border_width));
	cairo_fill_preserve (cr);
	cairo_set_source_rgba (cr, self->priv->border_red, self->priv->border_green, self->priv->border_blue, 1.0);
	cairo_set_line_width (cr, (gdouble) self->priv->border_width);
	cairo_stroke (cr);
}

static inline void
reversi_view_draw_tiles_background (ReversiView* self,
                                    cairo_t* cr,
                                    cairo_pattern_t* * noise_pattern)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	cairo_translate (cr, (gdouble) self->priv->border_width, (gdouble) self->priv->border_width);
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gint* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gint _tmp7_;
							if (!_tmp2_) {
								guint8 _tmp3_;
								_tmp3_ = y;
								y = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							_tmp4_ = self->priv->tile_xs;
							_tmp4__length1 = self->priv->tile_xs_length1;
							_tmp4__length2 = self->priv->tile_xs_length2;
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
							_tmp6_ = self->priv->tile_ys;
							_tmp6__length1 = self->priv->tile_ys_length1;
							_tmp6__length2 = self->priv->tile_ys_length2;
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
							reversi_view_draw_tile_background (self, cr, noise_pattern, _tmp5_, _tmp7_);
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_draw_tile_background (ReversiView* self,
                                   cairo_t* cr,
                                   cairo_pattern_t* * noise_pattern,
                                   gint tile_x,
                                   gint tile_y)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	cairo_set_source_rgba (cr, self->priv->background_red, self->priv->background_green, self->priv->background_blue, 1.0);
	reversi_view_rounded_square (self, cr, (gdouble) tile_x, (gdouble) tile_y, self->priv->tile_size, (gdouble) 0, (gdouble) self->priv->background_radius);
	if (self->priv->apply_texture) {
		_tmp0_ = self->priv->noise_pixbuf_loaded;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		cairo_matrix_t matrix = {0};
		cairo_matrix_t _tmp1_;
		cairo_fill_preserve (cr);
		cairo_matrix_init_identity (&matrix);
		cairo_matrix_translate (&matrix, (gdouble) (-tile_x), (gdouble) (-tile_y));
		_tmp1_ = matrix;
		cairo_pattern_set_matrix ((cairo_pattern_t*) (*noise_pattern), &_tmp1_);
		cairo_set_source (cr, (cairo_pattern_t*) (*noise_pattern));
	}
	cairo_fill (cr);
}

static inline void
reversi_view_draw_highlight (ReversiView* self,
                             cairo_t* cr)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean display_mouse_highlight = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean display_keybd_highlight = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean display_ghost_highlight = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = reversi_view_get_game (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_is_complete (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		return;
	}
	if (!self->priv->show_highlight) {
		gboolean _tmp6_ = FALSE;
		if (self->priv->show_mouse_highlight) {
			_tmp6_ = TRUE;
		} else {
			_tmp6_ = ((gint) self->priv->highlight_state) != 0;
		}
		_tmp5_ = _tmp6_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		gboolean _tmp7_ = FALSE;
		Iagno* _tmp8_;
		Player _tmp9_;
		Player _tmp10_;
		Game* _tmp11_;
		Game* _tmp12_;
		Player _tmp13_;
		Player _tmp14_;
		_tmp8_ = self->priv->iagno_instance;
		_tmp9_ = iagno_get_player_one (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = reversi_view_get_game (self);
		_tmp12_ = _tmp11_;
		_tmp13_ = game_get_current_color (_tmp12_);
		_tmp14_ = _tmp13_;
		if (_tmp10_ == _tmp14_) {
			_tmp7_ = TRUE;
		} else {
			Iagno* _tmp15_;
			ComputerPlayer* _tmp16_;
			ComputerPlayer* _tmp17_;
			_tmp15_ = self->priv->iagno_instance;
			_tmp16_ = iagno_get_computer (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp7_ = _tmp17_ == NULL;
		}
		_tmp4_ = _tmp7_;
	} else {
		_tmp4_ = FALSE;
	}
	display_mouse_highlight = _tmp4_;
	if (self->priv->show_highlight) {
		_tmp18_ = !self->priv->show_mouse_highlight;
	} else {
		_tmp18_ = FALSE;
	}
	display_keybd_highlight = _tmp18_;
	if (!self->priv->show_highlight) {
		_tmp22_ = !self->priv->show_mouse_highlight;
	} else {
		_tmp22_ = FALSE;
	}
	if (_tmp22_) {
		_tmp21_ = ((gint) self->priv->highlight_state) != 0;
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		_tmp20_ = self->priv->old_highlight_x != G_MAXUINT8;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		_tmp19_ = self->priv->old_highlight_y != G_MAXUINT8;
	} else {
		_tmp19_ = FALSE;
	}
	display_ghost_highlight = _tmp19_;
	if (display_ghost_highlight) {
		reversi_view_draw_tile_highlight (self, cr, self->priv->old_highlight_x, self->priv->old_highlight_y);
	} else {
		if (display_mouse_highlight) {
			reversi_view_draw_tile_highlight (self, cr, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
		} else {
			if (display_keybd_highlight) {
				reversi_view_draw_tile_highlight (self, cr, self->priv->highlight_x, self->priv->highlight_y);
			}
		}
	}
}

static inline void
reversi_view_draw_tile_highlight (ReversiView* self,
                                  cairo_t* cr,
                                  guint8 x,
                                  guint8 y)
{
	PossibleMove move = {0};
	gboolean test_placing_tile = FALSE;
	Game* _tmp0_;
	Game* _tmp1_;
	PossibleMove _tmp2_ = {0};
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean highlight_on = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = reversi_view_get_game (self);
	_tmp1_ = _tmp0_;
	_tmp3_ = game_test_placing_tile (_tmp1_, x, y, &_tmp2_);
	move = _tmp2_;
	test_placing_tile = _tmp3_;
	if (self->priv->show_highlight) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		if (self->priv->mouse_is_in) {
			_tmp6_ = self->priv->show_mouse_highlight;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			_tmp5_ = test_placing_tile;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp4_ = _tmp5_;
	}
	highlight_on = _tmp4_;
	if (highlight_on) {
		_tmp7_ = self->priv->highlight_state != REVERSI_VIEW_HIGHLIGHT_MAX;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		guint8 _tmp8_;
		_tmp8_ = self->priv->highlight_state;
		self->priv->highlight_state = _tmp8_ + 1;
		reversi_view_queue_draw_tile (self, x, y);
	} else {
		gboolean _tmp9_ = FALSE;
		if (!highlight_on) {
			_tmp9_ = ((gint) self->priv->highlight_state) != 0;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			guint8 _tmp10_;
			gboolean _tmp11_ = FALSE;
			_tmp10_ = self->priv->highlight_state;
			self->priv->highlight_state = _tmp10_ - 1;
			reversi_view_queue_draw_tile (self, x, y);
			if (self->priv->old_highlight_x != x) {
				_tmp11_ = TRUE;
			} else {
				_tmp11_ = self->priv->old_highlight_y != y;
			}
			if (_tmp11_) {
				return;
			}
		}
	}
	reversi_view_highlight_tile (self, cr, x, y, self->priv->highlight_state, FALSE);
	if (test_placing_tile) {
		gboolean _tmp14_;
		_tmp14_ = self->priv->_show_turnable_tiles;
		_tmp13_ = _tmp14_;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		gboolean _tmp15_ = FALSE;
		Iagno* _tmp16_;
		ComputerPlayer* _tmp17_;
		ComputerPlayer* _tmp18_;
		_tmp16_ = self->priv->iagno_instance;
		_tmp17_ = iagno_get_computer (_tmp16_);
		_tmp18_ = _tmp17_;
		if (_tmp18_ != NULL) {
			Iagno* _tmp19_;
			Player _tmp20_;
			Player _tmp21_;
			Game* _tmp22_;
			Game* _tmp23_;
			Player _tmp24_;
			Player _tmp25_;
			_tmp19_ = self->priv->iagno_instance;
			_tmp20_ = iagno_get_player_one (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = reversi_view_get_game (self);
			_tmp23_ = _tmp22_;
			_tmp24_ = game_get_current_color (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp15_ = _tmp21_ != _tmp25_;
		} else {
			_tmp15_ = FALSE;
		}
		_tmp12_ = !_tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		PossibleMove _tmp26_;
		PossibleMove _tmp27_;
		PossibleMove _tmp28_;
		PossibleMove _tmp29_;
		PossibleMove _tmp30_;
		PossibleMove _tmp31_;
		PossibleMove _tmp32_;
		PossibleMove _tmp33_;
		PossibleMove _tmp34_;
		PossibleMove _tmp35_;
		PossibleMove _tmp36_;
		PossibleMove _tmp37_;
		PossibleMove _tmp38_;
		PossibleMove _tmp39_;
		PossibleMove _tmp40_;
		PossibleMove _tmp41_;
		PossibleMove _tmp42_;
		PossibleMove _tmp43_;
		PossibleMove _tmp44_;
		PossibleMove _tmp45_;
		PossibleMove _tmp46_;
		PossibleMove _tmp47_;
		PossibleMove _tmp48_;
		PossibleMove _tmp49_;
		_tmp26_ = move;
		_tmp27_ = move;
		_tmp28_ = move;
		reversi_view_highlight_turnable_tiles (self, cr, _tmp26_.x, _tmp27_.y, (gint8) 0, (gint8) -1, _tmp28_.n_tiles_n);
		_tmp29_ = move;
		_tmp30_ = move;
		_tmp31_ = move;
		reversi_view_highlight_turnable_tiles (self, cr, _tmp29_.x, _tmp30_.y, (gint8) 1, (gint8) -1, _tmp31_.n_tiles_ne);
		_tmp32_ = move;
		_tmp33_ = move;
		_tmp34_ = move;
		reversi_view_highlight_turnable_tiles (self, cr, _tmp32_.x, _tmp33_.y, (gint8) 1, (gint8) 0, _tmp34_.n_tiles_e);
		_tmp35_ = move;
		_tmp36_ = move;
		_tmp37_ = move;
		reversi_view_highlight_turnable_tiles (self, cr, _tmp35_.x, _tmp36_.y, (gint8) 1, (gint8) 1, _tmp37_.n_tiles_se);
		_tmp38_ = move;
		_tmp39_ = move;
		_tmp40_ = move;
		reversi_view_highlight_turnable_tiles (self, cr, _tmp38_.x, _tmp39_.y, (gint8) 0, (gint8) 1, _tmp40_.n_tiles_s);
		_tmp41_ = move;
		_tmp42_ = move;
		_tmp43_ = move;
		reversi_view_highlight_turnable_tiles (self, cr, _tmp41_.x, _tmp42_.y, (gint8) -1, (gint8) 1, _tmp43_.n_tiles_so);
		_tmp44_ = move;
		_tmp45_ = move;
		_tmp46_ = move;
		reversi_view_highlight_turnable_tiles (self, cr, _tmp44_.x, _tmp45_.y, (gint8) -1, (gint8) 0, _tmp46_.n_tiles_o);
		_tmp47_ = move;
		_tmp48_ = move;
		_tmp49_ = move;
		reversi_view_highlight_turnable_tiles (self, cr, _tmp47_.x, _tmp48_.y, (gint8) -1, (gint8) -1, _tmp49_.n_tiles_no);
	}
}

static inline void
reversi_view_highlight_turnable_tiles (ReversiView* self,
                                       cairo_t* cr,
                                       guint8 x,
                                       guint8 y,
                                       gint8 x_step,
                                       gint8 y_step,
                                       guint8 count)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gint8 _x = 0;
			gint8 _y = 0;
			if (!_tmp0_) {
				guint8 _tmp1_;
				_tmp1_ = count;
				count = _tmp1_ - 1;
			}
			_tmp0_ = FALSE;
			if (!(((gint) count) > 0)) {
				break;
			}
			_x = ((gint8) x) + (((gint8) count) * x_step);
			_y = ((gint8) y) + (((gint8) count) * y_step);
			reversi_view_queue_draw_tile (self, (guint8) _x, (guint8) _y);
			reversi_view_highlight_tile (self, cr, (guint8) _x, (guint8) _y, self->priv->highlight_state, TRUE);
		}
	}
}

static inline void
reversi_view_add_highlights (ReversiView* self,
                             cairo_t* cr)
{
	gboolean _tmp0_ = FALSE;
	Iagno* _tmp1_;
	ComputerPlayer* _tmp2_;
	ComputerPlayer* _tmp3_;
	gboolean decreasing = FALSE;
	guint8 intensity = 0U;
	gboolean _tmp15_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	if (((gint) self->priv->playable_tiles_highlight_state) == 0) {
		return;
	}
	_tmp1_ = self->priv->iagno_instance;
	_tmp2_ = iagno_get_computer (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		Iagno* _tmp4_;
		Player _tmp5_;
		Player _tmp6_;
		Game* _tmp7_;
		Game* _tmp8_;
		Player _tmp9_;
		Player _tmp10_;
		_tmp4_ = self->priv->iagno_instance;
		_tmp5_ = iagno_get_player_one (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = reversi_view_get_game (self);
		_tmp8_ = _tmp7_;
		_tmp9_ = game_get_current_color (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp0_ = _tmp6_ != _tmp10_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		reversi_view_init_possible_moves (self);
		return;
	}
	decreasing = self->priv->playable_tiles_highlight_state > REVERSI_VIEW_HIGHLIGHT_MAX;
	if (decreasing) {
		intensity = (guint8) (((2 * REVERSI_VIEW_HIGHLIGHT_MAX) + 1) - self->priv->playable_tiles_highlight_state);
	} else {
		intensity = self->priv->playable_tiles_highlight_state;
	}
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				if (!_tmp11_) {
					guint8 _tmp12_;
					_tmp12_ = x;
					x = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp13_ = FALSE;
						_tmp13_ = TRUE;
						while (TRUE) {
							if (!_tmp13_) {
								guint8 _tmp14_;
								_tmp14_ = y;
								y = _tmp14_ + 1;
							}
							_tmp13_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							reversi_view_add_highlight (self, cr, x, y, intensity);
						}
					}
				}
			}
		}
	}
	if (decreasing) {
		_tmp15_ = ((gint) intensity) == 1;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		reversi_view_init_possible_moves (self);
	} else {
		guint8 _tmp16_;
		_tmp16_ = self->priv->playable_tiles_highlight_state;
		self->priv->playable_tiles_highlight_state = _tmp16_ + 1;
	}
}

static inline void
reversi_view_add_highlight (ReversiView* self,
                            cairo_t* cr,
                            guint8 x,
                            guint8 y,
                            guint8 intensity)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = self->priv->possible_moves;
	_tmp0__length1 = self->priv->possible_moves_length1;
	_tmp0__length2 = self->priv->possible_moves_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	if (_tmp1_ == FALSE) {
		return;
	}
	reversi_view_queue_draw_tile (self, x, y);
	reversi_view_highlight_tile (self, cr, x, y, intensity, TRUE);
}

static inline void
reversi_view_draw_playables (ReversiView* self,
                             cairo_t* cr)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gint* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gint _tmp7_;
							gint* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							gint _tmp9_;
							if (!_tmp2_) {
								guint8 _tmp3_;
								_tmp3_ = y;
								y = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							_tmp4_ = self->priv->pixmaps;
							_tmp4__length1 = self->priv->pixmaps_length1;
							_tmp4__length2 = self->priv->pixmaps_length2;
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
							_tmp6_ = self->priv->tile_xs;
							_tmp6__length1 = self->priv->tile_xs_length1;
							_tmp6__length2 = self->priv->tile_xs_length2;
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
							_tmp8_ = self->priv->tile_ys;
							_tmp8__length1 = self->priv->tile_ys_length1;
							_tmp8__length2 = self->priv->tile_ys_length2;
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
							reversi_view_draw_playable (self, cr, _tmp5_, _tmp7_, _tmp9_);
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_draw_playable (ReversiView* self,
                            cairo_t* cr,
                            gint pixmap,
                            gint tile_x,
                            gint tile_y)
{
	cairo_matrix_t matrix = {0};
	cairo_pattern_t* _tmp0_;
	cairo_matrix_t _tmp1_;
	cairo_pattern_t* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	if (pixmap == 0) {
		return;
	}
	cairo_matrix_init_identity (&matrix);
	cairo_matrix_translate (&matrix, (gdouble) (((pixmap % 8) * self->priv->tile_size) - tile_x), (gdouble) (((pixmap / 8) * self->priv->tile_size) - tile_y));
	_tmp0_ = self->priv->tiles_pattern;
	_tmp1_ = matrix;
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp0_, &_tmp1_);
	_tmp2_ = self->priv->tiles_pattern;
	cairo_set_source (cr, (cairo_pattern_t*) _tmp2_);
	cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) self->priv->tile_size, (gdouble) self->priv->tile_size);
	cairo_fill (cr);
}

static void
reversi_view_rounded_square (ReversiView* self,
                             cairo_t* cr,
                             gdouble x,
                             gdouble y,
                             gint size,
                             gdouble width,
                             gdouble radius_percent)
{
	gdouble radius_border = 0.0;
	gdouble radius_arc = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	if (radius_percent <= ((gdouble) 0)) {
		cairo_rectangle (cr, x + (width / 2.0), y + (width / 2.0), size + width, size + width);
		return;
	}
	if (radius_percent > ((gdouble) 50)) {
		radius_percent = (gdouble) 50;
	}
	radius_border = (radius_percent * size) / 100.0;
	radius_arc = radius_border - (width / 2.0);
	x1 = x + radius_border;
	y1 = y + radius_border;
	x2 = (x + size) - radius_border;
	y2 = (y + size) - radius_border;
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -REVERSI_VIEW_HALF_PI);
	cairo_arc (cr, x2, y1, radius_arc, -REVERSI_VIEW_HALF_PI, (gdouble) 0);
	cairo_arc (cr, x2, y2, radius_arc, (gdouble) 0, REVERSI_VIEW_HALF_PI);
	cairo_arc (cr, x1, y2, radius_arc, REVERSI_VIEW_HALF_PI, G_PI);
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -REVERSI_VIEW_HALF_PI);
}

static void
reversi_view_load_image (ReversiView* self,
                         cairo_t* c,
                         gint width,
                         gint height)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	{
		RsvgHandle* h = NULL;
		const gchar* _tmp0_;
		RsvgHandle* _tmp1_;
		cairo_matrix_t m = {0};
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		cairo_matrix_t _tmp6_;
		_tmp0_ = self->priv->pieces_file;
		_tmp1_ = rsvg_handle_new_from_file (_tmp0_, &_inner_error0_);
		h = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch10_g_error;
		}
		cairo_matrix_init_identity (&m);
		g_object_get (h, "width", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		g_object_get (h, "height", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		cairo_matrix_scale (&m, ((gdouble) width) / _tmp3_, ((gdouble) height) / _tmp5_);
		_tmp6_ = m;
		cairo_set_matrix (c, &_tmp6_);
		rsvg_handle_render_cairo (h, c);
		_g_object_unref0 (h);
		return;
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_g_error_free0 (e);
	}
	__finally10:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	{
		GdkPixbuf* p = NULL;
		const gchar* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
		_tmp7_ = self->priv->pieces_file;
		_tmp8_ = gdk_pixbuf_new_from_file_at_scale (_tmp7_, width, height, FALSE, &_inner_error0_);
		p = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch11_g_error;
		}
		_tmp9_ = p;
		gdk_cairo_set_source_pixbuf (c, _tmp9_, (gdouble) 0, (gdouble) 0);
		cairo_paint (c);
		_g_object_unref0 (p);
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp10_ = self->priv->pieces_file;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		g_warning ("reversi-view.vala:625: Failed to load theme image %s: %s", _tmp10_, _tmp12_);
		_g_error_free0 (e);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
reversi_view_highlight_tile (ReversiView* self,
                             cairo_t* cr,
                             guint8 x,
                             guint8 y,
                             guint8 intensity,
                             gboolean soft_highlight)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	if (soft_highlight) {
		cairo_set_source_rgba (cr, self->priv->highlight_soft_red, self->priv->highlight_soft_green, self->priv->highlight_soft_blue, self->priv->highlight_soft_alpha);
	} else {
		cairo_set_source_rgba (cr, self->priv->highlight_hard_red, self->priv->highlight_hard_green, self->priv->highlight_hard_blue, self->priv->highlight_hard_alpha);
	}
	_tmp0_ = self->priv->tile_xs;
	_tmp0__length1 = self->priv->tile_xs_length1;
	_tmp0__length2 = self->priv->tile_xs_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = self->priv->tile_ys;
	_tmp2__length1 = self->priv->tile_ys_length1;
	_tmp2__length2 = self->priv->tile_ys_length2;
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
	reversi_view_rounded_square (self, cr, (gdouble) (_tmp1_ + ((self->priv->tile_size * (REVERSI_VIEW_HIGHLIGHT_MAX - intensity)) / (2 * REVERSI_VIEW_HIGHLIGHT_MAX))), (gdouble) (_tmp3_ + ((self->priv->tile_size * (REVERSI_VIEW_HIGHLIGHT_MAX - intensity)) / (2 * REVERSI_VIEW_HIGHLIGHT_MAX))), (self->priv->tile_size * intensity) / REVERSI_VIEW_HIGHLIGHT_MAX, (gdouble) 0, (gdouble) self->priv->background_radius);
	cairo_fill (cr);
}

static void
reversi_view_queue_draw_tile (ReversiView* self,
                              guint8 x,
                              guint8 y)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (x < self->priv->game_size, "x < game_size");
	_vala_return_if_fail (y < self->priv->game_size, "y < game_size");
	_tmp0_ = self->priv->tile_xs;
	_tmp0__length1 = self->priv->tile_xs_length1;
	_tmp0__length2 = self->priv->tile_xs_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = self->priv->tile_ys;
	_tmp2__length1 = self->priv->tile_ys_length1;
	_tmp2__length2 = self->priv->tile_ys_length2;
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
	gtk_widget_queue_draw_area ((GtkWidget*) self, self->priv->board_x + _tmp1_, self->priv->board_y + _tmp3_, self->priv->tile_size, self->priv->tile_size);
}

static inline void
reversi_view_update_highlight_after_undo (ReversiView* self)
{
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (self->priv->last_state_set, "last_state_set");
	reversi_view_get_missing_tile (self, &_tmp0_, &_tmp1_);
	x = _tmp0_;
	y = _tmp1_;
	if (self->priv->show_highlight) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = self->priv->show_mouse_highlight;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = ((gint) self->priv->highlight_state) != 0;
	}
	if (_tmp2_) {
		Game* _tmp8_;
		Game* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		self->priv->highlight_state = (guint8) 0;
		if (self->priv->show_highlight) {
			Game* _tmp4_;
			Game* _tmp5_;
			_tmp4_ = reversi_view_get_game (self);
			_tmp5_ = _tmp4_;
			reversi_view_set_square (self, self->priv->highlight_x, self->priv->highlight_y, reversi_view_get_pixmap (game_get_owner (_tmp5_, self->priv->highlight_x, self->priv->highlight_y)), FALSE, TRUE);
		}
		if (self->priv->show_mouse_highlight) {
			Game* _tmp6_;
			Game* _tmp7_;
			_tmp6_ = reversi_view_get_game (self);
			_tmp7_ = _tmp6_;
			reversi_view_set_square (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y, reversi_view_get_pixmap (game_get_owner (_tmp7_, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y)), FALSE, TRUE);
		}
		_tmp8_ = reversi_view_get_game (self);
		_tmp9_ = _tmp8_;
		_tmp10_ = game_get_is_complete (_tmp9_);
		_tmp11_ = _tmp10_;
		if (!_tmp11_) {
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
			if (self->priv->show_highlight) {
				_tmp13_ = x == self->priv->highlight_x;
			} else {
				_tmp13_ = FALSE;
			}
			if (_tmp13_) {
				_tmp12_ = y == self->priv->highlight_y;
			} else {
				_tmp12_ = FALSE;
			}
			if (_tmp12_) {
				self->priv->highlight_state = REVERSI_VIEW_HIGHLIGHT_MAX;
			} else {
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
				if (self->priv->show_mouse_highlight) {
					_tmp15_ = x == self->priv->mouse_highlight_x;
				} else {
					_tmp15_ = FALSE;
				}
				if (_tmp15_) {
					_tmp14_ = y == self->priv->mouse_highlight_y;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					self->priv->highlight_state = REVERSI_VIEW_HIGHLIGHT_MAX;
				} else {
					self->priv->highlight_state = (guint8) 1;
				}
			}
		}
	}
	self->priv->highlight_set = TRUE;
	self->priv->highlight_x = x;
	self->priv->highlight_y = y;
	self->priv->mouse_highlight_x = x;
	self->priv->mouse_highlight_y = y;
	if (!self->priv->mouse_is_in) {
		self->priv->show_highlight = TRUE;
	} else {
		if (!self->priv->show_highlight) {
			self->priv->show_mouse_highlight = TRUE;
		}
	}
}

static void
reversi_view_get_missing_tile (ReversiView* self,
                               guint8* x,
                               guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
	g_return_if_fail (self != NULL);
	_vala_y = (guint8) 0;
	{
		gboolean _tmp0_ = FALSE;
		_vala_x = (guint8) 0;
		_tmp0_ = TRUE;
		while (TRUE) {
			if (!_tmp0_) {
				guint8 _tmp1_;
				_tmp1_ = _vala_x;
				_vala_x = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			if (!(_vala_x < self->priv->game_size)) {
				break;
			}
			{
				gboolean _tmp2_ = FALSE;
				_vala_y = (guint8) 0;
				_tmp2_ = TRUE;
				while (TRUE) {
					Game* _tmp4_;
					Game* _tmp5_;
					GameStateObject* _tmp6_;
					Game* _tmp7_;
					Game* _tmp8_;
					Player _tmp9_;
					Player _tmp10_;
					if (!_tmp2_) {
						guint8 _tmp3_;
						_tmp3_ = _vala_y;
						_vala_y = _tmp3_ + 1;
					}
					_tmp2_ = FALSE;
					if (!(_vala_y < self->priv->game_size)) {
						break;
					}
					_tmp4_ = reversi_view_get_game (self);
					_tmp5_ = _tmp4_;
					if (game_get_owner (_tmp5_, _vala_x, _vala_y) != PLAYER_NONE) {
						continue;
					}
					_tmp6_ = self->priv->last_state;
					_tmp7_ = reversi_view_get_game (self);
					_tmp8_ = _tmp7_;
					_tmp9_ = game_get_current_color (_tmp8_);
					_tmp10_ = _tmp9_;
					if (game_state_object_get_owner (_tmp6_, _vala_x, _vala_y) == _tmp10_) {
						if (x) {
							*x = _vala_x;
						}
						if (y) {
							*y = _vala_y;
						}
						return;
					}
				}
			}
		}
	}
	g_assert_not_reached ();
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
}

static void
reversi_view_turn_ended_cb (ReversiView* self,
                            gboolean undoing,
                            gboolean no_draw)
{
	Game* _tmp0_;
	Game* _tmp1_;
	GameStateObject* _tmp2_;
	GameStateObject* _tmp3_;
	GameStateObject* _tmp4_;
	g_return_if_fail (self != NULL);
	if (!no_draw) {
		reversi_view_update_squares (self);
		if (undoing) {
			reversi_view_update_highlight_after_undo (self);
		}
	}
	_tmp0_ = reversi_view_get_game (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_current_state (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (self->priv->last_state);
	self->priv->last_state = _tmp4_;
	self->priv->last_state_set = TRUE;
}

static inline void
reversi_view_update_squares (ReversiView* self)
{
	g_return_if_fail (self != NULL);
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							if (!_tmp2_) {
								guint8 _tmp3_;
								_tmp3_ = y;
								y = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							reversi_view_update_square (self, x, y);
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_update_square (ReversiView* self,
                            guint8 x,
                            guint8 y)
{
	Game* _tmp0_;
	Game* _tmp1_;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
	_tmp0_ = reversi_view_get_game (self);
	_tmp1_ = _tmp0_;
	reversi_view_set_square (self, x, y, reversi_view_get_pixmap (game_get_owner (_tmp1_, x, y)), FALSE, FALSE);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		ReversiView* self;
		self = _data7_->self;
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static gboolean
____lambda17_ (Block7Data* _data7_)
{
	ReversiView* self;
	gboolean animating = FALSE;
	gboolean result = FALSE;
	self = _data7_->self;
	animating = FALSE;
	{
		guint8 ix = 0U;
		ix = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = ix;
					ix = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(ix < self->priv->game_size)) {
					break;
				}
				{
					guint8 iy = 0U;
					iy = (guint8) 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							gint old = 0;
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							gint* _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							gint _tmp13_;
							if (!_tmp2_) {
								guint8 _tmp3_;
								_tmp3_ = iy;
								iy = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(iy < self->priv->game_size)) {
								break;
							}
							_tmp4_ = self->priv->pixmaps;
							_tmp4__length1 = self->priv->pixmaps_length1;
							_tmp4__length2 = self->priv->pixmaps_length2;
							_tmp5_ = _tmp4_[(ix * _tmp4__length2) + iy];
							old = _tmp5_;
							if (_data7_->is_final_animation) {
								_tmp7_ = self->priv->flip_final_result_now;
							} else {
								_tmp7_ = FALSE;
							}
							if (_tmp7_) {
								Game* _tmp8_;
								Game* _tmp9_;
								gboolean _tmp10_;
								gboolean _tmp11_;
								_tmp8_ = reversi_view_get_game (self);
								_tmp9_ = _tmp8_;
								_tmp10_ = game_get_is_complete (_tmp9_);
								_tmp11_ = _tmp10_;
								_tmp6_ = _tmp11_;
							} else {
								_tmp6_ = FALSE;
							}
							if (_tmp6_) {
								reversi_view_flip_final_result_tile (self, ix, iy);
							} else {
								reversi_view_update_square (self, ix, iy);
							}
							_tmp12_ = self->priv->pixmaps;
							_tmp12__length1 = self->priv->pixmaps_length1;
							_tmp12__length2 = self->priv->pixmaps_length2;
							_tmp13_ = _tmp12_[(ix * _tmp12__length2) + iy];
							if (_tmp13_ != old) {
								animating = TRUE;
							}
						}
					}
				}
			}
		}
	}
	if (animating) {
		result = G_SOURCE_CONTINUE;
		return result;
	} else {
		self->priv->animate_timeout = (guint) 0;
		if (!self->priv->show_highlight) {
			_reversi_view_on_motion (self, self->priv->mouse_position_x, self->priv->mouse_position_y, TRUE);
		}
		result = G_SOURCE_REMOVE;
		return result;
	}
}

static gboolean
_____lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda17_ (self);
	return result;
}

static void
reversi_view_set_square (ReversiView* self,
                         guint8 x,
                         guint8 y,
                         gint pixmap,
                         gboolean is_final_animation,
                         gboolean force_redraw)
{
	Block7Data* _data7_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	_data7_->is_final_animation = is_final_animation;
	if (!force_redraw) {
		gint* _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		gint _tmp2_;
		_tmp1_ = self->priv->pixmaps;
		_tmp1__length1 = self->priv->pixmaps_length1;
		_tmp1__length2 = self->priv->pixmaps_length2;
		_tmp2_ = _tmp1_[(x * _tmp1__length2) + y];
		_tmp0_ = _tmp2_ == pixmap;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		block7_data_unref (_data7_);
		_data7_ = NULL;
		return;
	}
	if (pixmap == 0) {
		_tmp3_ = TRUE;
	} else {
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		gint _tmp5_;
		_tmp4_ = self->priv->pixmaps;
		_tmp4__length1 = self->priv->pixmaps_length1;
		_tmp4__length2 = self->priv->pixmaps_length2;
		_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
		_tmp3_ = _tmp5_ == 0;
	}
	if (_tmp3_) {
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		_tmp6_ = self->priv->pixmaps;
		_tmp6__length1 = self->priv->pixmaps_length1;
		_tmp6__length2 = self->priv->pixmaps_length2;
		_tmp6_[(x * _tmp6__length2) + y] = pixmap;
	} else {
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint _tmp8_;
		_tmp7_ = self->priv->pixmaps;
		_tmp7__length1 = self->priv->pixmaps_length1;
		_tmp7__length2 = self->priv->pixmaps_length2;
		_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
		if (pixmap > _tmp8_) {
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			gint _tmp10_;
			_tmp9_ = self->priv->pixmaps;
			_tmp9__length1 = self->priv->pixmaps_length1;
			_tmp9__length2 = self->priv->pixmaps_length2;
			_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
			_tmp9_[(x * _tmp9__length2) + y] = _tmp10_ + 1;
		} else {
			gint* _tmp11_;
			gint _tmp11__length1;
			gint _tmp11__length2;
			gint _tmp12_;
			_tmp11_ = self->priv->pixmaps;
			_tmp11__length1 = self->priv->pixmaps_length1;
			_tmp11__length2 = self->priv->pixmaps_length2;
			_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
			_tmp11_[(x * _tmp11__length2) + y] = _tmp12_ - 1;
		}
		if (self->priv->animate_timeout == ((guint) 0)) {
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) REVERSI_VIEW_PIXMAP_FLIP_DELAY, _____lambda17__gsource_func, block7_data_ref (_data7_), block7_data_unref);
		}
	}
	reversi_view_queue_draw_tile (self, x, y);
	block7_data_unref (_data7_);
	_data7_ = NULL;
}

static gint
reversi_view_get_pixmap (Player color)
{
	gint result = 0;
	switch (color) {
		default:
		case PLAYER_NONE:
		{
			result = 0;
			return result;
		}
		case PLAYER_DARK:
		{
			result = 1;
			return result;
		}
		case PLAYER_LIGHT:
		{
			result = 31;
			return result;
		}
	}
}

static gboolean
___lambda16_ (ReversiView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
	_tmp0_ = reversi_view_get_game (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_is_complete (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		result = G_SOURCE_REMOVE;
		return result;
	}
	g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL], 0, FALSE);
	reversi_view_set_winner_and_loser_variables (self);
	self->priv->flip_final_result_now = TRUE;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				if (!_tmp4_) {
					guint8 _tmp5_;
					_tmp5_ = x;
					x = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							if (!_tmp6_) {
								guint8 _tmp7_;
								_tmp7_ = y;
								y = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							reversi_view_flip_final_result_tile (self, x, y);
						}
					}
				}
			}
		}
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda16__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda16_ ((ReversiView*) self);
	return result;
}

static void
reversi_view_game_is_complete_cb (ReversiView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	Game* _tmp5_;
	Game* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = reversi_view_get_game (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_is_complete (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		return;
	}
	_tmp5_ = reversi_view_get_game (self);
	_tmp6_ = _tmp5_;
	_tmp7_ = game_get_n_light_tiles (_tmp6_);
	_tmp8_ = _tmp7_;
	if (((gint) _tmp8_) == 0) {
		_tmp4_ = TRUE;
	} else {
		Game* _tmp9_;
		Game* _tmp10_;
		guint8 _tmp11_;
		guint8 _tmp12_;
		_tmp9_ = reversi_view_get_game (self);
		_tmp10_ = _tmp9_;
		_tmp11_ = game_get_n_dark_tiles (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp4_ = ((gint) _tmp12_) == 0;
	}
	if (_tmp4_) {
		return;
	}
	if (((gint) self->priv->game_size) >= 6) {
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ____lambda16__gsource_func, g_object_ref (self), g_object_unref);
	}
}

static void
reversi_view_flip_final_result_tile (ReversiView* self,
                                     guint8 x,
                                     guint8 y)
{
	gint pixmap = 0;
	guint8 n = 0U;
	g_return_if_fail (self != NULL);
	n = (y * self->priv->game_size) + x;
	if (((gint) n) < self->priv->n_winning_tiles) {
		Player _tmp0_;
		_tmp0_ = self->priv->winning_color;
		pixmap = reversi_view_get_pixmap (_tmp0_);
	} else {
		if (((gint) n) < (self->priv->n_winning_tiles + self->priv->n_losing_tiles)) {
			Player _tmp1_;
			_tmp1_ = self->priv->losing_color;
			pixmap = reversi_view_get_pixmap (_tmp1_);
		} else {
			pixmap = reversi_view_get_pixmap (PLAYER_NONE);
		}
	}
	reversi_view_set_square (self, x, y, pixmap, TRUE, FALSE);
}

static void
reversi_view_set_winner_and_loser_variables (ReversiView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = reversi_view_get_game (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_n_light_tiles (_tmp1_);
	_tmp3_ = _tmp2_;
	self->priv->n_winning_tiles = (gint) _tmp3_;
	_tmp4_ = reversi_view_get_game (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = game_get_n_dark_tiles (_tmp5_);
	_tmp7_ = _tmp6_;
	self->priv->n_losing_tiles = (gint) _tmp7_;
	if (self->priv->n_losing_tiles > self->priv->n_winning_tiles) {
		gint t = 0;
		self->priv->winning_color = PLAYER_DARK;
		self->priv->losing_color = PLAYER_LIGHT;
		t = self->priv->n_winning_tiles;
		self->priv->n_winning_tiles = self->priv->n_losing_tiles;
		self->priv->n_losing_tiles = t;
	} else {
		self->priv->winning_color = PLAYER_LIGHT;
		self->priv->losing_color = PLAYER_DARK;
	}
}

gboolean
reversi_view_undo_final_animation (ReversiView* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (!self->priv->flip_final_result_now) {
		result = FALSE;
		return result;
	}
	g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL], 0, TRUE);
	self->priv->flip_final_result_now = FALSE;
	reversi_view_update_squares (self);
	result = TRUE;
	return result;
}

static void
_reversi_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
	reversi_view_on_motion ((ReversiView*) self, _sender, x, y);
}

static void
reversi_view_init_mouse (ReversiView* self)
{
	GtkEventControllerMotion* _tmp0_;
	GtkEventControllerMotion* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ((GtkWidget*) self);
	_g_object_unref0 (self->priv->motion_controller);
	self->priv->motion_controller = _tmp0_;
	_tmp1_ = self->priv->motion_controller;
	g_signal_connect_object (_tmp1_, "motion", (GCallback) _reversi_view_on_motion_gtk_event_controller_motion_motion, self, 0);
}

static gboolean
reversi_view_real_enter_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	ReversiView * self;
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_;
	gboolean result = FALSE;
	self = (ReversiView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp2_ = reversi_view_pointer_is_in_board (self, event->x, event->y, &_tmp0_, &_tmp1_);
	x = _tmp0_;
	y = _tmp1_;
	if (_tmp2_) {
		reversi_view_on_cursor_moving_in (self, x, y);
	} else {
		if (self->priv->mouse_is_in) {
			g_assert_not_reached ();
		}
	}
	result = FALSE;
	return result;
}

static void
reversi_view_on_cursor_moving_in (ReversiView* self,
                                  guint8 x,
                                  guint8 y)
{
	g_return_if_fail (self != NULL);
	self->priv->mouse_position_x = x;
	self->priv->mouse_position_y = y;
	self->priv->mouse_position_set = TRUE;
	self->priv->mouse_is_in = TRUE;
	_reversi_view_on_motion (self, x, y, TRUE);
}

static gboolean
reversi_view_real_leave_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	ReversiView * self;
	gboolean result = FALSE;
	self = (ReversiView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	self->priv->mouse_is_in = FALSE;
	if (self->priv->mouse_position_set) {
		reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
	}
	result = FALSE;
	return result;
}

static gboolean
reversi_view_pointer_is_in_board (ReversiView* self,
                                  gdouble pos_x,
                                  gdouble pos_y,
                                  guint8* x,
                                  guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
	gint _x = 0;
	gint _y = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_x = (gint) floor ((pos_x - ((gdouble) self->priv->board_x)) / ((gdouble) self->priv->paving_size));
	_y = (gint) floor ((pos_y - ((gdouble) self->priv->board_y)) / ((gdouble) self->priv->paving_size));
	if (_x >= 0) {
		_tmp2_ = _x < ((gint) self->priv->game_size);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = _y >= 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = _y < ((gint) self->priv->game_size);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		_vala_x = (guint8) _x;
		_vala_y = (guint8) _y;
		result = TRUE;
		if (x) {
			*x = _vala_x;
		}
		if (y) {
			*y = _vala_y;
		}
		return result;
	} else {
		_vala_x = G_MAXUINT8;
		_vala_y = G_MAXUINT8;
		result = FALSE;
		if (x) {
			*x = _vala_x;
		}
		if (y) {
			*y = _vala_y;
		}
		return result;
	}
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		ReversiView* self;
		self = _data8_->self;
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static gboolean
______lambda18_ (Block8Data* _data8_)
{
	ReversiView* self;
	gboolean result = FALSE;
	self = _data8_->self;
	if (self->priv->mouse_is_in) {
		_reversi_view_on_motion (self, _data8_->x, _data8_->y, FALSE);
	}
	self->priv->timeout_id = (guint) 0;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
_______lambda18__gsource_func (gpointer self)
{
	gboolean result;
	result = ______lambda18_ (self);
	return result;
}

static void
reversi_view_on_motion (ReversiView* self,
                        GtkEventControllerMotion* _motion_controller,
                        gdouble event_x,
                        gdouble event_y)
{
	Block8Data* _data8_;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_motion_controller != NULL);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_data8_->self = g_object_ref (self);
	_tmp2_ = reversi_view_pointer_is_in_board (self, event_x, event_y, &_tmp0_, &_tmp1_);
	_data8_->x = _tmp0_;
	_data8_->y = _tmp1_;
	if (_tmp2_) {
		if (!self->priv->mouse_is_in) {
			reversi_view_on_cursor_moving_in (self, _data8_->x, _data8_->y);
		} else {
			gboolean _tmp3_ = FALSE;
			if (_data8_->x != self->priv->mouse_position_x) {
				_tmp3_ = TRUE;
			} else {
				_tmp3_ = _data8_->y != self->priv->mouse_position_y;
			}
			if (_tmp3_) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				self->priv->mouse_position_x = _data8_->x;
				self->priv->mouse_position_y = _data8_->y;
				self->priv->mouse_position_set = TRUE;
				if (self->priv->show_highlight) {
					_tmp5_ = TRUE;
				} else {
					_tmp5_ = _data8_->x != self->priv->mouse_highlight_x;
				}
				if (_tmp5_) {
					_tmp4_ = TRUE;
				} else {
					_tmp4_ = _data8_->y != self->priv->mouse_highlight_y;
				}
				if (_tmp4_) {
					if (self->priv->timeout_id != ((guint) 0)) {
						g_source_remove (self->priv->timeout_id);
						self->priv->timeout_id = (guint) 0;
					}
					self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _______lambda18__gsource_func, block8_data_ref (_data8_), block8_data_unref);
				}
			}
		}
	} else {
		self->priv->mouse_is_in = FALSE;
		self->priv->show_mouse_highlight = FALSE;
		if (self->priv->mouse_position_set) {
			reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
		}
	}
	block8_data_unref (_data8_);
	_data8_ = NULL;
}

static void
_reversi_view_on_motion (ReversiView* self,
                         guint8 x,
                         guint8 y,
                         gboolean force_redraw)
{
	gboolean _tmp0_ = FALSE;
	gboolean old_show_mouse_highlight = FALSE;
	PossibleMove move = {0};
	gboolean _tmp2_ = FALSE;
	gboolean _tmp7_ = FALSE;
	guint8 old_mouse_highlight_x = 0U;
	guint8 old_mouse_highlight_y = 0U;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	g_return_if_fail (self != NULL);
	if (!force_redraw) {
		gboolean _tmp1_ = FALSE;
		if (x != self->priv->mouse_position_x) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = y != self->priv->mouse_position_y;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	old_show_mouse_highlight = self->priv->show_mouse_highlight;
	if (self->priv->mouse_is_in) {
		Game* _tmp3_;
		Game* _tmp4_;
		PossibleMove _tmp5_ = {0};
		gboolean _tmp6_;
		_tmp3_ = reversi_view_get_game (self);
		_tmp4_ = _tmp3_;
		_tmp6_ = game_test_placing_tile (_tmp4_, x, y, &_tmp5_);
		move = _tmp5_;
		_tmp2_ = _tmp6_;
	} else {
		_tmp2_ = FALSE;
	}
	self->priv->show_mouse_highlight = _tmp2_;
	if (self->priv->show_mouse_highlight) {
		g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL], 0);
	}
	if (old_show_mouse_highlight) {
		_tmp7_ = !self->priv->show_mouse_highlight;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		self->priv->old_highlight_x = G_MAXUINT8;
		self->priv->old_highlight_y = G_MAXUINT8;
	}
	old_mouse_highlight_x = self->priv->mouse_highlight_x;
	old_mouse_highlight_y = self->priv->mouse_highlight_y;
	self->priv->mouse_highlight_x = x;
	self->priv->mouse_highlight_y = y;
	if (old_mouse_highlight_x != G_MAXUINT8) {
		_tmp8_ = old_mouse_highlight_y != G_MAXUINT8;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		reversi_view_queue_draw_tile (self, old_mouse_highlight_x, old_mouse_highlight_y);
	}
	if (self->priv->show_mouse_highlight) {
		_tmp9_ = self->priv->show_highlight;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		gboolean _tmp10_ = FALSE;
		self->priv->show_highlight = FALSE;
		if (self->priv->highlight_x != x) {
			_tmp10_ = TRUE;
		} else {
			_tmp10_ = self->priv->highlight_y != y;
		}
		if (_tmp10_) {
			reversi_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
		}
	}
	if (self->priv->show_mouse_highlight) {
		_tmp12_ = TRUE;
	} else {
		_tmp12_ = force_redraw;
	}
	if (_tmp12_) {
		gboolean _tmp13_ = FALSE;
		if (self->priv->mouse_highlight_x != G_MAXUINT8) {
			_tmp13_ = self->priv->mouse_highlight_y != G_MAXUINT8;
		} else {
			_tmp13_ = FALSE;
		}
		_tmp11_ = _tmp13_;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
	}
}

static gboolean
reversi_view_real_button_press_event (GtkWidget* base,
                                      GdkEventButton* event)
{
	ReversiView * self;
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	self = (ReversiView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (!self->priv->game_is_set) {
		result = FALSE;
		return result;
	}
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = event->button == ((guint) GDK_BUTTON_SECONDARY);
	}
	if (_tmp0_) {
		guint8 x = 0U;
		guint8 y = 0U;
		guint8 _tmp1_ = 0U;
		guint8 _tmp2_ = 0U;
		gboolean _tmp3_;
		_tmp3_ = reversi_view_pointer_is_in_board (self, event->x, event->y, &_tmp1_, &_tmp2_);
		x = _tmp1_;
		y = _tmp2_;
		if (_tmp3_) {
			self->priv->mouse_is_in = TRUE;
			self->priv->show_highlight = FALSE;
			self->priv->old_highlight_x = self->priv->highlight_x;
			self->priv->old_highlight_y = self->priv->highlight_y;
			gtk_widget_queue_draw ((GtkWidget*) self);
			self->priv->highlight_set = TRUE;
			self->priv->highlight_x = x;
			self->priv->highlight_y = y;
			reversi_view_move_if_possible (self, self->priv->highlight_x, self->priv->highlight_y);
		}
	}
	result = TRUE;
	return result;
}

static gboolean
reversi_view_real_key_press_event (GtkWidget* base,
                                   GdkEventKey* event)
{
	ReversiView * self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* key = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	GQuark _tmp65_ = 0U;
	static GQuark _tmp64_label0 = 0;
	static GQuark _tmp64_label1 = 0;
	static GQuark _tmp64_label2 = 0;
	static GQuark _tmp64_label3 = 0;
	static GQuark _tmp64_label4 = 0;
	static GQuark _tmp64_label5 = 0;
	static GQuark _tmp64_label6 = 0;
	static GQuark _tmp64_label7 = 0;
	static GQuark _tmp64_label8 = 0;
	static GQuark _tmp64_label9 = 0;
	static GQuark _tmp64_label10 = 0;
	static GQuark _tmp64_label11 = 0;
	static GQuark _tmp64_label12 = 0;
	static GQuark _tmp64_label13 = 0;
	static GQuark _tmp64_label14 = 0;
	static GQuark _tmp64_label15 = 0;
	static GQuark _tmp64_label16 = 0;
	static GQuark _tmp64_label17 = 0;
	static GQuark _tmp64_label18 = 0;
	static GQuark _tmp64_label19 = 0;
	static GQuark _tmp64_label20 = 0;
	static GQuark _tmp64_label21 = 0;
	static GQuark _tmp64_label22 = 0;
	static GQuark _tmp64_label23 = 0;
	static GQuark _tmp64_label24 = 0;
	static GQuark _tmp64_label25 = 0;
	static GQuark _tmp64_label26 = 0;
	static GQuark _tmp64_label27 = 0;
	static GQuark _tmp64_label28 = 0;
	static GQuark _tmp64_label29 = 0;
	static GQuark _tmp64_label30 = 0;
	static GQuark _tmp64_label31 = 0;
	static GQuark _tmp64_label32 = 0;
	static GQuark _tmp64_label33 = 0;
	static GQuark _tmp64_label34 = 0;
	static GQuark _tmp64_label35 = 0;
	static GQuark _tmp64_label36 = 0;
	static GQuark _tmp64_label37 = 0;
	static GQuark _tmp64_label38 = 0;
	static GQuark _tmp64_label39 = 0;
	static GQuark _tmp64_label40 = 0;
	static GQuark _tmp64_label41 = 0;
	static GQuark _tmp64_label42 = 0;
	static GQuark _tmp64_label43 = 0;
	static GQuark _tmp64_label44 = 0;
	static GQuark _tmp64_label45 = 0;
	static GQuark _tmp64_label46 = 0;
	static GQuark _tmp64_label47 = 0;
	static GQuark _tmp64_label48 = 0;
	static GQuark _tmp64_label49 = 0;
	static GQuark _tmp64_label50 = 0;
	static GQuark _tmp64_label51 = 0;
	static GQuark _tmp64_label52 = 0;
	static GQuark _tmp64_label53 = 0;
	static GQuark _tmp64_label54 = 0;
	static GQuark _tmp64_label55 = 0;
	static GQuark _tmp64_label56 = 0;
	static GQuark _tmp64_label57 = 0;
	static GQuark _tmp64_label58 = 0;
	static GQuark _tmp64_label59 = 0;
	gboolean _tmp92_ = FALSE;
	gboolean _tmp93_ = FALSE;
	const gchar* _tmp94_;
	const gchar* _tmp97_;
	gboolean _tmp98_ = FALSE;
	const gchar* _tmp99_;
	gboolean result = FALSE;
	self = (ReversiView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (!self->priv->game_is_set) {
		result = FALSE;
		return result;
	}
	_tmp1_ = gdk_keyval_name (event->keyval);
	_tmp0_ = _tmp1_;
	if (_tmp0_ == NULL) {
		_tmp0_ = "";
	}
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
	key = _tmp2_;
	if (self->priv->show_highlight) {
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		_tmp6_ = key;
		if (g_strcmp0 (_tmp6_, "space") == 0) {
			_tmp5_ = TRUE;
		} else {
			const gchar* _tmp7_;
			_tmp7_ = key;
			_tmp5_ = g_strcmp0 (_tmp7_, "Return") == 0;
		}
		if (_tmp5_) {
			_tmp4_ = TRUE;
		} else {
			const gchar* _tmp8_;
			_tmp8_ = key;
			_tmp4_ = g_strcmp0 (_tmp8_, "KP_Enter") == 0;
		}
		_tmp3_ = _tmp4_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		reversi_view_move_if_possible (self, self->priv->highlight_x, self->priv->highlight_y);
		result = TRUE;
		_g_free0 (key);
		return result;
	}
	if (((gint) self->priv->game_size) <= 4) {
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		const gchar* _tmp18_;
		_tmp18_ = key;
		if (g_strcmp0 (_tmp18_, "e") == 0) {
			_tmp17_ = TRUE;
		} else {
			const gchar* _tmp19_;
			_tmp19_ = key;
			_tmp17_ = g_strcmp0 (_tmp19_, "E") == 0;
		}
		if (_tmp17_) {
			_tmp16_ = TRUE;
		} else {
			const gchar* _tmp20_;
			_tmp20_ = key;
			_tmp16_ = g_strcmp0 (_tmp20_, "5") == 0;
		}
		if (_tmp16_) {
			_tmp15_ = TRUE;
		} else {
			const gchar* _tmp21_;
			_tmp21_ = key;
			_tmp15_ = g_strcmp0 (_tmp21_, "KP_5") == 0;
		}
		_tmp14_ = _tmp15_;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		_tmp13_ = TRUE;
	} else {
		gboolean _tmp22_ = FALSE;
		if (((gint) self->priv->game_size) <= 5) {
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
			const gchar* _tmp26_;
			_tmp26_ = key;
			if (g_strcmp0 (_tmp26_, "f") == 0) {
				_tmp25_ = TRUE;
			} else {
				const gchar* _tmp27_;
				_tmp27_ = key;
				_tmp25_ = g_strcmp0 (_tmp27_, "F") == 0;
			}
			if (_tmp25_) {
				_tmp24_ = TRUE;
			} else {
				const gchar* _tmp28_;
				_tmp28_ = key;
				_tmp24_ = g_strcmp0 (_tmp28_, "6") == 0;
			}
			if (_tmp24_) {
				_tmp23_ = TRUE;
			} else {
				const gchar* _tmp29_;
				_tmp29_ = key;
				_tmp23_ = g_strcmp0 (_tmp29_, "KP_6") == 0;
			}
			_tmp22_ = _tmp23_;
		} else {
			_tmp22_ = FALSE;
		}
		_tmp13_ = _tmp22_;
	}
	if (_tmp13_) {
		_tmp12_ = TRUE;
	} else {
		gboolean _tmp30_ = FALSE;
		if (((gint) self->priv->game_size) <= 6) {
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_ = FALSE;
			gboolean _tmp33_ = FALSE;
			const gchar* _tmp34_;
			_tmp34_ = key;
			if (g_strcmp0 (_tmp34_, "g") == 0) {
				_tmp33_ = TRUE;
			} else {
				const gchar* _tmp35_;
				_tmp35_ = key;
				_tmp33_ = g_strcmp0 (_tmp35_, "G") == 0;
			}
			if (_tmp33_) {
				_tmp32_ = TRUE;
			} else {
				const gchar* _tmp36_;
				_tmp36_ = key;
				_tmp32_ = g_strcmp0 (_tmp36_, "7") == 0;
			}
			if (_tmp32_) {
				_tmp31_ = TRUE;
			} else {
				const gchar* _tmp37_;
				_tmp37_ = key;
				_tmp31_ = g_strcmp0 (_tmp37_, "KP_7") == 0;
			}
			_tmp30_ = _tmp31_;
		} else {
			_tmp30_ = FALSE;
		}
		_tmp12_ = _tmp30_;
	}
	if (_tmp12_) {
		_tmp11_ = TRUE;
	} else {
		gboolean _tmp38_ = FALSE;
		if (((gint) self->priv->game_size) <= 7) {
			gboolean _tmp39_ = FALSE;
			gboolean _tmp40_ = FALSE;
			gboolean _tmp41_ = FALSE;
			const gchar* _tmp42_;
			_tmp42_ = key;
			if (g_strcmp0 (_tmp42_, "h") == 0) {
				_tmp41_ = TRUE;
			} else {
				const gchar* _tmp43_;
				_tmp43_ = key;
				_tmp41_ = g_strcmp0 (_tmp43_, "H") == 0;
			}
			if (_tmp41_) {
				_tmp40_ = TRUE;
			} else {
				const gchar* _tmp44_;
				_tmp44_ = key;
				_tmp40_ = g_strcmp0 (_tmp44_, "8") == 0;
			}
			if (_tmp40_) {
				_tmp39_ = TRUE;
			} else {
				const gchar* _tmp45_;
				_tmp45_ = key;
				_tmp39_ = g_strcmp0 (_tmp45_, "KP_8") == 0;
			}
			_tmp38_ = _tmp39_;
		} else {
			_tmp38_ = FALSE;
		}
		_tmp11_ = _tmp38_;
	}
	if (_tmp11_) {
		_tmp10_ = TRUE;
	} else {
		gboolean _tmp46_ = FALSE;
		if (((gint) self->priv->game_size) <= 8) {
			gboolean _tmp47_ = FALSE;
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			const gchar* _tmp50_;
			_tmp50_ = key;
			if (g_strcmp0 (_tmp50_, "i") == 0) {
				_tmp49_ = TRUE;
			} else {
				const gchar* _tmp51_;
				_tmp51_ = key;
				_tmp49_ = g_strcmp0 (_tmp51_, "I") == 0;
			}
			if (_tmp49_) {
				_tmp48_ = TRUE;
			} else {
				const gchar* _tmp52_;
				_tmp52_ = key;
				_tmp48_ = g_strcmp0 (_tmp52_, "9") == 0;
			}
			if (_tmp48_) {
				_tmp47_ = TRUE;
			} else {
				const gchar* _tmp53_;
				_tmp53_ = key;
				_tmp47_ = g_strcmp0 (_tmp53_, "KP_9") == 0;
			}
			_tmp46_ = _tmp47_;
		} else {
			_tmp46_ = FALSE;
		}
		_tmp10_ = _tmp46_;
	}
	if (_tmp10_) {
		_tmp9_ = TRUE;
	} else {
		gboolean _tmp54_ = FALSE;
		if (((gint) self->priv->game_size) <= 9) {
			gboolean _tmp55_ = FALSE;
			gboolean _tmp56_ = FALSE;
			gboolean _tmp57_ = FALSE;
			const gchar* _tmp58_;
			_tmp58_ = key;
			if (g_strcmp0 (_tmp58_, "j") == 0) {
				_tmp57_ = TRUE;
			} else {
				const gchar* _tmp59_;
				_tmp59_ = key;
				_tmp57_ = g_strcmp0 (_tmp59_, "J") == 0;
			}
			if (_tmp57_) {
				_tmp56_ = TRUE;
			} else {
				const gchar* _tmp60_;
				_tmp60_ = key;
				_tmp56_ = g_strcmp0 (_tmp60_, "0") == 0;
			}
			if (_tmp56_) {
				_tmp55_ = TRUE;
			} else {
				const gchar* _tmp61_;
				_tmp61_ = key;
				_tmp55_ = g_strcmp0 (_tmp61_, "KP_0") == 0;
			}
			_tmp54_ = _tmp55_;
		} else {
			_tmp54_ = FALSE;
		}
		_tmp9_ = _tmp54_;
	}
	if (_tmp9_) {
		result = FALSE;
		_g_free0 (key);
		return result;
	}
	self->priv->old_highlight_x = self->priv->highlight_x;
	self->priv->old_highlight_y = self->priv->highlight_y;
	_tmp62_ = key;
	_tmp63_ = _tmp62_;
	_tmp65_ = (NULL == _tmp63_) ? 0 : g_quark_from_string (_tmp63_);
	if ((_tmp65_ == ((0 != _tmp64_label0) ? _tmp64_label0 : (_tmp64_label0 = g_quark_from_static_string ("Left")))) || (_tmp65_ == ((0 != _tmp64_label1) ? _tmp64_label1 : (_tmp64_label1 = g_quark_from_static_string ("KP_Left"))))) {
		switch (0) {
			default:
			{
				gboolean _tmp66_ = FALSE;
				if (self->priv->mouse_position_set) {
					_tmp66_ = self->priv->show_mouse_highlight;
				} else {
					_tmp66_ = FALSE;
				}
				if (_tmp66_) {
					self->priv->highlight_x = self->priv->mouse_highlight_x;
					self->priv->highlight_y = self->priv->mouse_highlight_y;
				} else {
					gboolean _tmp67_ = FALSE;
					if (!self->priv->highlight_set) {
						Game* _tmp68_;
						Game* _tmp69_;
						Player _tmp70_;
						Player _tmp71_;
						_tmp68_ = reversi_view_get_game (self);
						_tmp69_ = _tmp68_;
						_tmp70_ = game_get_current_color (_tmp69_);
						_tmp71_ = _tmp70_;
						_tmp67_ = _tmp71_ == PLAYER_LIGHT;
					} else {
						_tmp67_ = FALSE;
					}
					if (_tmp67_) {
						self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
					}
				}
				if (((gint) self->priv->highlight_x) > 0) {
					guint8 _tmp72_;
					_tmp72_ = self->priv->highlight_x;
					self->priv->highlight_x = _tmp72_ - 1;
				}
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label2) ? _tmp64_label2 : (_tmp64_label2 = g_quark_from_static_string ("Right")))) || (_tmp65_ == ((0 != _tmp64_label3) ? _tmp64_label3 : (_tmp64_label3 = g_quark_from_static_string ("KP_Right"))))) {
		switch (0) {
			default:
			{
				gboolean _tmp73_ = FALSE;
				if (self->priv->mouse_position_set) {
					_tmp73_ = self->priv->show_mouse_highlight;
				} else {
					_tmp73_ = FALSE;
				}
				if (_tmp73_) {
					self->priv->highlight_x = self->priv->mouse_highlight_x;
					self->priv->highlight_y = self->priv->mouse_highlight_y;
				} else {
					if (!self->priv->highlight_set) {
						Game* _tmp74_;
						Game* _tmp75_;
						Player _tmp76_;
						Player _tmp77_;
						self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
						_tmp74_ = reversi_view_get_game (self);
						_tmp75_ = _tmp74_;
						_tmp76_ = game_get_current_color (_tmp75_);
						_tmp77_ = _tmp76_;
						if (_tmp77_ == PLAYER_DARK) {
							self->priv->highlight_y = self->priv->highlight_x;
						}
					}
				}
				if (((gint) self->priv->highlight_x) < (self->priv->game_size - 1)) {
					guint8 _tmp78_;
					_tmp78_ = self->priv->highlight_x;
					self->priv->highlight_x = _tmp78_ + 1;
				}
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label4) ? _tmp64_label4 : (_tmp64_label4 = g_quark_from_static_string ("Up")))) || (_tmp65_ == ((0 != _tmp64_label5) ? _tmp64_label5 : (_tmp64_label5 = g_quark_from_static_string ("KP_Up"))))) {
		switch (0) {
			default:
			{
				gboolean _tmp79_ = FALSE;
				if (self->priv->mouse_position_set) {
					_tmp79_ = self->priv->show_mouse_highlight;
				} else {
					_tmp79_ = FALSE;
				}
				if (_tmp79_) {
					self->priv->highlight_x = self->priv->mouse_highlight_x;
					self->priv->highlight_y = self->priv->mouse_highlight_y;
				} else {
					gboolean _tmp80_ = FALSE;
					if (!self->priv->highlight_set) {
						Game* _tmp81_;
						Game* _tmp82_;
						Player _tmp83_;
						Player _tmp84_;
						_tmp81_ = reversi_view_get_game (self);
						_tmp82_ = _tmp81_;
						_tmp83_ = game_get_current_color (_tmp82_);
						_tmp84_ = _tmp83_;
						_tmp80_ = _tmp84_ == PLAYER_LIGHT;
					} else {
						_tmp80_ = FALSE;
					}
					if (_tmp80_) {
						self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
					}
				}
				if (((gint) self->priv->highlight_y) > 0) {
					guint8 _tmp85_;
					_tmp85_ = self->priv->highlight_y;
					self->priv->highlight_y = _tmp85_ - 1;
				}
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label6) ? _tmp64_label6 : (_tmp64_label6 = g_quark_from_static_string ("Down")))) || (_tmp65_ == ((0 != _tmp64_label7) ? _tmp64_label7 : (_tmp64_label7 = g_quark_from_static_string ("KP_Down"))))) {
		switch (0) {
			default:
			{
				gboolean _tmp86_ = FALSE;
				if (self->priv->mouse_position_set) {
					_tmp86_ = self->priv->show_mouse_highlight;
				} else {
					_tmp86_ = FALSE;
				}
				if (_tmp86_) {
					self->priv->highlight_x = self->priv->mouse_highlight_x;
					self->priv->highlight_y = self->priv->mouse_highlight_y;
				} else {
					if (!self->priv->highlight_set) {
						Game* _tmp87_;
						Game* _tmp88_;
						Player _tmp89_;
						Player _tmp90_;
						self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
						_tmp87_ = reversi_view_get_game (self);
						_tmp88_ = _tmp87_;
						_tmp89_ = game_get_current_color (_tmp88_);
						_tmp90_ = _tmp89_;
						if (_tmp90_ == PLAYER_DARK) {
							self->priv->highlight_x = self->priv->highlight_y;
						}
					}
				}
				if (((gint) self->priv->highlight_y) < (self->priv->game_size - 1)) {
					guint8 _tmp91_;
					_tmp91_ = self->priv->highlight_y;
					self->priv->highlight_y = _tmp91_ + 1;
				}
				break;
			}
		}
	} else if (((_tmp65_ == ((0 != _tmp64_label8) ? _tmp64_label8 : (_tmp64_label8 = g_quark_from_static_string ("space")))) || (_tmp65_ == ((0 != _tmp64_label9) ? _tmp64_label9 : (_tmp64_label9 = g_quark_from_static_string ("Return"))))) || (_tmp65_ == ((0 != _tmp64_label10) ? _tmp64_label10 : (_tmp64_label10 = g_quark_from_static_string ("KP_Enter"))))) {
		switch (0) {
			default:
			{
				if (self->priv->show_mouse_highlight) {
					reversi_view_move_if_possible (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
					result = TRUE;
					_g_free0 (key);
					return result;
				} else {
					if (self->priv->mouse_position_set) {
						self->priv->highlight_x = self->priv->mouse_position_x;
						self->priv->highlight_y = self->priv->mouse_position_y;
					}
				}
				break;
			}
		}
	} else if (_tmp65_ == ((0 != _tmp64_label11) ? _tmp64_label11 : (_tmp64_label11 = g_quark_from_static_string ("Escape")))) {
		switch (0) {
			default:
			{
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label12) ? _tmp64_label12 : (_tmp64_label12 = g_quark_from_static_string ("a")))) || (_tmp65_ == ((0 != _tmp64_label13) ? _tmp64_label13 : (_tmp64_label13 = g_quark_from_static_string ("A"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 0;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label14) ? _tmp64_label14 : (_tmp64_label14 = g_quark_from_static_string ("b")))) || (_tmp65_ == ((0 != _tmp64_label15) ? _tmp64_label15 : (_tmp64_label15 = g_quark_from_static_string ("B"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 1;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label16) ? _tmp64_label16 : (_tmp64_label16 = g_quark_from_static_string ("c")))) || (_tmp65_ == ((0 != _tmp64_label17) ? _tmp64_label17 : (_tmp64_label17 = g_quark_from_static_string ("C"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 2;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label18) ? _tmp64_label18 : (_tmp64_label18 = g_quark_from_static_string ("d")))) || (_tmp65_ == ((0 != _tmp64_label19) ? _tmp64_label19 : (_tmp64_label19 = g_quark_from_static_string ("D"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 3;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label20) ? _tmp64_label20 : (_tmp64_label20 = g_quark_from_static_string ("e")))) || (_tmp65_ == ((0 != _tmp64_label21) ? _tmp64_label21 : (_tmp64_label21 = g_quark_from_static_string ("E"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 4;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label22) ? _tmp64_label22 : (_tmp64_label22 = g_quark_from_static_string ("f")))) || (_tmp65_ == ((0 != _tmp64_label23) ? _tmp64_label23 : (_tmp64_label23 = g_quark_from_static_string ("F"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 5;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label24) ? _tmp64_label24 : (_tmp64_label24 = g_quark_from_static_string ("g")))) || (_tmp65_ == ((0 != _tmp64_label25) ? _tmp64_label25 : (_tmp64_label25 = g_quark_from_static_string ("G"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 6;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label26) ? _tmp64_label26 : (_tmp64_label26 = g_quark_from_static_string ("h")))) || (_tmp65_ == ((0 != _tmp64_label27) ? _tmp64_label27 : (_tmp64_label27 = g_quark_from_static_string ("H"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 7;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label28) ? _tmp64_label28 : (_tmp64_label28 = g_quark_from_static_string ("i")))) || (_tmp65_ == ((0 != _tmp64_label29) ? _tmp64_label29 : (_tmp64_label29 = g_quark_from_static_string ("I"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 8;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label30) ? _tmp64_label30 : (_tmp64_label30 = g_quark_from_static_string ("j")))) || (_tmp65_ == ((0 != _tmp64_label31) ? _tmp64_label31 : (_tmp64_label31 = g_quark_from_static_string ("J"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 9;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label32) ? _tmp64_label32 : (_tmp64_label32 = g_quark_from_static_string ("1")))) || (_tmp65_ == ((0 != _tmp64_label33) ? _tmp64_label33 : (_tmp64_label33 = g_quark_from_static_string ("KP_1"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 0;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label34) ? _tmp64_label34 : (_tmp64_label34 = g_quark_from_static_string ("2")))) || (_tmp65_ == ((0 != _tmp64_label35) ? _tmp64_label35 : (_tmp64_label35 = g_quark_from_static_string ("KP_2"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 1;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label36) ? _tmp64_label36 : (_tmp64_label36 = g_quark_from_static_string ("3")))) || (_tmp65_ == ((0 != _tmp64_label37) ? _tmp64_label37 : (_tmp64_label37 = g_quark_from_static_string ("KP_3"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 2;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label38) ? _tmp64_label38 : (_tmp64_label38 = g_quark_from_static_string ("4")))) || (_tmp65_ == ((0 != _tmp64_label39) ? _tmp64_label39 : (_tmp64_label39 = g_quark_from_static_string ("KP_4"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 3;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label40) ? _tmp64_label40 : (_tmp64_label40 = g_quark_from_static_string ("5")))) || (_tmp65_ == ((0 != _tmp64_label41) ? _tmp64_label41 : (_tmp64_label41 = g_quark_from_static_string ("KP_5"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 4;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label42) ? _tmp64_label42 : (_tmp64_label42 = g_quark_from_static_string ("6")))) || (_tmp65_ == ((0 != _tmp64_label43) ? _tmp64_label43 : (_tmp64_label43 = g_quark_from_static_string ("KP_6"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 5;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label44) ? _tmp64_label44 : (_tmp64_label44 = g_quark_from_static_string ("7")))) || (_tmp65_ == ((0 != _tmp64_label45) ? _tmp64_label45 : (_tmp64_label45 = g_quark_from_static_string ("KP_7"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 6;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label46) ? _tmp64_label46 : (_tmp64_label46 = g_quark_from_static_string ("8")))) || (_tmp65_ == ((0 != _tmp64_label47) ? _tmp64_label47 : (_tmp64_label47 = g_quark_from_static_string ("KP_8"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 7;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label48) ? _tmp64_label48 : (_tmp64_label48 = g_quark_from_static_string ("9")))) || (_tmp65_ == ((0 != _tmp64_label49) ? _tmp64_label49 : (_tmp64_label49 = g_quark_from_static_string ("KP_9"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 8;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label50) ? _tmp64_label50 : (_tmp64_label50 = g_quark_from_static_string ("0")))) || (_tmp65_ == ((0 != _tmp64_label51) ? _tmp64_label51 : (_tmp64_label51 = g_quark_from_static_string ("KP_0"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 9;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label52) ? _tmp64_label52 : (_tmp64_label52 = g_quark_from_static_string ("Home")))) || (_tmp65_ == ((0 != _tmp64_label53) ? _tmp64_label53 : (_tmp64_label53 = g_quark_from_static_string ("KP_Home"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 0;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label54) ? _tmp64_label54 : (_tmp64_label54 = g_quark_from_static_string ("End")))) || (_tmp65_ == ((0 != _tmp64_label55) ? _tmp64_label55 : (_tmp64_label55 = g_quark_from_static_string ("KP_End"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) (self->priv->game_size - 1);
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label56) ? _tmp64_label56 : (_tmp64_label56 = g_quark_from_static_string ("Page_Up")))) || (_tmp65_ == ((0 != _tmp64_label57) ? _tmp64_label57 : (_tmp64_label57 = g_quark_from_static_string ("KP_Page_Up"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 0;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label58) ? _tmp64_label58 : (_tmp64_label58 = g_quark_from_static_string ("Page_Down")))) || (_tmp65_ == ((0 != _tmp64_label59) ? _tmp64_label59 : (_tmp64_label59 = g_quark_from_static_string ("KP_Next"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) (self->priv->game_size - 1);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				result = FALSE;
				_g_free0 (key);
				return result;
			}
		}
	}
	self->priv->highlight_set = TRUE;
	_tmp94_ = key;
	if (g_strcmp0 (_tmp94_, "space") != 0) {
		const gchar* _tmp95_;
		_tmp95_ = key;
		_tmp93_ = g_strcmp0 (_tmp95_, "Return") != 0;
	} else {
		_tmp93_ = FALSE;
	}
	if (_tmp93_) {
		const gchar* _tmp96_;
		_tmp96_ = key;
		_tmp92_ = g_strcmp0 (_tmp96_, "KP_Enter") != 0;
	} else {
		_tmp92_ = FALSE;
	}
	if (_tmp92_) {
		g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL], 0);
	}
	_tmp97_ = key;
	if (g_strcmp0 (_tmp97_, "Escape") == 0) {
		self->priv->show_highlight = FALSE;
	} else {
		if (self->priv->show_highlight) {
			self->priv->highlight_state = REVERSI_VIEW_HIGHLIGHT_MAX;
		} else {
			self->priv->show_highlight = TRUE;
		}
	}
	reversi_view_queue_draw_tile (self, self->priv->old_highlight_x, self->priv->old_highlight_y);
	if (self->priv->old_highlight_x != self->priv->highlight_x) {
		_tmp98_ = TRUE;
	} else {
		_tmp98_ = self->priv->old_highlight_y != self->priv->highlight_y;
	}
	if (_tmp98_) {
		reversi_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
	}
	_tmp99_ = key;
	if (g_strcmp0 (_tmp99_, "Escape") != 0) {
		self->priv->show_mouse_highlight = FALSE;
		if (self->priv->mouse_position_set) {
			reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
		}
	} else {
		gboolean _tmp100_ = FALSE;
		if (self->priv->mouse_position_set) {
			_tmp100_ = self->priv->mouse_is_in;
		} else {
			_tmp100_ = FALSE;
		}
		if (_tmp100_) {
			self->priv->highlight_x = self->priv->mouse_position_x;
			self->priv->highlight_y = self->priv->mouse_position_y;
			_reversi_view_on_motion (self, self->priv->highlight_x, self->priv->highlight_y, TRUE);
		}
	}
	result = TRUE;
	_g_free0 (key);
	return result;
}

static void
reversi_view_init_possible_moves (ReversiView* self)
{
	gboolean* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->playable_tiles_highlight_state = (guint8) 0;
	_tmp0_ = g_new0 (gboolean, self->priv->game_size * self->priv->game_size);
	self->priv->possible_moves = (g_free (self->priv->possible_moves), NULL);
	self->priv->possible_moves = _tmp0_;
	self->priv->possible_moves_length1 = self->priv->game_size;
	self->priv->possible_moves_length2 = self->priv->game_size;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							gboolean* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							if (!_tmp3_) {
								guint8 _tmp4_;
								_tmp4_ = y;
								y = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							_tmp5_ = self->priv->possible_moves;
							_tmp5__length1 = self->priv->possible_moves_length1;
							_tmp5__length2 = self->priv->possible_moves_length2;
							_tmp5_[(x * _tmp5__length2) + y] = FALSE;
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_move_if_possible (ReversiView* self,
                               guint8 x,
                               guint8 y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Iagno* _tmp2_;
	ComputerPlayer* _tmp3_;
	ComputerPlayer* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp2_ = self->priv->iagno_instance;
	_tmp3_ = iagno_get_computer (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		Iagno* _tmp5_;
		Player _tmp6_;
		Player _tmp7_;
		Game* _tmp8_;
		Game* _tmp9_;
		Player _tmp10_;
		Player _tmp11_;
		_tmp5_ = self->priv->iagno_instance;
		_tmp6_ = iagno_get_player_one (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = reversi_view_get_game (self);
		_tmp9_ = _tmp8_;
		_tmp10_ = game_get_current_color (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp1_ = _tmp7_ == _tmp11_;
	}
	if (_tmp1_) {
		Game* _tmp12_;
		Game* _tmp13_;
		_tmp12_ = reversi_view_get_game (self);
		_tmp13_ = _tmp12_;
		_tmp0_ = game_get_owner (_tmp13_, x, y) != PLAYER_NONE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		reversi_view_highlight_playable_tiles (self);
	} else {
		g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_MOVE_SIGNAL], 0, x, y);
	}
}

static void
_possible_move_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (possible_move_free (var), NULL));
}

static inline void
_g_slist_free__possible_move_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _possible_move_free0_);
}

static void
__lambda19_ (ReversiView* self,
             PossibleMove* move)
{
	guint8 x = 0U;
	guint8 y = 0U;
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	x = ((PossibleMove) (*move)).x;
	y = ((PossibleMove) (*move)).y;
	_tmp0_ = self->priv->possible_moves;
	_tmp0__length1 = self->priv->possible_moves_length1;
	_tmp0__length2 = self->priv->possible_moves_length2;
	_tmp0_[(x * _tmp0__length2) + y] = TRUE;
	reversi_view_queue_draw_tile (self, x, y);
}

static void
___lambda19__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda19_ ((ReversiView*) self, (PossibleMove*) data);
}

static inline void
reversi_view_highlight_playable_tiles (ReversiView* self)
{
	GSList* moves = NULL;
	Game* _tmp0_;
	Game* _tmp1_;
	GSList* _tmp2_ = NULL;
	GSList* _tmp3_;
	g_return_if_fail (self != NULL);
	if (((gint) self->priv->playable_tiles_highlight_state) != 0) {
		return;
	}
	_tmp0_ = reversi_view_get_game (self);
	_tmp1_ = _tmp0_;
	game_get_possible_moves (_tmp1_, &_tmp2_);
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
	moves = _tmp2_;
	self->priv->playable_tiles_highlight_state = (guint8) 1;
	_tmp3_ = moves;
	g_slist_foreach (_tmp3_, ___lambda19__gfunc, self);
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
}

static gboolean
reversi_view_get_show_turnable_tiles (ReversiView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_turnable_tiles;
	return result;
}

void
reversi_view_set_show_turnable_tiles (ReversiView* self,
                                      gboolean value)
{
	g_return_if_fail (self != NULL);
	if (reversi_view_get_show_turnable_tiles (self) != value) {
		self->priv->_show_turnable_tiles = value;
		g_object_notify_by_pspec ((GObject *) self, reversi_view_properties[REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY]);
	}
}

const gchar*
reversi_view_get_sound_flip (ReversiView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_sound_flip;
	result = _tmp0_;
	return result;
}

static void
reversi_view_set_sound_flip (ReversiView* self,
                             const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_sound_flip);
	self->priv->_sound_flip = _tmp0_;
}

const gchar*
reversi_view_get_sound_gameover (ReversiView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_sound_gameover;
	result = _tmp0_;
	return result;
}

static void
reversi_view_set_sound_gameover (ReversiView* self,
                                 const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_sound_gameover);
	self->priv->_sound_gameover = _tmp0_;
}

Game*
reversi_view_get_game (ReversiView* self)
{
	Game* result;
	Game* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	if (!self->priv->game_is_set) {
		g_assert_not_reached ();
	}
	_tmp0_ = self->priv->_game;
	result = _tmp0_;
	return result;
}

static void
_reversi_view_game_is_complete_cb_game_completeness_updated (Game* _sender,
                                                             gboolean completeness,
                                                             gpointer self)
{
	reversi_view_game_is_complete_cb ((ReversiView*) self);
}

static void
_reversi_view_turn_ended_cb_game_turn_ended (Game* _sender,
                                             gboolean undoing,
                                             gboolean no_draw,
                                             gpointer self)
{
	reversi_view_turn_ended_cb ((ReversiView*) self, undoing, no_draw);
}

void
reversi_view_set_game (ReversiView* self,
                       Game* value)
{
	Game* test = NULL;
	Game* _tmp0_;
	Game* _tmp2_;
	Game* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gint* _tmp6_;
	gint* _tmp7_;
	gint* _tmp8_;
	Game* _tmp15_;
	Game* _tmp16_;
	gboolean odd_game = FALSE;
	gboolean _tmp17_ = FALSE;
	Game* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	guint8 _tmp21_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	test = _tmp0_;
	if (test == NULL) {
		g_assert_not_reached ();
	}
	if (self->priv->game_is_set) {
		Game* _tmp1_;
		_tmp1_ = self->priv->_game;
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
	}
	_tmp2_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_game);
	self->priv->_game = _tmp2_;
	self->priv->game_is_set = TRUE;
	_tmp3_ = self->priv->_game;
	_tmp4_ = game_get_size (_tmp3_);
	_tmp5_ = _tmp4_;
	self->priv->game_size = _tmp5_;
	_tmp6_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
	self->priv->pixmaps = _tmp6_;
	self->priv->pixmaps_length1 = self->priv->game_size;
	self->priv->pixmaps_length2 = self->priv->game_size;
	_tmp7_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
	self->priv->tile_xs = (g_free (self->priv->tile_xs), NULL);
	self->priv->tile_xs = _tmp7_;
	self->priv->tile_xs_length1 = self->priv->game_size;
	self->priv->tile_xs_length2 = self->priv->game_size;
	_tmp8_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
	self->priv->tile_ys = (g_free (self->priv->tile_ys), NULL);
	self->priv->tile_ys = _tmp8_;
	self->priv->tile_ys_length1 = self->priv->game_size;
	self->priv->tile_ys_length2 = self->priv->game_size;
	reversi_view_init_possible_moves (self);
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				if (!_tmp9_) {
					guint8 _tmp10_;
					_tmp10_ = x;
					x = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp11_ = FALSE;
						_tmp11_ = TRUE;
						while (TRUE) {
							gint* _tmp13_;
							gint _tmp13__length1;
							gint _tmp13__length2;
							Game* _tmp14_;
							if (!_tmp11_) {
								guint8 _tmp12_;
								_tmp12_ = y;
								y = _tmp12_ + 1;
							}
							_tmp11_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							_tmp13_ = self->priv->pixmaps;
							_tmp13__length1 = self->priv->pixmaps_length1;
							_tmp13__length2 = self->priv->pixmaps_length2;
							_tmp14_ = self->priv->_game;
							_tmp13_[(x * _tmp13__length2) + y] = reversi_view_get_pixmap (game_get_owner (_tmp14_, x, y));
						}
					}
				}
			}
		}
	}
	_tmp15_ = self->priv->_game;
	g_signal_connect_object (_tmp15_, "completeness-updated", (GCallback) _reversi_view_game_is_complete_cb_game_completeness_updated, self, 0);
	_tmp16_ = self->priv->_game;
	g_signal_connect_object (_tmp16_, "turn-ended", (GCallback) _reversi_view_turn_ended_cb_game_turn_ended, self, 0);
	self->priv->show_highlight = FALSE;
	odd_game = (self->priv->game_size % 2) != 0;
	_tmp18_ = self->priv->_game;
	_tmp19_ = game_get_alternative_start (_tmp18_);
	_tmp20_ = _tmp19_;
	if (_tmp20_) {
		_tmp17_ = TRUE;
	} else {
		_tmp17_ = odd_game;
	}
	self->priv->highlight_set = _tmp17_;
	if (odd_game) {
		_tmp21_ = (guint8) (self->priv->game_size / 2);
	} else {
		_tmp21_ = (guint8) ((self->priv->game_size / 2) - 1);
	}
	self->priv->highlight_x = _tmp21_;
	self->priv->highlight_y = self->priv->highlight_x;
	self->priv->highlight_state = (guint8) 0;
	gtk_widget_queue_draw ((GtkWidget*) self);
	_g_object_unref0 (test);
}

const gchar*
reversi_view_get_theme (ReversiView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_theme;
	result = _tmp0_;
	return result;
}

void
reversi_view_set_theme (ReversiView* self,
                        const gchar* value)
{
	GKeyFile* key = NULL;
	GKeyFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp15_;
	gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_key_file_new ();
	key = _tmp0_;
	if (value == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = g_strcmp0 ((const gchar*) value, "default") == 0;
	}
	if (_tmp1_) {
		reversi_view_set_default_theme (self, &key);
	} else {
		{
			gchar* key_path = NULL;
			gchar* _tmp2_;
			gchar* filepath = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gboolean _tmp9_;
			GKeyFile* _tmp11_;
			const gchar* _tmp12_;
			_tmp2_ = g_build_filename (DATA_DIRECTORY, "themes", "key", NULL);
			key_path = _tmp2_;
			_tmp3_ = key_path;
			_tmp4_ = g_build_filename (_tmp3_, (const gchar*) value, NULL);
			filepath = _tmp4_;
			_tmp5_ = filepath;
			_tmp6_ = g_path_get_dirname (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp8_ = key_path;
			_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
			_g_free0 (_tmp7_);
			if (_tmp9_) {
				GError* _tmp10_;
				_tmp10_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, "Theme file is not in the \"key\" directory.");
				_inner_error0_ = _tmp10_;
				_g_free0 (filepath);
				_g_free0 (key_path);
				goto __catch12_g_error;
			}
			_tmp11_ = key;
			_tmp12_ = filepath;
			g_key_file_load_from_file (_tmp11_, _tmp12_, G_KEY_FILE_NONE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (filepath);
				_g_free0 (key_path);
				goto __catch12_g_error;
			}
			_g_free0 (filepath);
			_g_free0 (key_path);
		}
		goto __finally12;
		__catch12_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp13_ = e;
			_tmp14_ = _tmp13_->message;
			g_warning ("reversi-view.vala:202: Failed to load theme: %s", _tmp14_);
			reversi_view_set_default_theme (self, &key);
			value = "default";
			_g_error_free0 (e);
		}
		__finally12:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_key_file_unref0 (key);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp15_ = key;
	reversi_view_load_theme (self, _tmp15_);
	_tmp16_ = g_strdup (value);
	_g_free0 (self->priv->_theme);
	self->priv->_theme = _tmp16_;
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
	self->priv->tiles_pattern = NULL;
	gtk_widget_queue_draw ((GtkWidget*) self);
	_g_key_file_unref0 (key);
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
}

static GObject *
reversi_view_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ReversiView * self;
	parent_class = G_OBJECT_CLASS (reversi_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REVERSI_VIEW, ReversiView);
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_events ((GtkWidget*) self, (gint) (((((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_POINTER_MOTION_MASK) | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK));
	reversi_view_init_mouse (self);
	return obj;
}

static void
reversi_view_class_init (ReversiViewClass * klass,
                         gpointer klass_data)
{
	reversi_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ReversiView_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) reversi_view_real_draw;
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) reversi_view_real_enter_notify_event;
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) reversi_view_real_leave_notify_event;
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) reversi_view_real_button_press_event;
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) reversi_view_real_key_press_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_reversi_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_reversi_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = reversi_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = reversi_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY, reversi_view_properties[REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY] = g_param_spec_boolean ("show-turnable-tiles", "show-turnable-tiles", "show-turnable-tiles", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_SOUND_FLIP_PROPERTY, reversi_view_properties[REVERSI_VIEW_SOUND_FLIP_PROPERTY] = g_param_spec_string ("sound-flip", "sound-flip", "sound-flip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY, reversi_view_properties[REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY] = g_param_spec_string ("sound-gameover", "sound-gameover", "sound-gameover", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_GAME_PROPERTY, reversi_view_properties[REVERSI_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_THEME_PROPERTY, reversi_view_properties[REVERSI_VIEW_THEME_PROPERTY] = g_param_spec_string ("theme", "theme", "theme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
	reversi_view_signals[REVERSI_VIEW_MOVE_SIGNAL] = g_signal_new ("move", TYPE_REVERSI_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
	reversi_view_signals[REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL] = g_signal_new ("clear-impossible-to-move-here-warning", TYPE_REVERSI_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	reversi_view_signals[REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL] = g_signal_new ("notify-final-animation", TYPE_REVERSI_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
reversi_view_instance_init (ReversiView * self,
                            gpointer klass)
{
	self->priv = reversi_view_get_instance_private (self);
	self->priv->_show_turnable_tiles = FALSE;
	self->priv->background_red = 0.2;
	self->priv->background_green = 0.6;
	self->priv->background_blue = 0.4;
	self->priv->background_radius = 0;
	self->priv->texture_alpha = 0.25;
	self->priv->apply_texture = FALSE;
	self->priv->mark_red = 0.2;
	self->priv->mark_green = 0.6;
	self->priv->mark_blue = 0.4;
	self->priv->mark_width = 2;
	self->priv->border_red = 0.1;
	self->priv->border_green = 0.1;
	self->priv->border_blue = 0.1;
	self->priv->border_width = 3;
	self->priv->half_border_width = 1.5;
	self->priv->spacing_red = 0.1;
	self->priv->spacing_green = 0.3;
	self->priv->spacing_blue = 0.2;
	self->priv->spacing_width = 2;
	self->priv->highlight_hard_red = 0.1;
	self->priv->highlight_hard_green = 0.3;
	self->priv->highlight_hard_blue = 0.2;
	self->priv->highlight_hard_alpha = 0.4;
	self->priv->highlight_soft_red = 0.1;
	self->priv->highlight_soft_green = 0.3;
	self->priv->highlight_soft_blue = 0.2;
	self->priv->highlight_soft_alpha = 0.2;
	self->priv->show_highlight = FALSE;
	self->priv->highlight_set = FALSE;
	self->priv->highlight_x = G_MAXUINT8;
	self->priv->highlight_y = G_MAXUINT8;
	self->priv->old_highlight_x = G_MAXUINT8;
	self->priv->old_highlight_y = G_MAXUINT8;
	self->priv->highlight_state = (guint8) 0;
	self->priv->show_mouse_highlight = FALSE;
	self->priv->mouse_position_set = FALSE;
	self->priv->mouse_highlight_x = G_MAXUINT8;
	self->priv->mouse_highlight_y = G_MAXUINT8;
	self->priv->mouse_position_x = G_MAXUINT8;
	self->priv->mouse_position_y = G_MAXUINT8;
	self->priv->render_size = (guint) 0;
	self->priv->tiles_pattern = NULL;
	self->priv->board_pattern = NULL;
	self->priv->noise_pixbuf_loaded = FALSE;
	self->priv->animate_timeout = (guint) 0;
	self->priv->game_is_set = FALSE;
	self->priv->_theme = NULL;
	self->priv->last_state_set = FALSE;
	self->priv->flip_final_result_now = FALSE;
	self->priv->mouse_is_in = FALSE;
	self->priv->timeout_id = (guint) 0;
}

static void
reversi_view_finalize (GObject * obj)
{
	ReversiView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REVERSI_VIEW, ReversiView);
	_g_free0 (self->priv->pieces_file);
	_g_free0 (self->priv->_sound_flip);
	_g_free0 (self->priv->_sound_gameover);
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
	_cairo_pattern_destroy0 (self->priv->board_pattern);
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
	_g_object_unref0 (self->priv->_game);
	_g_object_unref0 (self->priv->iagno_instance);
	_g_free0 (self->priv->_theme);
	self->priv->tile_xs = (g_free (self->priv->tile_xs), NULL);
	self->priv->tile_ys = (g_free (self->priv->tile_ys), NULL);
	_g_object_unref0 (self->priv->last_state);
	_g_object_unref0 (self->priv->motion_controller);
	self->priv->possible_moves = (g_free (self->priv->possible_moves), NULL);
	G_OBJECT_CLASS (reversi_view_parent_class)->finalize (obj);
}

GType
reversi_view_get_type (void)
{
	static volatile gsize reversi_view_type_id__volatile = 0;
	if (g_once_init_enter (&reversi_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ReversiViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) reversi_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ReversiView), 0, (GInstanceInitFunc) reversi_view_instance_init, NULL };
		GType reversi_view_type_id;
		reversi_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ReversiView", &g_define_type_info, 0);
		ReversiView_private_offset = g_type_add_instance_private (reversi_view_type_id, sizeof (ReversiViewPrivate));
		g_once_init_leave (&reversi_view_type_id__volatile, reversi_view_type_id);
	}
	return reversi_view_type_id__volatile;
}

static void
_vala_reversi_view_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ReversiView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_REVERSI_VIEW, ReversiView);
	switch (property_id) {
		case REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY:
		g_value_set_boolean (value, reversi_view_get_show_turnable_tiles (self));
		break;
		case REVERSI_VIEW_SOUND_FLIP_PROPERTY:
		g_value_set_string (value, reversi_view_get_sound_flip (self));
		break;
		case REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY:
		g_value_set_string (value, reversi_view_get_sound_gameover (self));
		break;
		case REVERSI_VIEW_GAME_PROPERTY:
		g_value_set_object (value, reversi_view_get_game (self));
		break;
		case REVERSI_VIEW_THEME_PROPERTY:
		g_value_set_string (value, reversi_view_get_theme (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_reversi_view_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ReversiView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_REVERSI_VIEW, ReversiView);
	switch (property_id) {
		case REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY:
		reversi_view_set_show_turnable_tiles (self, g_value_get_boolean (value));
		break;
		case REVERSI_VIEW_SOUND_FLIP_PROPERTY:
		reversi_view_set_sound_flip (self, g_value_get_string (value));
		break;
		case REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY:
		reversi_view_set_sound_gameover (self, g_value_get_string (value));
		break;
		case REVERSI_VIEW_GAME_PROPERTY:
		reversi_view_set_game (self, g_value_get_object (value));
		break;
		case REVERSI_VIEW_THEME_PROPERTY:
		reversi_view_set_theme (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

